var sape = sape || {};
sape.toolbar = sape.toolbar || {};

Components.utils['import']("resource://gre/modules/Services.jsm");

sape.toolbar.prefs = function()
{
    if (!sape.toolbar.hasOwnProperty('myPrefs'))
    {
        sape.toolbar.myPrefs = Services.prefs.getBranch("extensions.wmsape.");
    }
    return sape.toolbar.myPrefs;
};

sape.toolbar.str = function(name)
{
    if (!sape.toolbar.hasOwnProperty('stringsBundle'))
    {
        sape.toolbar.stringsBundle = Services.strings.createBundle("chrome://wmsape/locale/wmsape.properties?" + Math.random());
    }
    try
    {
        var s = sape.toolbar.stringsBundle.GetStringFromName(name);
    }
    catch(e)
    {
        return "";
    }
    return s;
};

//------------------------------------------------------------------------------
// Служебные таймеры
//------------------------------------------------------------------------------

sape.toolbar.waitTimer = function(callback, timeout)
{
    var waitTimer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
        waitTimer.initWithCallback({notify: function(timer){callback(timer);}}, timeout, Components.interfaces.nsITimer.TYPE_ONE_SHOT);

    return waitTimer;
};

sape.toolbar.setTimer = function(callback, timeout)
{
    if (!sape.toolbar.hasOwnProperty('waitTimers')) sape.toolbar.waitTimers = new Array();

    var waitTimer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
        waitTimer.initWithCallback(
        {
            notify: function(timer)
            {
                var idx = sape.toolbar.waitTimers.indexOf(timer);
                if (idx > -1) sape.toolbar.waitTimers.splice(idx, 1);
                if (callback) callback();
            }
        }, timeout, Components.interfaces.nsITimer.TYPE_ONE_SHOT);

        sape.toolbar.waitTimers.push(waitTimer);
};

//------------------------------------------------------------------------------
// Текущая локация
//------------------------------------------------------------------------------

sape.toolbar.inside = function(doc)
{
    return sape.toolbar.sape(doc);
};

sape.toolbar.sape = function(doc)
{
    if (doc && doc.location)
    {
        if (doc.location.hostname)
        {
            return doc.location.hostname.match(/^((www|articles).sape.ru)|(wmsape)$/i);
        }
        if (doc.location.href)
        {
            return doc.location.href.match(/[\/]{2}(((www|articles).sape.ru)|(wmsape))/i);
        }
    }
    return false;
};

sape.toolbar.getDocument = function()
{
    var contentWindow = window.content ? window.content : window.getBrowser().selectedBrowser.contentWindowAsCPOW;
    return contentWindow.document;
};

sape.toolbar.initDOM = function()
{
    return sape.toolbar.getDocument().body.offsetWidth;
};

sape.toolbar.urlEncode = function(url)
{
    return encodeURIComponent(url).replace(/\+/g, '%2B').replace(/[\/]/g, '%2F');
};

sape.toolbar.safeEncode = function(url)
{
    return encodeURIComponent(url).replace(/%25(D[0-1]{1})%25([0-9A-F]{2})/ig, "%$1%$2").replace(/\+/g, "%2B").replace(/[\/]{1}/g, "%2F");
};

sape.toolbar.urlCheck = function(url)
{
   return !(!url || typeof(url) == 'undefined' || !url.match(/^https?\:/i));
};

sape.toolbar.getCheckbox = function(cell)
{
    var boxCheck = function(box)
    {
        return !(!box || box.hasAttribute("onclick") || box.id.match(/check_all|chk_all|aSelectAll/));
    };
    var checkbox = cell.querySelector('input[type="checkbox"]');
    return boxCheck(checkbox)? checkbox : null;
};

sape.toolbar.parseDate = function(text)
{
    var dateText = (text instanceof HTMLTableCellElement)? text.innerHTML : text;
        dateText = dateText.match(/([0-9]+)\.([0-9]+)\.([0-9]+)/);

    if (dateText && dateText.length > 3)
    {
        var dd = parseInt(dateText[1], 10);
        var mm = parseInt(dateText[2], 10)-1;
        var yy = parseInt(dateText[3], 10);
        if (yy < 2000) yy += 2000;

        return new Date(yy,mm,dd);
    }
    return 0;
};


//------------------------------------------------------------------------------
// Поиск селекта с опциями отказа от заявок
//------------------------------------------------------------------------------

sape.toolbar.changeSelect = function(doc, values)
{
    var select = doc.querySelector('select[name="requests_action"], select[name="act"]');
    if (select && select.options)
    {
        for (var v = values.split(','), i=0; i < v.length; i++)
        {
            var option = select.querySelector('option[value="' + v[i] + '"]');
            if (option)
            {
                option.selected = true;
            }
        }
        var evt = doc.createEvent("HTMLEvents");
            evt.initEvent("change", true, true);

        select.dispatchEvent(evt);
    }
};

sape.toolbar.resetSelect = function(doc)
{
    var select = doc.querySelector('select[name="requests_action"], select[name="act"]');
    if (select && select.options)
    {
        select.options[0].selected = true;

        var evt = doc.createEvent("HTMLEvents");
            evt.initEvent("change", true, true);

        select.dispatchEvent(evt);
    }
};

//------------------------------------------------------------------------------
// Возвращает кодировку страницы из мета-тегов
//------------------------------------------------------------------------------

sape.toolbar.getCharset = function(text)
{
    var em = /<meta [^>]+>/ig;
    var ec  = /charset\=([-0-9a-z]+)/i;
    var ec1 = /charset\=[\"\']?([-0-9a-z]+)[\"\']?/i;

    var meta, ch; em.lastIndex = 0;
    while ((meta = em.exec(text)) !== null)
    {
        if ((ch = ec.exec(meta[0])) !== null)
        {
            if (sape.toolbar.validCharset(ch[1].toLowerCase())) return ch[1].toLowerCase();
        }
        if ((ch = ec1.exec(meta[0])) !== null)
        {
            if (sape.toolbar.validCharset(ch[1].toLowerCase())) return ch[1].toLowerCase();
        }
    }
    if (text.match(/[\u0430-\u044F]{7,}/i))
    {
        return 'utf-8';
    }
    return 'windows-1251';
};

//------------------------------------------------------------------------------
// Проверяет кодировку
//------------------------------------------------------------------------------
sape.toolbar.validCharset = function(charset)
{
    if (!charset) return false;
    var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
    try
    {
        converter.charset = charset;
        return true;
    }
    catch(ex) { return false; }
};


sape.toolbar.ping = function(url)
{
    var data = (arguments.length > 1)? arguments[1] : null;
    var type = (data)? 'POST' : 'GET';
    var req  = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open(type, url, true);
        req.onreadystatechange = function (aEvt) {};
        if (type == 'POST')
        {
            req.setRequestHeader('Content-Length', data.length);
            req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        }
        req.send(data);
};

//------------------------------------------------------------------------------
// Удаляет редиректы
//------------------------------------------------------------------------------
sape.toolbar.dropRedirects = function(doc)
{
    var st = sape.toolbar;
    var links = doc.getElementsByTagName('a'), ll = links.length;

    for (var i=0; i < ll; i++)
    {
        var href = links[i].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        if (!links[i].textContent || links[i].textContent.match(/^(YAP|YAL|GC)$/)) continue;

        var URI = st.getURI(href);
        if ((URI.host.indexOf('123sdfsdfsdfsd.ru') > -1) || (URI.host.indexOf('linkexplorer.ru') > -1))
        {
            var res, exp = /r\.html\?r=(.*)$/;
            if ((res = exp.exec(URI.path)) !== null)
            {
                try
                {
                    var newLink = decodeURIComponent(res[1].toString());
                    if (!st.urlCheck(newLink))
                    {
                        newLink = decodeURIComponent(newLink);
                    }
                    links[i].setAttribute('href', newLink);
                }
                catch(e1) {}
            }
        }
    }
};

sape.toolbar.getURI = function(href)
{
    var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var URI = ioService.newURI(href, 'windows-1251', null);

    return URI;
};

sape.toolbar.getURL = function(href)
{
    var URI  = sape.toolbar.getURI(href);
    var host = href.split('/')[2];

    if ((URI.asciiHost !== host) && (URI.asciiHost == host.toLowerCase()))
    {
        return URI.asciiSpec.replace('//' + URI.asciiHost, '//' + host);
    }
    return URI.asciiSpec;
};

sape.toolbar.getMyLink = function(me, row)
{
    if (me.lay.loc.match(/mode=wait|links_wait.php|orders.php|projects\/requests/)) return null;
    if (row.innerHTML.match(/icon_stat\s*stat_(wait|sleep)/)) return null;

    var st = sape.toolbar, URL = null;
    var col = row.cells;

    var exp = /URL\: ([^\s<]+)/;
    var res = exp.exec(col[me.lc].innerHTML);

    if (res)
    {
        return st.getURL(st.html_entity_decode(res[1]));
    }

    if  (me.lay.loc.indexOf('sape.ru/links_new_price.php') > -1)
    {
        var asp = col[1].getElementsByTagName('a');
        if (asp.length)
        {
            return st.getURL(asp[0].getAttribute('href'));
        }
    }
    var a; if ((a = me.doc.querySelector('span.wink_plugin a')) !== null)
    {
        return a.getAttribute('href');
    }

    var checker_input = me.doc.getElementById('wink_checker_url');
    if (checker_input)
    {
        var checker_input_val = checker_input.value;
        if (checker_input_val && checker_input_val.length)
        {
            checker_input_val = checker_input_val.trim();

            var wildcard = checker_input_val.match(/\*$/);
            if (wildcard)
            {
                checker_input_val = checker_input_val.replace(/\*$/, '');
            }
            if (checker_input_val.match(/^https?\:/i))
            {
                return st.getURL(checker_input_val) + ((wildcard)? '*':'');
            }
            else
            {
                return st.getURL('http://' + checker_input_val) + ((wildcard)? '*':'');
            }
        }
    }
    return null;
};

//------------------------------------------------------------------------------
// Проверка на наличие в базе вредоносных и фишинговых сайтов
//------------------------------------------------------------------------------

sape.toolbar.antivir = function(url, place)
{
   if (place.hasAttribute('antivir')) return;

   var st = sape.toolbar;
   var uri = st.getURI(url, null, null);

   function virCheck(place, url)
   {
       var img = place.ownerDocument.createElement('img');
           img.src = 'chrome://wmsape/skin/virus.png';
           img.title = sape.toolbar.str('antivir.warning');

       var a = place.ownerDocument.createElement('a');
           a.href = 'https://safebrowsing.clients.google.com/safebrowsing/diagnostic?client=Firefox&hl=ru&site=' + encodeURIComponent(url);
           a.target = '_blank';
           a.appendChild(img);

       var div = place.ownerDocument.createElement('div');
           div.appendChild(a);

       if (!place.hasAttribute('antivir'))
       {
            place.appendChild(div);
            place.setAttribute('antivir', 1);

            var checkbox = place.querySelector('input[type="checkbox"]');
            if (checkbox)
            {
                checkbox.checked = true;
                checkbox.setAttribute("reason", "virus");
            }
       }
   }
   try
   {
       var URIClassifier = Components.classes["@mozilla.org/uriclassifierservice"].createInstance(Components.interfaces.nsIURIClassifier);
       var callback = function(code)
       {
            if (code) virCheck(place, url);
       };
       if (URIClassifier)
       {
            try
            {
               var principal = Components.classes["@mozilla.org/scriptsecuritymanager;1"].getService(Components.interfaces.nsIScriptSecurityManager).getNoAppCodebasePrincipal(uri);
               URIClassifier.classify(principal, callback);
            }
            catch(ex)
            {
               URIClassifier.classify(uri, callback);
            }
       }
   }
   catch(e){}
};

//------------------------------------------------------------------------------
// Проверка блокировки Роскомнадзором
//------------------------------------------------------------------------------
sape.toolbar.rknBlock = function(req, place)
{
    if (place.hasAttribute('rknb'))
    {
        return place.getAttribute('rknb');
    }
    var isBlocked = 0;
    var host = req.channel.URI.host;
    var path = req.channel.URI.path;
    var text = (req.responseText)? req.responseText : "";

    if (host == 'law.filter.ertelecom.ru' || host == '95.167.13.50' || host == 'warning.rt.ru') isBlocked = 1;
    if (host.match(/\bmts\.ru$/)   && path.match(/^[\/]zapret_info[\/]/)) isBlocked = 1;
    if (host.match(/\bbscom\.ru$/) && path.match(/^[\/]blockedsite[\/]/)) isBlocked = 1;
    if (text && !isBlocked)
    {
        if (text.match(/w\.yaCounter18811318/)) isBlocked = 1;
        if (text.match(/eais.rkn.gov.ru/) && text.match(/398\-fz.rkn.gov.ru/) && text.match(/nap.rkn.gov.ru/)) isBlocked = 1;
    }
    place.setAttribute('rknb', isBlocked);

    if (isBlocked && place.ownerDocument)
    {
        var img = place.ownerDocument.createElement('img');
            img.src   = 'chrome://wmsape/skin/roscom.png';
            img.title = sape.toolbar.str('roscom.warning');

        if (place.hasAttribute('trusted_anejo'))
        {
            img.setAttribute('style', 'background:white;');
        }
        var div = place.ownerDocument.createElement('div');
            div.appendChild(img);

        place.appendChild(div);
    }
    return isBlocked;
};

//------------------------------------------------------------------------------
// Функции информационных сообщений
//------------------------------------------------------------------------------

sape.toolbar.showAlert = function(message, title)
{
    var play = function(melody)
    {
        var selectedAudioFile = "start.wav";
        if (melody == 2) selectedAudioFile = "stop.wav";
        if (melody == 3) selectedAudioFile = "captcha.wav";

        var soundURL = "chrome://wmsape/content/media/" + selectedAudioFile;
        try
        {
            var mySound = new Audio(soundURL);
                mySound.play();
        }
        catch(e){}
    };

    var melody  = (arguments.length > 2)? arguments[2] : 0;
    var image   = (arguments.length > 3)? arguments[3] : "chrome://wmsape/skin/button-sape.png";

    var prefs = sape.toolbar.prefs();
    if ((prefs.getBoolPref("play.start") && (melody == 1 || melody == 2)) || (prefs.getBoolPref("play.captcha") &&  melody == 3)) play(melody);

    if (melody == 2 || message.indexOf(sape.toolbar.str('links.checked')) > -1) sape.filters.ccount();

    if (!prefs.getBoolPref("showalerts")) return;
    try
    {
      	var alertService = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);
            alertService.showAlertNotification(image, "" + title, "" + message, false);
    }
    catch(e)
    {
        try
        {
            var notifyBox = gBrowser.getNotificationBox();
            if (notifyBox)
            {
                var notify = notifyBox.getNotificationWithValue('sape-toolbar-notify-popup');
                if (notify) notify.close();
                    notify = notifyBox.appendNotification("" + title, 'sape-toolbar-notify-popup', 'chrome://wmsape/skin/button-forum.png', notifyBox.PRIORITY_INFO_LOW, null);
            }
        }
        catch(e2){}
    }
};

sape.toolbar.noway = function()
{
    try
    {
        var notifyBox = gBrowser.getNotificationBox();
        if (notifyBox)
        {
            var notify = notifyBox.getNotificationWithValue('sape-toolbar-notify-noway');
            if (!notify)
            {
                notify = notifyBox.appendNotification(sape.toolbar.str('noway.message'), 'sape-toolbar-notify-noway', 'chrome://wmsape/skin/tools.png', notifyBox.PRIORITY_WARNING_LOW, null);
                notify.setAttribute("tooltiptext", sape.toolbar.str('close'));
                notify.addEventListener("click", function(evt){evt.target.close();});
            }
        }
    } catch(err){}
};

//------------------------------------------------------------------------------
// Функции разбора структуры страниц интерфейса
//------------------------------------------------------------------------------

sape.toolbar.addCSS = function(doc)
{
    if (doc.getElementById("wmsape-css-link")) return;

    var link = doc.createElement("link");

    link.type = "text/css";
    link.rel  = "stylesheet";
    link.href = "chrome://wmsape/skin/page.css";
    link.id   = "wmsape-css-link";

    doc.getElementsByTagName('head')[0].appendChild(link);
};

sape.toolbar.getTextCell = function(cell)
{
    var clear = function(node)
    {
        var child;
        while ((child = node.querySelector("a,br,img,b,p,div,span,input,textarea")) !== null)
        {
            if (child.parentNode) child.parentNode.removeChild(child);
        }
        return node;
    };
    var clone = cell.cloneNode(true);

    var context = clone.querySelector("span.is_context");
    if (context)
    {
        context.parentNode.removeChild(context);
    }
    var saperank = clone.querySelector("span.is_saperank");
    if (saperank)
    {
        saperank.parentNode.removeChild(saperank);
    }
    var teaser = clone.querySelector("div.teaser_item_block");
    if (teaser)
    {
        return clear(teaser);
    }
    var span = clone.querySelector("span.plcmnt_txt_container,span.link_text,span");
    if (span)
    {
        return clear(span);
    }
    return clear(clone);
};


sape.toolbar.expandTables = function(doc)
{
    var table = doc.querySelectorAll('table.orders_result_tree_info');
    if (table)
    {
        for (var i = 0; i < table.length; i++)
        {
            table[i].style.display = '';
        }
    }
};

sape.toolbar.isTree = function(doc)
{
    return !!(doc.querySelector('table.orders_result_tree_info'));
};

sape.toolbar.layout = function(doc)
{
    var result  =
    {
      link: -1,
      level: -1,
      idx: 0,
      tree: 0,
      ext: -1,
      tic: -1,
      rank: -1,
      black: 0,
      cols: 0,    // колонок в таблице
      check: 0,   // колонка с чекбоксом
      text: -1,   // колонка с текстом ссылки
      url: -1,    // колонка с url ссылки
      seo: 0,     // интерфейс оптимизатора
      dc: -1,     // колонка даты
      ico: -1,    // колонка кнопок YAP, GC
      loc: '',    // текущая локация
      price: 0,   // колонка с ценой
      history: 0, // признак сохранения истории проверок
      menu: ''
    };
    if (!sape.toolbar.inside(doc)) return result;

    var infoOnly = (arguments.length > 1);
    if (!infoOnly)
    {
        if (doc.querySelector('input[name=xToolMarker]'))
        {
            sape.toolbar.noway();
        }
        sape.toolbar.dropRedirects(doc);
        sape.toolbar.addCSS(doc);
    }

    var loc  = doc.location.href.toLowerCase();
    result.loc = loc;

    // Список проектов
    if  (loc.indexOf('sape.ru/projects.php') > 0)
    {
        result.cols  = 12;
        result.check = 11;
        result.url = 1;
        result.ico = 1;
        result.menu = 'yandex,yap,yac,host,s2,google,gc,gs,bing,bp,bs,inverse,export,addform,s5';
        return result;
    }

    // Новые заявки
    if  (loc.indexOf('sape.ru/links_wait.php') > 0)
    {
        result.link  = 1;
        result.ico   = 1;
        result.text  = 2;
        result.dc    = 3;
        result.tic   = 5;
        result.ext   = 6;
        result.level = 7;
        result.rank  = 8;
        result.price = 10;
        result.check = 11;
        result.cols  = 12;
        result.seo   = 1;
        if ((loc.indexOf('link_id=') > 0) || (loc.indexOf('project_id=') > 0))
        {
            result.link  = 0;
            result.ico   = 0;
            result.text  = 1;
            result.dc    = 2;
            result.tic   = 4;
            result.ext   = 5;
            result.level = 6;
            result.rank  = 7;
            result.price = 9;
            result.check = 10;
            result.cols  = 11;
        }
        result.menu = 'l1,lf,tf,s1,yandex,yap,yac,host,rel,tic,ctic,s2,google,gc,gs,bing,bp,bs,domains,linkpad,traf,pages,ext,lvl,moz,uniq,inverse,export,s5';
        return result;
    }
    // Список размещенных ссылок
    if  (loc.indexOf('sape.ru/links.php') > 0)
    {
        result.link  = 3;
        result.ico   = 3;
        result.level = 6;
        result.ext   = 5;
        result.tic   = 4;
        result.rank  = 7;
        result.price = 8;
        result.check = 9;
        result.cols  = 10;
        result.seo   = 1;
        result.text  = 2;
        result.dc    = 1;
        result.history = 1;
        if  (loc.indexOf('link_id=') > 0 && loc.indexOf('mode=wait') > 0)
        {
            result.text  = 1;
            result.link  = 2;
            result.ico   = 2;
            result.price = 9;
            result.check = 11;
            result.cols  = 12;
        }
        result.menu = 'l1,lf,tf,s1,yandex,yap,yal,yac,host,rel,tic,ctic,s2,google,gc,gl,gs,bing,bp,bl,bs,domains,linkpad,traf,pages,ext,lvl,hide,moz,uniq,inverse,export,s5';
        return result;
    }

    // Замороженные ссылки
    if  (loc.indexOf('sape.ru/links_sleep.php') > 0)
    {
        result.dc = 0;
        result.seo   = 1;
        result.text  = 2;
        result.link  = 3;
        result.ico   = 3;
        result.tic   = 4;
        result.ext   = 5;
        result.level = 6;
        result.rank  = 7;
        result.price = 8;
        result.check = 9;
        result.cols  = 10;
        result.history = 1;
        result.menu = 'l1,lf,tf,s1,yandex,yap,yal,yac,host,rel,tic,ctic,s2,google,gc,gl,gs,bing,bp,bl,bs,domains,linkpad,traf,pages,ext,lvl,hide,moz,uniq,inverse,export,s5';
        return result;
    }

    // Новые цены
    if  (loc.indexOf('sape.ru/links_new_price.php') > 0)
    {
        result.link  = 3;
        result.ico   = 3;
        result.level = 6;
        result.ext   = 5;
        result.tic   = 4;
        result.rank  = 7;
        result.cols  = 12;
        result.price = 10;
        result.check = 11;
        result.text  = 2;
        result.dc    = 1;
        result.history = 1;
        result.menu = 'l1,lf,tf,s1,yandex,yap,yal,yac,host,rel,tic,ctic,s2,google,gc,gl,gs,bing,bp,bl,bs,domains,linkpad,traf,pages,ext,lvl,hide,moz,uniq,inverse,export,s5';
        return result;
    }

    // Ручной поиск
    if  (loc.indexOf('sape.ru/orders.php') > 0)
    {
        result.ext   = 2;
        result.rank  = 4;
        result.level = 3;
        result.idx = 0;

        result.tree  = sape.toolbar.isTree(doc);
        result.cols  = (result.tree)? 11 : 10;
        result.check = (result.tree)? 10 : 9;
        result.link  = (result.tree)?  1 : 0;
        result.url   = (result.tree)?  1 : 0;
        result.ico   = (result.tree)?  1 : 0;
        result.tic   = (result.tree)? -1 : 1;

        if (loc.indexOf('filter_mode=2') > 0)
        {
            result.cols  = (result.tree)? 11 : 10;
            result.check = (result.tree)? 10 : 9;
        }
        result.menu = (result.tree)? 'l1,lf,tf,s1,yandex,yap,yac,host,tic,s2,google,gc,gs,bing,bp,bs,domains,linkpad,traf,pages,ext,lvl,moz,uniq,inverse,export,addform,s5' : 'l1,lf,tf,s1,yandex,yap,yac,host,tic,ctic,s2,google,gc,pr,domains,linkpad,traf,pages,ext,lvl,moz,uniq,inverse,export,addform,s5';

        if (result.tree && !infoOnly) sape.toolbar.expandTables(doc);
        return result;
    }

    // Список страниц вебмастера
    if  (loc.indexOf('sape.ru/site_pages.php') > 0 || loc.indexOf('/site_pages_context.php') > 0 || loc.indexOf('/site_pages_teasers.php') > 0)
    {
        result.link  = 0;
        result.ico   = 0;
        result.idx   = 2;
        result.ext   = 1;
        result.level = 2;
        result.rank  = 3;
        result.price = 8;
        result.check = 9;
        result.cols  = 10;
        if  (loc.indexOf('filter[only_sr]=true') > 0 || loc.indexOf('filter%5bonly_sr%5d=true') > 0)
        {
            result.price = 6;
            result.check = 7;
            result.cols  = 8;
        }
        result.menu  = 'l1,lf,tf,s1,yandex,yap,yac,host,s2,google,gc,gs,bing,bp,bs,domains,linkpad,traf,pages,ext,lvl,moz,uniq,inverse,export,addform,s5';
        return result;
    }

    // Список размещенных ссылок вебмастера
    if  (loc.indexOf('sape.ru/site_links.php') > 0)
    {
        result.dc    = 1;
        result.text  = 3;
        result.url   = 4;
        result.ico   = 4;
        result.link  = 2;
        result.level = 5;
        result.price = 7;
        result.check = 8;
        result.cols  = 9;
        result.menu = 'user,l1,2,3,22,50,75,ab,en,dots,lf,tf,wait,s1,yandex,yap,yal,yac,host,rel,tic,s2,google,gc,gl,gs,bing,bp,bl,bs,domains,linkpad,traf,pages,moz,lvl,uniq,inverse,export,addform,s5';
        return result;
    }

    // Новые заявки вебмастера
    if  (loc.indexOf('sape.ru/submit_orders.php') > 0)
    {
        result.cols  = 7;
        result.price = 4;
        result.check = 6;
        result.text  = 3;
        result.url   = 2;
        result.ico   = 2;
        if  (loc.indexOf('site_id') > 0)
        {
            result.cols  = 6;
            result.price = 3;
            result.check = 5;
            result.text  = 2;
            result.url   = 1;
            result.ico   = 1;
        }
        result.menu = 'user,l1,2,3,22,50,75,ab,en,dots,lf,tf,wait,s1,yandex,yap,yac,host,rel,tic,s2,google,gc,gs,bing,bp,bs,domains,linkpad,traf,pages,moz,uniq,inverse,export,addform,s5';
        return result;
    }

    // Заявки на изменение текста
    if  (loc.indexOf('sape.ru/site_links_text_update.php') > 0)
    {
        result.cols  = 9;
        result.check = 8;
        result.price = 5;
        result.url   = 2;
        result.ico   = 2;
        result.text  = 1;
        result.history = 1;
        result.menu = 'user,l1,2,3,22,50,75,ab,en,dots,lf,tf,wait,s1,yandex,yap,yac,host,rel,tic,s2,google,gc,gs,bing,bp,bs,domains,linkpad,traf,pages,moz,uniq,inverse,export,addform,s5';
        return result;
    }

    // Избранное и черные списки
    if  (loc.indexOf('sape.ru/white_list.php') > 0 || loc.indexOf('sape.ru/links_bl.php') > 0 || loc.indexOf('sape.ru/sites_bl.php') > 0 || loc.indexOf('sape.ru/black_list_project') > 0)
    {
        result.link  = 1;
        result.ico   = 1;
        result.rank  = 1;
        result.tic   = 1;
        result.black = 1;
        result.cols  = 2;
        result.check = 1;
        result.menu = 'l1,lf,tf,s1,yandex,yac,host,tic,ctic,s2,google,gc,gs,bing,bp,bs,domains,linkpad,traf,pages,moz,uniq,inverse,export,addform,s5';
        return result;
    }

    // Список текстов ссылок
    if  (loc.indexOf('sape.ru/link_texts.php') > 0)
    {
        result.text  = 0;
        result.ico   = 0;
        result.cols  = 3;
        result.check = 2;
        result.menu = 'clear,drop,inverse,s5';
        return result;
    }

    // Индивидуальная настройка цен
    if  (loc.indexOf('sape.ru/site_pages_prices.php?act=show_full_table') > 0)
    {
        result.cols  = 9;
        result.check = 8;
        result.ico   = 0;
        result.url   = 0;
        result.idx   = 0;
        result.ext   = 1;
        result.level = 2;
        result.rank  = 3;
        result.menu = 'l1,lf,tf,s1,yandex,yap,yac,s2,google,gc,gs,bing,bp,bs,pages,ext,lvl,inverse,export,addform,s5';
        return result;
    }

    // Изменение текстов оптимизатора
    if  (loc.indexOf('sape.ru/link_update_texts.php?link_id') > 0)
    {
        result.cols  = 10;
        result.check = 9;
        result.dc    = 1;
        result.text  = 2;
        result.ico   = 3;
        result.url   = 3;
        result.idx   = 0;
        result.tic   = 4;
        result.ext   = 5;
        result.level = 6;
        result.rank  = 7;
        result.price = 8;
        result.seo   = 1;
        result.history = 1;
        result.menu = 'l1,lf,tf,s1,yandex,yap,yal,yac,host,rel,tic,ctic,s2,google,gc,gl,gs,bing,bp,bl,bs,domains,linkpad,traf,pages,ext,lvl,hide,moz,uniq,inverse,export,addform,s5';
        return result;
    }

    // Извещения
    if  (loc.indexOf('sape.ru/messages.php') > 0)
    {
        result.menu  = 'msgs,s5';
        return result;
    }

    // Биржа статей - страницы вебмастера
    if  (loc.indexOf('articles.sape.ru/wm/pages/?site_id') > 0)
    {
        result.cols  = 8;
        result.check = 7;
        result.ico   = 0;
        result.url   = 1;
        return result;
    }

    // Биржа статей - размещенные статьи у вебмастера
    if  (loc.indexOf('articles.sape.ru/wm/articles/?site_id') > 0)
    {
        result.cols  = 8;
        result.check = 7;
        result.ico   = 1;
        result.url   = 1;
        return result;
    }

    // Биржа статей - черный список
    if  ((loc.indexOf('articles.sape.ru/wm/bl/') > 0) || (loc.indexOf('articles.sape.ru/wm/bl/') > 0))
    {
        result.link  = 0;
        result.ico   = 0;
        result.rank  = 0;
        result.tic   = 0;
        result.black = 1;
        result.cols  = 1;
        result.check = 0;
        result.menu = 'l1,lf,tf,s1,yandex,yac,host,tic,ctic,s2,google,gc,gs,bing,bp,bs,domains,linkpad,traf,pages,moz,uniq,inverse,export,addform,s5';
        return result;
    }

    // Биржа статей - анонсы у вебмастера
    if  (loc.indexOf('articles.sape.ru/wm/announcements/?site_id') > 0)
    {
        result.cols  = 7;
        result.check = 6;
        result.ico   = 2;
        result.url   = 1;
        return result;
    }

    // Биржа статей - Размещенные статьи оптимизатора
    if  (loc.indexOf('articles.sape.ru/seo/placed/?project_id') > 0)
    {
        result.cols  = 7;
        result.check = 6;
        result.ico   = 3;
        result.url   = 3;
        result.idx   = 0;
        return result;
    }

    // Биржа статей - Заявки оптимизатора
    if  (loc.indexOf('articles.sape.ru/seo/orders/?project_id') > 0)
    {
        result.cols  = 5;
        result.check = 4;
        result.ico   = 0;
        result.url   = 0;
        result.idx   = 0;
        return result;
    }

    // Чекер ссылок
    if  (loc.indexOf('wmsape/content/check.html') > 0)
    {
        result.cols  = 4;
        result.url   = 0;
        result.ico   = 0;
        result.idx   = 0;
        result.ext   = 1;
        result.level = 2;
        result.check = 3;
        result.menu = 'l1,lf,tf,s1,yandex,yap,yac,host,tic,s2,google,gc,gs,bing,bp,bs,domains,linkpad,traf,pages,ext,lvl,moz,uniq,inverse,export,s5';
        return result;
    }
    return result;
};

//------------------------------------------------------------------------------
// Внешние сервисы
//------------------------------------------------------------------------------
sape.toolbar.openChecker = function()
{
    var doc = sape.toolbar.getDocument(), where = (doc.location.href.match(/^about:(blank|home|newtab)$/))? 'current' : 'tab';
    openUILinkIn('chrome://wmsape/content/check.html', where , false, null, null);
};

sape.toolbar.openService = function(service)
{
    var loc = sape.toolbar.getDocument().location;
    if (!loc.protocol.match(/^https?/i)) return;

    var URI = sape.toolbar.getURI(loc.href);
    var spec = URI.asciiHost.replace(/^www./i, '') + URI.path;

    switch (service)
    {
        case 'XT':
            openUILinkIn('http://xtool.ru/trust/?site=' + encodeURIComponent(URI.asciiHost), 'tab');
	        break;

	   case 'T':
            openUILinkIn('http://ru.semrush.com/ru/search.php?db=ru&ref=874727397&stype=domain&q=' + encodeURIComponent(URI.host), 'tab');
            openUILinkIn('http://www.alexa.com/siteinfo/' + encodeURIComponent(URI.host), 'tab');
            break;

	   case 'TIC':
            openUILinkIn('https://yaca.yandex.ru/yca/cy/ch/' + encodeURIComponent(URI.asciiHost) + '/', 'tab');
            break;

	   case 'MR':
            openUILinkIn('https://moz.com/researchtools/ose/links?site=' + encodeURIComponent(URI.asciiSpec), 'tab');
            break;

	   case 'CF':
            openUILinkIn('https://ru.majesticseo.com/reports/site-explorer?q=' + encodeURIComponent(URI.asciiSpec) + '&scope=url', 'tab');
            break;

	   case 'AH':
            openUILinkIn('https://ru.ahrefs.com/site-explorer/overview/v2/exact/fresh?target=' + encodeURIComponent(URI.asciiSpec), 'tab');
            break;

	   case 'D':
            openUILinkIn('https://www.linkpad.ru/default.aspx?r=15&i=' + encodeURIComponent(URI.asciiHost), 'tab');
            break;

	   case 'H':
            openUILinkIn('https://yandex.ru/yandsearch?text=' + encodeURIComponent('site:' + URI.asciiHost.replace(/^www./i, '')), 'tab');
            break;

	   case 'BS':
            openUILinkIn('http://www.bing.com/search?q=' + encodeURIComponent('site:' + URI.asciiHost.replace(/^www./i, '')), 'tab');
            break;

	   case 'YP':
            openUILinkIn('https://yandex.ru/yandsearch?text=' + encodeURIComponent('url:"' + spec + '" | url:"www.' + spec + '"'), 'tab');
            break;

	   case 'BP':
            openUILinkIn('http://www.bing.com/search?q=' + encodeURIComponent('url:"' + spec + '" | url:"www.' + spec + '"'), 'tab');
            break;

	   case 'GP':
            openUILinkIn('https://www.google.ru/search?q=' + encodeURIComponent('info:' + URI.asciiSpec), 'tab');
            break;

	   case 'GM':
            openUILinkIn('https://www.google.ru/search?q=' + encodeURIComponent('inurl:' + URI.host.replace(/^www\./i, '') + URI.path.replace(/\&/g, '*').replace(/#.*$/g, '') + ' site:' + URI.host.replace(/^www\./i, '') + '/&'), 'tab');
            break;

	   case 'GC':
            openUILinkIn('https://www.google.ru/search?q=' + encodeURIComponent('cache:' + URI.asciiSpec), 'tab');
            break;

	   case 'GS':
            openUILinkIn('https://www.google.ru/search?q=' + encodeURIComponent('site:' + URI.asciiHost.replace(/^www./i, '')), 'tab');
            break;

	   case 'SOC':
            openUILinkIn('https://blogs.yandex.ru/search.xml?text=&ft=all&link=' + encodeURIComponent(URI.spec) + '&holdres=mark', 'tab');
            break;

	   case 'LI':
            sape.toolbar.loadJS('counters');
            sape.counters.openStat();
            break;

       default:
            break;
	}
};

sape.toolbar.loadJS = function(name)
{
    if (sape.hasOwnProperty(name)) return;

    var loader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader);
        loader.loadSubScript("chrome://wmsape/content/libs/" + name + ".js", null, "UTF-8");
};

//------------------------------------------------------------------------------
// Функции работы с Unicode
//------------------------------------------------------------------------------

sape.toolbar.unicode =
{
        encode: function(str)
        {
            var converter =  Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
            converter.charset = "UTF-8";

            return converter.ConvertToUnicode(str);
        },
        decode: function(str)
        {
            var converter =  Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
            converter.charset = "UTF-8";

            return converter.ConvertFromUnicode(str);
        }
};

//------------------------------------------------------------------------------
// Класс преобразований utf-8
//------------------------------------------------------------------------------

sape.toolbar.utf8 =
{
    encode: function(s)
    {
        s = s.replace(/\r\n/g,"\n");
        var utftext = "";

        for (var n = 0; n < s.length; n++)
        {
            var c = s.charCodeAt(n);

            if (c < 128)
            {
                utftext += String.fromCharCode(c);
            }
            else
            {
                if((c > 127) && (c < 2048))
                {
                   utftext += String.fromCharCode((c >> 6) | 192);
                   utftext += String.fromCharCode((c & 63) | 128);
                }
                else
                {
                   utftext += String.fromCharCode((c >> 12) | 224);
                   utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                   utftext += String.fromCharCode((c & 63) | 128);
                }
            }
        }
        return utftext;
    },

    decode: function(utftext)
    {
        var s = "";
        var i = 0, c = 0, c1 = 0, c2 = 0, c3 = 0;

        while (i < utftext.length)
        {
            c = utftext.charCodeAt(i);

            if (c < 128)
            {
                s += String.fromCharCode(c);
                i++;
            }
            else
            {
                if((c > 191) && (c < 224))
                {
                    c2 = utftext.charCodeAt(i+1);
                    s += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                    i += 2;
                }
                else
                {
                    c2 = utftext.charCodeAt(i+1);
                    c3 = utftext.charCodeAt(i+2);
                    s += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                    i += 3;
                }
            }
        }
        return s;
    }
};

//------------------------------------------------------------------------------
// Функция получения md5-хэша строки
//------------------------------------------------------------------------------

sape.toolbar.md5 = function(str)
{
    function toHexString(charCode)
    {
         return ("0" + charCode.toString(16)).slice(-2);
    }
    var converter =  Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
        converter.charset = "UTF-8";

    var result = {};
    var data = converter.convertToByteArray(str, result);

    var ch = Components.classes["@mozilla.org/security/hash;1"].createInstance(Components.interfaces.nsICryptoHash);
        ch.init(ch.MD5);
        ch.update(data, data.length);

    var res = "", hash = ch.finish(false);
    for (var i = 0; i < hash.length; i++)
    {
        res += toHexString(hash.charCodeAt(i));
    }
    return res.substring(0,32);
};

sape.toolbar.sha512 = function(str)
{
    function toHexString(charCode)
    {
         return ("0" + charCode.toString(16)).slice(-2);
    }
    var converter =  Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
        converter.charset = "UTF-8";

    var result = {};
    var data = converter.convertToByteArray(str, result);

    var ch = Components.classes["@mozilla.org/security/hash;1"].createInstance(Components.interfaces.nsICryptoHash);
        ch.init(ch.SHA512);
        ch.update(data, data.length);

    var res = "", hash = ch.finish(false);
    for (var i = 0; i < hash.length; i++)
    {
        res += toHexString(hash.charCodeAt(i));
    }
    return res;
};

//------------------------------------------------------------------------------
// Преобразование мнемоник в текст
//------------------------------------------------------------------------------

sape.toolbar.html_entity_decode = function(html)
{
    var scriptableUnescapeHTML = Components.classes["@mozilla.org/feed-unescapehtml;1"].getService(Components.interfaces.nsIScriptableUnescapeHTML);
    return scriptableUnescapeHTML.unescape(html);
};

//------------------------------------------------------------------------------
// Уникализация элементов массива
//------------------------------------------------------------------------------

sape.toolbar.uniqArray = function(all)
{
    var uniq = all.sort().filter(function(el,i,a) {return i == a.indexOf(el);});
    return uniq;
};

//------------------------------------------------------------------------------
// Convert all applicable characters to HTML entities
//   original by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
//------------------------------------------------------------------------------

sape.toolbar.htmlentities = function(s)
{
    var doc = sape.toolbar.getDocument(), div = doc.createElement('div'), text = doc.createTextNode(s);
    div.appendChild(text);
    return div.innerHTML;
};

//------------------------------------------------------------------------------
// Инициализация интерфейса
//------------------------------------------------------------------------------

sape.toolbar.initInterface = function()
{
    var pref = sape.toolbar.prefs();

    var toolsShow = pref.getBoolPref("interface.tools");
    var statusShow = pref.getBoolPref("interface.status");
    var contextShow = pref.getBoolPref("interface.context");
    var hiddenButtons = pref.getCharPref("interface.hidden");

    if (window.navigator.platform.indexOf("Win32") == -1) toolsShow = false;

	try
    {
        var toolsItem = document.getElementById('wmsape-tools-menu');
        var statusItem = document.getElementById('wmsape-statusbar-panel-icon');
        var contextItem = document.getElementById('wmsape-context-menu');

        if (toolsItem) toolsItem.hidden = !toolsShow;
        if (statusItem) statusItem.hidden = !statusShow;
        if (contextItem) contextItem.hidden = !contextShow;

        var hidden  = hiddenButtons.split(",");
        var toolbox = document.getElementById('sape-toolbar-v81');
        if (toolbox)
        {
            var element = toolbox.getElementsByTagName('toolbarbutton');
            for (var i=0; i < element.length; i++)
            {
                if (element[i].id.indexOf('wmsape-button') > -1)
                {
                    element[i].hidden = (hidden.indexOf(element[i].id.replace('wmsape-button-', '')) > -1);
                }
            }
        }
    }
    catch(e){}
};

//------------------------------------------------------------------------------
// Контекстное меню
//------------------------------------------------------------------------------

sape.toolbar.menu =
{
    toggle: function()
    {
        var toolbar = document.getElementById("sape-toolbar-v81");
        if (toolbar)
        {
            toolbar.collapsed = !toolbar.collapsed;
            document.persist(toolbar.id, "collapsed");
        }
    },

    clone: function(toID)
    {
        var from  = document.getElementById("wmsape-context-popup");
        var to    = document.getElementById(toID);

        while (to.firstChild)
        {
            to.removeChild(to.firstChild);
        }
        for (var i=0; i < from.childNodes.length; i++)
        {
            to.appendChild(from.childNodes[i].cloneNode(true));
        }
        sape.toolbar.menu.hide(toID);
    },

    hide: function(ID)
    {
        function walk(menu, items)
        {
            for (var i=0; i < menu.childNodes.length; i++)
            {
                var elem = menu.childNodes[i];
                if (elem.hasAttributeNS("http://www.sape.ru/toolbar.xul", "name"))
                {
                    elem.hidden = !(items.indexOf(elem.getAttributeNS("http://www.sape.ru/toolbar.xul", "name")) > -1);
                }
                else
                {
                    elem.hidden = false;
                }
                if (elem.hasChildNodes()) walk(elem, items);
            }
        }
        var st = sape.toolbar, lay = st.layout(st.getDocument(), 1), menu = document.getElementById(ID), items = lay.menu.split(",");
        walk(menu, items);
    }
};