var sape = sape || {};

if (!sape.filters) sape.filters =
{
    bgcolor: "pink",        // Цвет подсветки строк
    changeselect: true,     // Выбирать пункт "отказать"
    amorf: false,           // Нестрогое сравнение слов
    repeat: 3,              // Количество повторов
    chkspace: false,        // Задвоенные пробелы
    chkdot: true,           // Начинающиеся не с буквы
    chkcomma: true,         // Контроль пунктуации
    regexp: "",             // Регулярка для текстов
    layout: {}              // Разметка страницы
};

//------------------------------------------------------------------------------
// Инициализация
//------------------------------------------------------------------------------
sape.filters.init = function()
{
    var f = sape.filters, st = sape.toolbar, doc = st.getDocument();
    var prefs = st.prefs();

    st.loadJS('external');

    f.bgcolor       = prefs.getCharPref("bgcolor").replace(/[^0-9a-z#]+/ig,"");
    f.changeselect  = prefs.getBoolPref("changeselect");
    f.amorf         = prefs.getBoolPref("amorf");
    f.repeat        = prefs.getIntPref("repeat");
    f.chkspace      = prefs.getBoolPref("chkspace");
    f.chkdot        = prefs.getBoolPref("chkdot");
    f.chkcomma      = prefs.getBoolPref("chkcomma");
    f.regexp        = prefs.getCharPref("regexp");
    f.layout        = sape.toolbar.layout(doc);
    f.keycheck      = prefs.getBoolPref("request.keycheck");
    f.sensitive     = prefs.getBoolPref("request.sensitive");
    f.stoplist      = [];
    if (f.keycheck)
    {
        f.stoplist = sape.external.prefToArray("request.stoplist");
    }

    Components.utils["import"]("resource://wmsape/snowball.jsm", sape);
};

//------------------------------------------------------------------------------
// Запуск фильтра
//------------------------------------------------------------------------------

sape.filters.run = function(selected)
{
    var f = sape.filters, st = sape.toolbar, doc = st.getDocument();
    if (!sape.toolbar.inside(doc)) return;

    f.init();

    if (f.layout.seo) return;
    if (f.layout.text == -1) return;

    var rows  = doc.getElementsByTagName('tr');
    var total = 0;
    for (var i = 0; i < rows.length; i++)
    {
        var cols = rows[i].cells;
        if (cols.length < f.layout.cols) continue;

        var checkbox = st.getCheckbox(cols[f.layout.check]);
        if (!checkbox || checkbox.checked) continue;

        if (cols[f.layout.text].querySelector('span.is_context') || cols[f.layout.text].innerHTML.indexOf('link_is_context') != -1) continue;

        total += sape.filters[selected](rows[i]);
    }
    if (total > 0)
    {
        if (f.changeselect)
        {
            st.changeSelect(doc, 'placementRemoveCause2,delete_link_type_2');
        }
        st.showAlert(st.str('links.checked') + ' ' + total, st.str('ya.finished'), 0, "chrome://wmsape/skin/button-forum.png");
    }
    else
    {
        st.showAlert(st.str('links.no'), st.str('ya.finished'), 0, "chrome://wmsape/skin/button-forum.png");
    }
    sape.stemmer.done();
};

//------------------------------------------------------------------------------
// Запуск пользовательского фильтра
//------------------------------------------------------------------------------
sape.filters.user = function ()
{
    var f = sape.filters, st = sape.toolbar, doc = st.getDocument();
    if (!st.inside(doc)) return;

    f.init();
    var prefs = st.prefs();

    var fn = new Array();
    fn[1]  = prefs.getBoolPref("mem.1");
    fn[2]  = prefs.getBoolPref("mem.2");
    fn[3]  = prefs.getBoolPref("mem.3");
    fn[4]  = prefs.getBoolPref("mem.4");
    fn[5]  = prefs.getBoolPref("mem.5");
    fn[8]  = prefs.getBoolPref("mem.8");
    fn[11] = prefs.getBoolPref("mem.11");
    fn[12] = prefs.getBoolPref("mem.12");
    fn[13] = true;
    fn[18] = prefs.getBoolPref("mem.18");

    var rows  = doc.getElementsByTagName('tr');
    var total = 0;

    if ((f.layout.text > -1) && !f.layout.seo)
    {
        for (var i = 0; i < rows.length; i++)
        {
            var cols = rows[i].cells;
            if (cols.length < f.layout.cols) continue;

            var checkbox = st.getCheckbox(cols[f.layout.check]);
            if (!checkbox || checkbox.checked) continue;

            if (cols[f.layout.text].querySelector('span.is_context') || cols[f.layout.text].innerHTML.indexOf('link_is_context') != -1) continue;

            if (fn[1])  total += f[1](rows[i]);
            if (fn[2])  total += f[2](rows[i]);
            if (fn[3])  total += f[3](rows[i]);
            if (fn[4])  total += f[4](rows[i]);
            if (fn[5])  total += f[5](rows[i]);
            if (fn[8])  total += f[8](rows[i]);
            if (fn[11]) total += f[11](rows[i]);
            if (fn[12]) total += f[12](rows[i]);
            if (fn[13]) total += f[13](rows[i]);
        }
    }
    if (fn[18])
    {
        total += sape.external.urls(1);
    }
    sape.stemmer.done();

    if (total > 0)
    {
        if (f.changeselect)
        {
            st.changeSelect(doc, 'placementRemoveCause2,delete_link_type_2');
        }
        f.ccount();
        st.showAlert(st.str('links.checked') + ' ' + total, st.str('ya.finished'), 0, "chrome://wmsape/skin/button-forum.png");
    }
    else
    {
        st.showAlert(st.str('links.no'), st.str('ya.finished'), 0, "chrome://wmsape/skin/button-forum.png");
    }
};


//------------------------------------------------------------------------------
// Раскраска строк
//------------------------------------------------------------------------------

sape.filters.decorate = function(row, color)
{
    try
    {
        var col = row.cells;
        for (var i=0; i < col.length; i++)
        {
            if (!col[i].hasAttribute("trusted") && !col[i].hasAttribute("trusted_anejo")) col[i].style.backgroundColor = color;
        }
    }
    catch(err) {}
};

//------------------------------------------------------------------------------
// Снять отметки
//------------------------------------------------------------------------------

sape.filters.cleanup = function ()
{
    var f = sape.filters, st = sape.toolbar, doc = st.getDocument();
    if (!st.inside(doc)) return;

    f.init();

    var rows = doc.getElementsByTagName('tr');
    for (var i = 0; i < rows.length; i++)
    {
        try
        {
            var cols = rows[i].cells;
            if (cols.length !== f.layout.cols) continue;

            var checkbox = st.getCheckbox(cols[f.layout.check]);
            if (!checkbox) continue;

            if (checkbox.checked)
            {
                checkbox.checked = false;
                checkbox.removeAttribute("reason");
            }
            f.decorate(rows[i], '');
        }
        catch(err)
        {
            continue;
        }
    }
    try
    {
        f.ccount();
        st.resetSelect(doc);
    }
    catch(err) {}
};

sape.filters.cleanupwl = function ()
{
    var f = sape.filters, st = sape.toolbar, doc = st.getDocument();
    if (!st.inside(doc)) return;

    f.init();

    var rows = doc.getElementsByTagName('tr');
    for (var i = 0; i < rows.length; i++)
    {
        try
        {
            if (!rows[i].querySelector('span.icon_in_wl')) continue;

            var cols = rows[i].cells;
            if (cols.length !== f.layout.cols) continue;

            var checkbox = st.getCheckbox(cols[f.layout.check]);
            if (!checkbox) continue;

            if (checkbox.checked)
            {
                checkbox.checked = false;
                checkbox.removeAttribute("reason");
            }
            f.decorate(rows[i], '');
        }
        catch(err)
        {
            continue;
        }
    }
    try
    {
        f.ccount();
        st.resetSelect(doc);
    }
    catch(err) {}
};

//------------------------------------------------------------------------------
// Инвертировать отметки
//------------------------------------------------------------------------------

sape.filters.inverse = function ()
{
    var f = sape.filters, st = sape.toolbar, doc = st.getDocument();
    if (!st.inside(doc)) return;

    f.init();

    var rows = doc.getElementsByTagName('tr');
    for (var i = 0; i < rows.length; i++)
    {
        try
        {
            var cols = rows[i].cells;
            if (cols.length !== f.layout.cols) continue;

            var checkbox = st.getCheckbox(cols[f.layout.check]);
            if (!checkbox) continue;

            if (checkbox.checked)
            {
                f.decorate(rows[i], '');
                checkbox.removeAttribute("reason");
            }
            checkbox.checked = !checkbox.checked;
        }
        catch(err)
        {
            continue;
        }
    }
    try
    {
        f.ccount();
        st.resetSelect(doc);
    }
    catch(err) {}
};

//------------------------------------------------------------------------------
// Оставить только отмеченные строки
//------------------------------------------------------------------------------

sape.filters.drop = function ()
{
    var f = sape.filters, st = sape.toolbar, doc = st.getDocument();
    if (!st.inside(doc)) return;

    f.init();
    var rows  = doc.getElementsByTagName('tr');
    var top   = rows.length - 1;

    for (var i = top; i >= 0; i--)
    {
        try
        {
            var cols = rows[i].cells;
            if (cols.length !== f.layout.cols) continue;

            var checkbox = st.getCheckbox(cols[f.layout.check]);
            if (!checkbox || checkbox.checked) continue;

            rows[i].parentNode.removeChild(rows[i]);
        }
        catch(err)
        {
            continue;
        }
    }
    if (st.isTree(doc))
    {
        var div = doc.querySelectorAll('div.block_round');
        for (var j=0; j < div.length; j++)
        {
            var table = div[j].querySelector('table.orders_result_tree_info');
            if (!table) continue;
            if (!table.querySelector('input[type="checkbox"]:checked'))
            {
                div[j].parentNode.removeChild(div[j]);
            }
        }
    }
    try
    {
        f.ccount();
        st.resetSelect(doc);
    }
    catch(err) {}
};

//------------------------------------------------------------------------------
// Количество отмеченных строк
//------------------------------------------------------------------------------

sape.filters.ccount = function ()
{
    var st = sape.toolbar;

    var show_tooltip = function(c, v, id)
    {
        var icon = document.getElementById(id);
        if (icon)
        {
            var text = (!c)? st.str('menu.toggle.label') : st.str('links.checked') + ' ' + c;
            if (c && v) text += "\n" + st.str('addform.s4') + ' ' + v.toFixed(2);

            icon.setAttribute("tooltiptext", text);
        }
    };

    var show_info = function(c, v)
    {
        var fastinfo = doc.querySelector('#window_fast_info');
        if (fastinfo)
        {
            if (c > 0)
            {
                fastinfo.textContent = "\u0412\u044b\u0431\u0440\u0430\u043d\u043e \u0441\u0441\u044b\u043b\u043e\u043a " + c;
                if (v > 0)
                {
                    fastinfo.textContent += ", \u043d\u0430 \u0441\u0443\u043c\u043c\u0443 " + v.toFixed(2);
                }
                fastinfo.style.display = "block";
            }
            else
            {
                fastinfo.textContent = "";
                fastinfo.style.display = "none";
            }
        }
    };

    var doc = st.getDocument(), ccnt = 0, cval = 0;
    if (st.inside(doc))
    {
        var lay = st.layout(doc);
        if (lay.cols > 0)
        {
            var rows = doc.getElementsByTagName('tr');
            for (var i = 0; i < rows.length; i++)
            {
                if (rows[i].cells.length < lay.cols) continue;

                var checkbox = st.getCheckbox(rows[i].cells[lay.check]);
                if (checkbox && checkbox.checked)
                {
                    ccnt++;
                    if (checkbox.hasAttribute("price")) cval += parseFloat(checkbox.getAttribute("price").replace(',', '.'));
                }
            }
        }
        show_info(ccnt, cval);
        if (arguments.length)
        {
            show_tooltip(ccnt, cval, arguments[0]);
        }
    }
};

//------------------------------------------------------------------------------
// Отметка по количеству страниц
//------------------------------------------------------------------------------
sape.filters.counters = function ()
{
    var st = sape.toolbar, doc = st.getDocument();
    if (!st.inside(doc)) return;

    var r = doc.getElementsByTagName("tr");
    if (!r.length) return;

    var prefs    = st.prefs();
    var yLimit   = prefs.getIntPref("pc.ycount");
    var gLimit   = prefs.getIntPref("pc.gcount");
    var bLimit   = prefs.getIntPref("pc.bcount");
    var yCheck   = prefs.getBoolPref("pc.ycheck");
    var gCheck   = prefs.getBoolPref("pc.gcheck");
    var bCheck   = prefs.getBoolPref("pc.bcheck");
    var together = prefs.getBoolPref("pc.together");
    var diff     = prefs.getIntPref("pc.diff");
    var diffc    = prefs.getBoolPref("pc.diff.check");
    var lay      = st.layout(doc);
    var gexp     = /G:<\/b>\s+\[([0-9]+)\]/;
    var yexp     = /Я:<\/b>\s+\[([0-9]+)\]/;
    var bexp     = /B:<\/b>\s+\[([0-9]+)\]/;
    var counter  = 0;

    for (var i=0; i < r.length; i++)
	{
        if (r[i].cells.length !== lay.cols) continue;

        var checkbox = sape.toolbar.getCheckbox(r[i].cells[lay.check]);
        if (!checkbox) continue;

        var yCount = -1, yc = yCheck;
        var gCount = -1, gc = gCheck;
        var bCount = -1, bc = bCheck;

        var res, html = r[i].innerHTML;

        if (html.indexOf('blocked-in-yandex') > 0)
        {
            yCount = (res = yexp.exec(html))? +res[1] : 0;
        }
        yc = yc && (yCount > -1);

        if (html.indexOf('blocked-in-google') > 0)
        {
            gCount = (res = gexp.exec(html))? +res[1] : 0;
        }
        gc = gc && (gCount > -1);

        if (html.indexOf('blocked-in-bing') > 0)
        {
            bCount = (res = bexp.exec(html))? +res[1] : 0;
        }
        bc = bc && (bCount > -1);

        var y = yc && (yCount < yLimit);
        var g = gc && (gCount < gLimit);
        var b = bc && (bCount < bLimit);

        var checkit = false;
        if (together)
        {
            var v1 = 1 + yc + gc + bc;
            var v2 = 1 + y + g + b;

            if ((v1 > 1) && (v2 >= v1)) checkit = true;
        }
        else
        {
            checkit = y || g || b;
        }
        // Сравнение количества страниц в G и Я
        if (diffc && !checkit)
        {
            if ((html.indexOf('blocked-in-google') > -1) && (html.indexOf('blocked-in-yandex') > -1))
            {
                yCount = Math.max(yCount,1);
                gCount = Math.max(gCount,1);

                checkit = (gCount/yCount > diff) || (yCount/gCount > diff);
            }
        }
        if (checkit)
        {
            checkbox.checked = true;
            checkbox.setAttribute("reason", "idxcount");
            counter++;

            sape.filters.decorate(r[i], prefs.getCharPref("bgcolor"));
        }
    }
    if (counter > 0)
        st.showAlert(st.str('nice'), st.str('links.checked') + ' ' + counter, 0);
    else
        st.showAlert(st.str('nice'), st.str('links.no'), 0);
};

//------------------------------------------------------------------------------
// Функция нестрогого сравнения
//------------------------------------------------------------------------------

sape.filters.morf = function(text1, text2)
{
    if  (text1 == text2) return true;
    if  (!sape.filters.amorf) return false;

    var  ml = Math.min(text1.length, text2.length);
    if  (ml < 4) return false;

    if  (Math.abs(text1.length - text2.length) < 2)
    {
        if (text1.substr(0, ml-1) == text2.substr(0, ml-1)) return true;
    }
    return (sape.stemmer.Snowball(text1) == sape.stemmer.Snowball(text2));
};

//------------------------------------------------------------------------------
// Массив слов для анализа
//------------------------------------------------------------------------------

sape.filters.clearText = function(cell)
{
    var container = sape.toolbar.getTextCell(cell);
    var text = (container)? container.textContent : "";

    text = sape.toolbar.html_entity_decode(text).trim();

    return text;
};

sape.filters.wordArray = function(cell)
{
    var f = sape.filters;
    var a = new Array();

    var text = f.clearText(cell);

    if (!text.length) return a;

    text = text.replace(/[^0-9a-z\u0430-\u044F\u0451]+/gi, " ").replace(/\s\s+/g, " ").trim().toLowerCase();

    var sa = text.split(" ");
    for (var j=0; j < sa.length; j++)
    {
        if (sa[j].length > 2) a.push(sa[j]);
    }
    return a;
};


//------------------------------------------------------------------------------
// Три одинаковых слова с учетом морфологии
//------------------------------------------------------------------------------

sape.filters[1] = function(row)
{
    var f   = sape.filters;
    var col = row.cells;

    var checkbox = sape.toolbar.getCheckbox(col[f.layout.check]);
    if (!checkbox || checkbox.checked) return 0;

    var a = f.wordArray(col[f.layout.text]);

    for (var c=0; c < a.length; c++)
    {
            var counter = 1;
            for (var d = c+1; d < a.length; d++)
            {
                if (f.morf(a[c], a[d])) counter++;
            }
            if  (counter > f.repeat - 1)
            {
                f.decorate(row, f.bgcolor);
                checkbox.checked = true;

                return 1;
            }
    }
    return 0;
};

//------------------------------------------------------------------------------
// Две пары с учетом морфологии
//------------------------------------------------------------------------------

sape.filters[2] = function(row)
{
    var f   = sape.filters;
    var col = row.cells;

    var checkbox = sape.toolbar.getCheckbox(col[f.layout.check]);
    if (!checkbox || checkbox.checked) return 0;

    var a = f.wordArray(col[f.layout.text]);

    var counter = 0;
    for (var c=0; c < a.length - 2; c++)
    {
         for (var d=c+2; d < a.length-1; d++)
         {
                if (f.morf(a[c], a[d]) && f.morf(a[c+1], a[d+1]))
                {
                    counter++;
                    break;
                }
                if (f.morf(a[c], a[d+1]) && f.morf(a[c+1], a[d]))
                {
                    counter++;
                    break;
                }
        }
        if (counter > 0)
        {
            f.decorate(row, f.bgcolor);
            checkbox.checked = true;

            return 1;
        }
  	}
    return 0;
};

//------------------------------------------------------------------------------
// Длина текста больше 50 символов
//------------------------------------------------------------------------------

sape.filters[3] = function(row)
{
    var f   = sape.filters;
    var col = row.cells;

    var checkbox = sape.toolbar.getCheckbox(col[f.layout.check]);
    if (!checkbox || checkbox.checked) return 0;

    var text = f.clearText(col[f.layout.text]);

    if (text.length > 50)
    {
        f.decorate(row, f.bgcolor);
        checkbox.checked = true;

        return 1;
    }
    return 0;
};

//------------------------------------------------------------------------------
// Длина текста больше 75 символов
//------------------------------------------------------------------------------

sape.filters[4] = function(row)
{
    var f   = sape.filters;
    var col = row.cells;

    var checkbox = sape.toolbar.getCheckbox(col[f.layout.check]);
    if (!checkbox || checkbox.checked) return 0;

    var text = f.clearText(col[f.layout.text]);

    if (text.length > 75)
    {
        f.decorate(row, f.bgcolor);
        checkbox.checked = true;

        return 1;
    }
    return 0;
};

//------------------------------------------------------------------------------
// Заявки без русских букв
//------------------------------------------------------------------------------

sape.filters[5] = function(row)
{
    var f   = sape.filters;
    var col = row.cells;

    var checkbox = sape.toolbar.getCheckbox(col[f.layout.check]);
    if (!checkbox || checkbox.checked) return 0;

    var text = f.clearText(col[f.layout.text]);

    if (text.length && (text.length == text.replace(/[\u0430-\u044F]+/ig, "").length))
    {
        f.decorate(row, f.bgcolor);
        checkbox.checked = true;

        return 1;
    }
    return 0;
};

//------------------------------------------------------------------------------
// Два слова подряд с учетом морфологии
//------------------------------------------------------------------------------

sape.filters[8] = function(row)
{
    var f   = sape.filters;
    var col = row.cells;

    var checkbox = sape.toolbar.getCheckbox(col[f.layout.check]);
    if (!checkbox || checkbox.checked) return 0;

    var a = f.wordArray(col[f.layout.text]);

    for (var c=0; c < a.length-1; c++)
    {
         if (f.morf(a[c], a[c+1]))
         {
                f.decorate(row, f.bgcolor);
                checkbox.checked = true;

                return 1;
         }
  	}
    return 0;
};

//------------------------------------------------------------------------------
// Контроль пунктуации
//------------------------------------------------------------------------------

sape.filters[11] = function(row)
{
    var f   = sape.filters;
    var col = row.cells;

    var checkbox = sape.toolbar.getCheckbox(col[f.layout.check]);
    if (!checkbox || checkbox.checked) return 0;

    var text = f.clearText(col[f.layout.text]);

    if (!text.length) return 0;

    var checkit = false;

    if (f.chkspace && !checkit)
    {
        checkit = (text.length >  text.replace(/^\s+/g, "").replace(/\s+$/g, "").replace(/\s+/g, " ").replace(/\&nbsp\;/g, "").replace("\xA0", "").length);
    }
    if (f.chkdot && !checkit)
    {
        checkit = (text.replace(/^\s+/g, "").match(/^[^0-9a-z\u0430-\u044F\"\']+/i) !== null);
    }
    if (f.chkcomma && !checkit)
    {
        var m = text.replace(/\.$/g, "").match(/[\.|\,|\!|\?|\:|\;]+/g);
        if (m !== null) checkit = (m.length > 3);
    }
    if (checkit)
    {
        f.decorate(row, f.bgcolor);
        checkbox.checked = true;

        return 1;
    }
    return 0;
};

//------------------------------------------------------------------------------
// Заявки заглавными буквами
//------------------------------------------------------------------------------

sape.filters[12] = function(row)
{
    var f   = sape.filters;
    var col = row.cells;

    var checkbox = sape.toolbar.getCheckbox(col[f.layout.check]);
    if (!checkbox || checkbox.checked) return 0;

    var text = f.clearText(col[f.layout.text]);

    if (text.length && (text.length == text.replace(/[a-z\u0430-\u044F\u0451]+/g, "").length))
    {
        f.decorate(row, f.bgcolor);
        checkbox.checked = true;

        return 1;
    }
    return 0;
};

//------------------------------------------------------------------------------
// Регулярка для текста заявки
//------------------------------------------------------------------------------

sape.filters[13] = function(row)
{
    var f   = sape.filters;
    var col = row.cells;

    var checkbox = sape.toolbar.getCheckbox(col[f.layout.check]);
    if (!checkbox || checkbox.checked) return 0;

    var text = f.clearText(col[f.layout.text]);
    if (!text.length) return 0;

    if (f.keycheck)
    {
        if (f.regexp && f.regexp.length)
        {
            var exp = (f.sensitive)? new RegExp(sape.toolbar.utf8.decode(f.regexp), '') : new RegExp(sape.toolbar.utf8.decode(f.regexp), 'i');
            try
            {
                if (exp.test(text))
                {
                    f.decorate(row, f.bgcolor);
                    checkbox.checked = true;
                    return 1;
                }
            }
            catch (err) {}
        }
        var stopword = sape.external.searchKeys(text, f.stoplist);
        if (stopword)
        {
            f.decorate(row, f.bgcolor);
            checkbox.checked = true;
            checkbox.title = stopword;
            return 1;
        }
    }
    return 0;
};