var sape = sape || {};

if (!sape.ahrefs) sape.ahrefs =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    lay: {},
    img: "chrome://wmsape/skin/ahrefs.png",
    check: {},
    limit: {}
};

sape.ahrefs.firstQuery = function(callback)
{
    var st = sape.toolbar, me = sape.ahrefs;

    var URI = st.getURI('https://ahrefs.com/site-explorer/');

    var req = new XMLHttpRequest();
        req.open('GET', 'https://ahrefs.com/toolbar/script.js?source=' + encodeURIComponent(URI.asciiSpec) + '&v=0.2.21&_=' + (new Date()).getTime(), true);
        req.timeout = 15000;
        req.withCredentials = true;
        req.setRequestHeader('Referer', URI.asciiSpec);

    req.onreadystatechange = function(evt)
    {
        if (req.readyState == 4)
        {
            me.next(10);
        }
    };
    req.send(null);
};

sape.ahrefs.run = function(link, place, row)
{
    var st = sape.toolbar, me = sape.ahrefs;

    var img = me.doc.createElement('img');
        img.src = 'chrome://wmsape/skin/ajax-loader.gif';

    var loader = row.querySelector('div.ahrefs-loader') || me.doc.createElement('div');
        loader.className = "ahrefs-loader";
        loader.textContent = "";
        loader.appendChild(img);

    if (loader.parentNode && me.cached(link, place, row))
    {
        loader.parentNode.removeChild(loader);
        return;
    }

    var URI = st.getURI(link);
    var data = {UR: 'n/a', BL: 'n/a', RD: 'n/a', DDR: 'n/a', DBL: 'n/a', DRD: 'n/a', AR: 'n/a'};

    var dataReq = function()
    {
        var req = new XMLHttpRequest();
            req.open('GET', 'https://ahrefs.com/toolbar/header?target=' + encodeURIComponent(URI.asciiSpec) + '&Version=' + (new Date()).getTime() + Math.floor(Math.random() * 1000000), true);
            req.responseType = "document";
            req.timeout = 30000;
            req.withCredentials = true;
            req.setRequestHeader('Referer', URI.asciiSpec);

        var cleanValue = function(s)
        {
            var result = s.trim().replace(/,/g, '');
            if (result.match(/K$/))
            {
                result = result.replace(/K$/, '') + '000';
            }
            if (result.match(/M$/))
            {
                result = result.replace(/M$/, '') + '000000';
            }
            return result;
        };

        var correct = 0;
        req.onreadystatechange = function(evt)
        {
            if (req.readyState == 4)
            {
                if (loader && loader.parentNode)
                {
                    loader.parentNode.removeChild(loader);
                }
                if (req.status == 200 && req.response)
                {
                    if (req.response.body && req.response.body.textContent.indexOf('Please login') > -1)
                    {
                        me.inProgress = 0;
                        row.removeAttribute('ahrefs');
                        st.showAlert(st.str('ahrefs.auth'), st.str('ya.stop'), 2, me.img);
                        return;
                    }
                    if (req.response.body && req.response.body.textContent.indexOf('Please wait for a minute') > -1)
                    {
                        me.inProgress = 0;
                        row.removeAttribute('ahrefs');
                        st.showAlert(st.str('ahrefs.503'), st.str('ya.stop'), 2, me.img);
                        return;
                    }
                    var li = req.response.getElementsByTagName('li');

                    for (var i=0; i < li.length; i++)
                    {
                        var cite = li[i].querySelector('cite');
                        if (cite)
                        {
                            if (li[i].innerHTML.indexOf("URL Rating") > -1)
                                data.UR = cleanValue(cite.textContent);

                            if (li[i].innerHTML.indexOf("Domain Rating") > -1)
                                data.DDR = cleanValue(cite.textContent);

                            if (li[i].innerHTML.indexOf("Ahrefs Rank") > -1)
                                data.AR = cleanValue(cite.textContent);

                            if (li[i].innerHTML.indexOf("Backlinks") > -1)
                            {
                                if (li[i].parentNode.className === '')
                                    data.BL = cleanValue(cite.textContent);
                                else
                                    data.DBL = cleanValue(cite.textContent);
                            }
                            if (li[i].innerHTML.indexOf("Referring Domains") > -1)
                            {
                                if (li[i].parentNode.className === '')
                                    data.RD = cleanValue(cite.textContent);
                                else
                                    data.DRD = cleanValue(cite.textContent);
                            }
                        }
                    }

                    if (st.cache.enabled && li.length)
                        st.cache.push(URI.spec, 'ahrefs', JSON.stringify(data));

                    me.decorate(link, place, row, data);
                    me.empty = 0;
                    correct = 1;
                }
                if (req.status == 200 && !req.response)
                {
                    me.empty = me.empty + 1;
                }
                if ((req.status == 503) || (me.empty == 3))
                {
                    me.inProgress = 0;
                    row.removeAttribute('ahrefs');
                    st.showAlert(st.str('ahrefs.503'), st.str('ya.stop'), 2, me.img);

                    return;
                }
                if (!correct)
                {
                    me.decorate(link, place, row, data);
                }
                me.next();
            }
        };
        req.send(null);
    };

    place.appendChild(loader);
    dataReq();
};

sape.ahrefs.decorate = function(link, place, row, data)
{
    var st = sape.toolbar, me = sape.ahrefs;

    var newLink = function(text, href, className)
    {
        var ln = place.ownerDocument.createElement('a');
            ln.setAttribute('href', href);
            ln.setAttribute('target', '_blank');
            if (className)
            {
                ln.className = className;
            }
            ln.textContent = text;
        return ln;
    };

    var exactURL  = 'https://ahrefs.com/site-explorer/overview/v2/exact/fresh?target=' + encodeURIComponent(link);

    var div = row.querySelector('div.ahrefPlace') || me.doc.createElement('div');
        div.className = 'ahrefsPlace';
        div.textContent = '';

    var DDRClass = null;
    if (isFinite(data.DDR))
    {
        DDRClass = (parseFloat(data.DDR) < me.limit.drank)? 'bold_red' : 'bold_green';
    }
    var URClass = null;
    if (isFinite(data.UR))
    {
        URClass = (parseFloat(data.UR) < me.limit.rank)? 'bold_red' : 'bold_green';
    }

    div.appendChild(me.doc.createTextNode('URL\xA0Rating:\xA0'));
    div.appendChild(newLink(data.UR, exactURL, URClass));
    div.appendChild(me.doc.createElement('br'));

    div.appendChild(me.doc.createTextNode('Domain\xA0Rating:\xA0'));
    div.appendChild(newLink(data.DDR, exactURL, DDRClass));
    div.appendChild(me.doc.createElement('br'));

    place.appendChild(div);

    me.checkParams(data, row);
};

sape.ahrefs.checkParams = function(data, row)
{
    var st = sape.toolbar, me = sape.ahrefs;

    var checkbox = st.getCheckbox(row.cells[me.lay.check]);
    if (!checkbox || checkbox.checked) return;

    var a = me.check.rank  && ((isFinite(data.UR)  && (parseFloat(data.UR)  < me.limit.rank))  || (!isFinite(data.UR) && me.check.na));
    var b = me.check.drank && ((isFinite(data.DDR) && (parseFloat(data.DDR) < me.limit.drank)) || (!isFinite(data.DDR) && me.check.na));

    var c = (me.check.both && me.check.rank && me.check.drank)? a && b : a || b;
    if (c)
    {
        me.counter++;
        checkbox.checked = true;
        checkbox.setAttribute('reason', 'ahrefs');
    }
};

sape.ahrefs.cached = function(link, place, row)
{
    var st = sape.toolbar, me = sape.ahrefs;

    if (st.cache.enabled)
    {
        var URI = st.getURI(link);

        var data = st.cache.pop(URI.spec, 'ahrefs');
        if (data !== null)
        {
            me.decorate(URI.spec, place, row, JSON.parse(data));
            return true;
        }
    }
    return false;
};

sape.ahrefs.nextone = function()
{
    var st = sape.toolbar, me = sape.ahrefs;

    if (!me.doc || !me.doc.defaultView) return;

    var row = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i = 0; i < rl; i++)
    {
        if (row[i].hasAttribute('ahrefs')) continue;

        var col = row[i].cells;
        if ((me.lay.cols > 0) && (col.length < me.lay.cols)) continue;

        var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox || (checkbox.checked && me.skip)) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var url = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(url)) continue;

        row[i].setAttribute('ahrefs', '1');

        var aURI = st.getURI(url);
        var pURL = (me.check.domain)? aURI.prePath : aURI.asciiSpec;

        if (me.cached(pURL, col[me.lc], row[i])) continue;

        me.run(pURL, col[me.lc], row[i]);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.finish'), 2, me.img);
    }
};

sape.ahrefs.next = function()
{
    var me = sape.ahrefs, timeout = (arguments.length)? arguments[0] : me.timeout + Math.floor(Math.random() * me.timeout);
    if (me.inProgress)
    {
        sape.toolbar.setTimer(me.nextone, timeout);
    }
};

sape.ahrefs.unload = function()
{
    var me = sape.ahrefs;
    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    me.doc = me.inProgress = 0;
};

sape.ahrefs.start = function()
{
    var st = sape.toolbar, me = sape.ahrefs, doc = st.getDocument();
    if (!st.inside(doc))
    {
        st.openService('AH');
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, me.img);
        return;
    }
    if (me.doc) me.unload();

    var lay = st.layout(st.getDocument());

    if ((me.lc = (lay.url == -1)? lay.link : lay.url) < 0) return;

    me.lay = lay;
    me.urls = [];

    me.doc = st.getDocument();
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    var prefs = st.prefs();
    me.timeout        = prefs.getIntPref("ahrefs.timeout");
    me.limit.rank     = prefs.getIntPref("ahrefs.limit.rank");
    me.limit.drank    = prefs.getIntPref("ahrefs.limit.drank");
    me.check.rank     = prefs.getBoolPref("ahrefs.check.rank");
    me.check.drank    = prefs.getBoolPref("ahrefs.check.drank");

    me.check.na       = prefs.getBoolPref("mozrank.check.na");
    me.check.domain   = prefs.getBoolPref("mozrank.check.domain");
    me.skip           = prefs.getBoolPref("re.check");
    me.empty          = 0;

    me.check.both     = prefs.getBoolPref("ahrefs.check.both") && me.check.rank && me.check.drank;

    me.counter   = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, me.img);

    me.firstQuery();
};