var sape = sape || {};

if (!sape.antigate) sape.antigate =
{
    API: '',
    host: 'antigate.com',
    soft_id: '',
    queue: [],
    queueTimer: null,
    stopCounter: {yandex: 0, google: 0}
};

sape.antigate.init = function()
{
    var st = sape.toolbar, me = sape.antigate;
    var prefs = st.prefs();

    me.API  = prefs.getCharPref("antigate.api").replace(/(^\s+)|(\s+$)/, '');
    me.host = prefs.getCharPref("antigate.host").replace(/(^\s+)|(\s+$)/, '').toLowerCase();
    me.mode = prefs.getIntPref("antigate.mode");
    me.soft_id = '';

    if (me.host.search(/^http/i) > -1)
    {
        me.host = me.host.split('/')[2];
    }
    if (!me.host.length)
    {
        me.host = 'antigate.com';
    }
    if (!me.API.length && me.mode == 2)
    {
        me.mode = 0;
    }
    if (me.host.indexOf('anti-captcha.com') > -1) me.soft_id = '150';
    if (me.host.indexOf('antigate.com') > -1)     me.soft_id = '150';
    if (me.host.indexOf('ripcaptcha.com') > -1)   me.soft_id = '1229';
    if (me.host.indexOf('rucaptcha.com') > -1)    me.soft_id = '113';
    if (me.host.indexOf('captcha24.com') > -1)    me.soft_id = '901';

    return +(me.mode > 0);
};

sape.antigate.getImage = function(url)
{
    var ioserv  = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    var channel = ioserv.newChannel2(url, null, null, null, null, null, 0, 3);
    var stream  = channel.open();

    if (channel instanceof Components.interfaces.nsIHttpChannel && channel.responseStatus != 200 && channel.responseStatus != 302) return "";

    var bstream = Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);
        bstream.setInputStream(stream);

    var data = '', size = 0;
    while ((size = bstream.available()) > 0) data += bstream.readBytes(size);

    return data;
};

sape.antigate.queueManager = function()
{
    var ag = sape.antigate;
    if (ag.queueTimer && !ag.queue.length)
    {
        ag.queueTimer.cancel();
        return;
    }
    while (ag.queue.length)
    {
        var task = ag.queue.shift();

        if (!task.caller || (!task.caller.doc)) continue;
        if (!task.ID) ag.recognize(task, 'base64');
        if (task.ID && !task.code) ag.check(task);
        if (task.ID &&  task.code) ag.send(task);
    }
};

sape.antigate.queueStart = function(task)
{
    var ag = sape.antigate;
    if (task) ag.queue.push(task);
    if (!ag.queueTimer)
    {
        ag.queueTimer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
    }
    ag.queueTimer.initWithCallback({notify: function(timer){sape.antigate.queueManager();}}, 5000, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
};

sape.antigate.recognize = function(task, method)
{
    var st = sape.toolbar, ag = sape.antigate, nl = "\r\n", nl2 = "\r\n\r\n";
    var boundary = "XX" + Math.random();

    var data  = '--' + boundary + nl;
        if (method == 'post')
        {
            data += 'Content-Disposition: form-data; name="method"' + nl2 + 'post' + nl;
        }
        else
        {
            data += 'Content-Disposition: form-data; name="method"' + nl2 + 'base64' + nl;
        }
        data += '--' + boundary + nl;
        data += 'Content-Disposition: form-data; name="key"' + nl2 + sape.antigate.API + nl;
        data += '--' + boundary + nl;
        if (sape.antigate.soft_id.length)
        {
            data += 'Content-Disposition: form-data; name="soft_id"' + nl2 + sape.antigate.soft_id + nl;
            data += '--' + boundary + nl;
        }
        if (task.host.indexOf('google') == -1)
        {
            data += 'Content-Disposition: form-data; name="is_russian"' + nl2 + '1' + nl;
            data += '--' + boundary + nl;
            data += 'Content-Disposition: form-data; name="language"' + nl2 + '1' + nl;
            data += '--' + boundary + nl;
        }
        if (method == 'post')
        {
            data += 'Content-Disposition: form-data; name="file"; filename="capcha.gif"' + nl + 'Content-Type: image/gif' + nl2 + atob(task.imgData) + nl;
        }
        else
        {
            data += 'Content-Disposition: form-data; name="body"' + nl2 + task.imgData + nl;
        }
        data += '--' + boundary + '--';

    var req = new XMLHttpRequest();
        req.open('POST', 'http://' + sape.antigate.host + '/in.php', true);
        //req.setRequestHeader('Content-Type', 'multipart/form-data; boundary=' + boundary);
        //req.setRequestHeader('Content-Length', data.length);
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                if (req.responseText.match(/^OK/))
                {
                    task.ID = req.responseText.split('|')[1].trim();
                    ag.queueStart(task);

                    st.showAlert(st.str("ag.recognize"), st.str("captcha"), 0, task.imgInfo);
                    return;
                }
                else
                {
                    if (req.responseText.match(/NO_SLOT_AVAILABLE/))
                    {
                          ag.queueStart(task);
                          return;
                    }
                    var msg = '';
                    if (req.responseText.match(/IMAGE_TYPE_NOT_SUPPORTED/) && (method == 'base64'))
                    {
                        ag.recognize(task, 'post');
                        return;
                    }
                    if (req.responseText.match(/WRONG_USER_KEY|KEY_DOES_NOT_EXIST/))
                    {
                        msg = st.str("ag.key.error");
                        ag.queue = [];
                    }
                    if (req.responseText.match(/IP_NOT_ALLOWED/))
                    {
                        msg = st.str("ag.ip.error");
                        ag.queue = [];
                    }
                    if (req.responseText.match(/ZERO_CAPTCHA_FILESIZE|TOO_BIG_CAPTCHA_FILESIZE|WRONG_FILE_EXTENSION/))
                    {
                        msg = st.str("ag.format.error");
                    }
                    if (msg.length)
                    {
                        st.showAlert(msg, st.str("captcha"), 0, task.imgInfo);
                        if (task.caller && task.caller.unload) task.caller.unload();
                    }
                    else st.showAlert(req.responseText, st.str("captcha"), 0, task.imgInfo);
                }
            }
            else
            {
                sape.antigate.queueStart(task);
            }
        }
    };
    try
    {
        var blob = new Blob([data], {type: 'multipart/form-data; boundary=' + boundary});
        req.send(blob);
    }
    catch(e)
    {
      req.abort();
    }
};

sape.antigate.check = function(task)
{
    var st = sape.toolbar;

    var req = new XMLHttpRequest();
    req.open('GET', 'http://' + sape.antigate.host + '/res.php?action=get&key=' + sape.antigate.API + '&id=' + task.ID, true);
    req.overrideMimeType('Content-Type: text/plain; charset=utf-8');
    req.timeout = 30000;
    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                var result = req.responseText.replace(/(^[\s\n\r]+)|([\s\n\r]+$)/g, '');
                if (result.match(/^OK/))
                {
                    task.code = result.split('|')[1];
                    sape.antigate.send(task);
                    return;
                }
                if (!result.match(/^ERROR/))
                {
                    sape.antigate.queueStart(task);
                    return;
                }
                else
                {
                    st.showAlert(st.str("ag.norec"), st.str("captcha"), 0, task.imgInfo);
                    if (task.caller.unload) task.caller.unload();
                }
            }
        }
    };
    try {
      req.send(null);
    }
    catch(e) {
      req.abort();
    }
};

sape.antigate.sendBing = function(task)
{
    var st = sape.toolbar;
    var sendURL = 'http://' + task.host + '/challenge';
    var postData = 'encanswer=' + task.encanswer + '&useranswer=' + task.code +  + '&IG=' + task.IG + '&query=%25%2F&submit=%D0%9F%D1%80%D0%BE%D0%B4%D0%BE%D0%BB%D0%B6%D0%B8%D1%82%D1%8C';

    var req = new XMLHttpRequest();

    req.open('POST', sendURL, true);
    req.setRequestHeader('Referer', task.referer);
    req.timeout = 30000;
    req.onreadystatechange = function(aEvt)
    {
        if (req.readyState == 4)
        {
            if (task.caller.cTimer && task.caller.doc)
            {
                task.caller.cTimer = 0;
                task.caller.inProgress = 1;

                if (task.caller.nextone) task.caller.nextone();
            }
        }
    };
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-Length', postData.length);
    req.send(postData);
};

sape.antigate.send = function(task)
{
    var st = sape.toolbar, ag = sape.antigate, sendURL = '';
    if (task.retpath === '') task.retpath = task.referer;

    if (task.host.indexOf('yandex') > -1)  sendURL = 'https://' + task.host + '/checkcaptcha?key=' + encodeURIComponent(task.key) + '&retpath=' + encodeURIComponent(task.retpath) + '&rep=' + encodeURIComponent(task.code);
    if (task.host.indexOf('google') > -1)  sendURL = 'https://' + task.host + '/sorry/' + task.action + '?q=' + task.q + '&continue=' + encodeURIComponent(task.retpath) + '&id=' +  task.key + '&captcha=' + task.code + '&submit=%D0%9E%D1%82%D0%BF%D1%80%D0%B0%D0%B2%D0%B8%D1%82%D1%8C';
    if (task.host.indexOf('rambler') > -1) sendURL = 'http://' + task.host + '/check_captcha?path=' + encodeURIComponent(task.retpath) + '&key=' + encodeURIComponent(task.key) + '&text=' + encodeURIComponent(task.code);
    if (task.host.indexOf('bing.com') > -1)
    {
        sape.antigate.sendBing(task);
        return;
    }

    var req = new XMLHttpRequest();
        req.open('GET', sendURL, true);
        req.setRequestHeader('Referer', task.referer);
        req.timeout = 30000;
        req.onreadystatechange = function(aEvt)
        {
            if (req.readyState == 4)
            {
                if (task.caller.cTimer && task.caller.doc)
                {
                    var isCaptcha = (task.host.indexOf('google') > -1)? sape.google.isCaptcha(req) : sape.yandex.isCaptcha(req);
                    var stopNow = 0;

                    task.caller.cTimer = 0;
                    task.caller.inProgress = 1;

                    if (task.host.indexOf('google') > -1)
                    {
                        ag.stopCounter.google = (isCaptcha)? ag.stopCounter.google + 1 : 0;
                        stopNow = (ag.stopCounter.google > 2);
                    }
                    else
                    {
                        ag.stopCounter.yandex = (isCaptcha)? ag.stopCounter.yandex + 1 : 0;
                        stopNow = (ag.stopCounter.yandex > 2);
                    }

                    if (task.callback && !isCaptcha)
                    {
                        task.callback(req);
                    }
                    else
                    {
                        if (isCaptcha && stopNow)
                        {
                            st.showAlert(st.str("ag.norec"), st.str("captcha"), 0, task.imgInfo);
                            if (task.host.indexOf('google') > -1)
                            {
                                ag.stopCounter.google = 0;
                            }
                            else
                            {
                                ag.stopCounter.yandex = 0;
                            }
                            if (task.caller.unload) task.caller.unload();
                        }
                        else
                        {
                            if (task.caller.nextone) task.caller.nextone();
                        }
                    }
                }
            }
        };
    try {
        req.send(null);
    }
    catch(e) {
        req.abort();
    }
};

sape.antigate.manual = function(task)
{
    task.ondialogaccept = function()
    {
        if (task.code.length)
        {
            sape.antigate.send(task);
        }
        else
        {
            task.ondialogcancel();
        }
    };
	task.ondialogcancel = function()
    {
        var st = sape.toolbar;

        st.showAlert(st.str("ag.norec"), st.str("captcha"), 0, task.imgInfo);
        if (task.caller.unload)
        {
            task.caller.unload();
        }
    };
    window.openDialog('chrome://wmsape/content/captcha.xul','','centerscreen,chrome,resizable,dependent,dialog=yes', task);
};

sape.antigate.addTask = function(caller, req, callback)
{
    var st = sape.toolbar;
    var exp, task =
    {
        ID: 0,        // ID капчи в antigate
        imgURL: '',   // адрес картинки с капчей
        imgData: '',  // картинка капчи
        code: '',     // строка разгаданной капчи
        type: '',     // тип капчи
        key: '',      // дополнительный параметр формы (key для яндекса и tut.by, id для google)
        referer: '',
        retpath: '',
        action: 'CaptchaRedirect',
        imgInfo: 'chrome://wmsape/skin/yandex.png'
    };
    for (var i=0; i < sape.antigate.queue.length; i++)
    {
        if (sape.antigate.queue[i].caller == caller) return;
    }
    task.host = req.channel.URI.host;
    task.path = req.channel.URI.path;
    task.referer = req.channel.URI.spec;

    if (task.host.match(/\bbing\.com$/i) && task.path.match(/^[\/]challenge/i))
    {
        task.imgInfo = 'chrome://wmsape/skin/bing.png';

        exp = /challengepic\?encanswer\=([0-9A-F]+)/i;
        exp = req.responseText.match(exp);
        if (exp)
        {
            task.imgURL    = 'http://' + task.host + '/' + exp[0].trim();
            task.encanswer = exp[1].trim();
        }
        exp = /name\=\"IG\"[^>]*value\=\"([0-9A-F]+)/i;
        exp = req.responseText.match(exp);
        if (exp)
        {
            task.IG = task.key = exp[1].trim();
        }
    }
    if (task.host.match(/\byandex\./) && task.path.match(/^[\/]showcaptcha/))
    {
        exp = /name\=\"key\"[^>]*value\=\"([^\"]+)/;
        exp = req.responseText.match(exp);
        if (exp)
        {
            task.key = exp[1];
        }
        exp = /\/captchaimg\?[^\"]+/;
        exp = req.responseText.match(exp);
        if (exp)
        {
            task.imgURL = 'http://' + task.host + st.html_entity_decode(exp[0].trim());
        }
        exp = /[a-z\.]+.yandex.net\/image\?key=[^\"]+/;
        exp = req.responseText.match(exp);
        if (exp)
        {
            task.imgURL = 'http://' + st.html_entity_decode(exp[0].trim());
        }
        exp = /name\=\"retpath\"[^>]*value\=\"([^\"]+)/;
        exp = req.responseText.match(exp);
        if (exp)
        {
            task.retpath = exp[1].replace(/\&amp;/g, '&');
        }
    }
    if (task.host.match(/\bgoogle\./) && task.path.match(/^[\/]sorry[\/]/))
    {
        task.imgInfo = 'chrome://wmsape/skin/google.png';

        exp = /['"]id['"]\s*value\=['"]([^'"]+)['"]/;
        exp = req.responseText.match(exp);
        if (exp)
        {
            task.key = exp[1];
        }
        exp = /['"]q['"]\s*value\=['"]([^'"]+)['"]/;
        exp = req.responseText.match(exp);
        if (exp)
        {
            task.q = exp[1];
        }
        exp = /action\=['"]([a-z]+)['"]/i;
        exp = req.responseText.match(exp);
        if (exp)
        {
            task.action = exp[1];
        }
        exp = /[\/]sorry[\/]image\?id=[^'"]+/i;
        exp = req.responseText.match(exp);
        if (exp)
        {
            task.imgURL = 'https://' + task.host + st.html_entity_decode(exp[0]);
        }
        if (req.channel.originalURI.spec.indexOf('Captcha') == -1)
        {
            task.retpath = req.channel.originalURI.spec;
        }
    }
    if (task.host.match(/\brambler\.ru/))
    {
        exp = /name\=\"key\"[^>]*value\=\"([^\"]+)/;
        exp = req.responseText.match(exp);
        if (exp)
        {
            task.key = exp[1];
        }
        exp = /[\/]captchaimg\?[^\"]+/;
        exp = req.responseText.match(exp);
        if (exp)
        {
            task.imgURL = 'http://yandex.ru' + st.html_entity_decode(exp[0]);
        }
        exp = /name\=\"path\"[^>]*value\=\"([^\"]+)/;
        exp = req.responseText.match(exp);
        if (exp)
        {
            task.retpath = exp[1].replace(/\&amp;/g, '&');
        }
    }

    var mode = st.prefs().getIntPref("antigate.mode");

    if (!mode)
    {
       st.showAlert(st.str('ya.stop'), st.str('captcha'), 2, task.imgInfo);
       if (caller.unload)
       {
           caller.unload();
       }
       return;
    }

    if (task.key.length && task.imgURL)
    {
        task.caller   = caller;
        task.callback = callback;
        if (mode == 2)
        {
            task.imgData  = btoa(sape.antigate.getImage(task.imgURL));
            sape.antigate.queueStart(task);
        }
        else
        {
            sape.antigate.manual(task);
        }
    }
    else
    {
       st.showAlert(st.str("ag.no.captcha"), st.str("captcha"), 2, task.imgInfo);
       if (caller.unload)
       {
           caller.unload();
       }
    }
};
