var sape = sape || {};

if (!sape.bing) sape.bing =
{
    bingurl: 'http://www.bing.com/search?q=',
    img: "chrome://wmsape/skin/bing.png",
    timeout: 250
};

sape.bing.isCaptcha = function(req)
{
    return (req.channel.URI.host.match(/\bbing\.com$/i) && req.channel.URI.path.match(/^[\/]challenge/i));
};

sape.bing.anticaptcha = function(me, req)
{
    var st = sape.toolbar;

    if (!me.inProgress) return;
    else me.inProgress = 0;

    if (sape.bing.antigate)
    {
        me.cTimer = 1;
        st.showAlert(st.str('ag.wait'), st.str('captcha'), 3, sape.bing.img);
        sape.antigate.addTask(me, req, null);
    }
    else
    {
        st.showAlert(st.str('ya.stop'), st.str('captcha'), 2, sape.bing.img);
    }
};

sape.bing.getResult = function(text)
{
    var res = text.match(/\"sb_count\"\sid\=\"count\">([^<]+)</);
    if (!res)
    {
        res = text.match(/\sclass\=\"sb_count\">([^<]+)</);
    }
    if (res)
    {
        var ret, txt = sape.toolbar.html_entity_decode(res[1]);
        if ((ret = txt.match(/[\d\s,]+/g)) !== null)
        {
            txt = ret[ret.length - 1].replace(/[^\d]+/g, '');
            return parseInt(txt, 10);
        }
    }
    if (text.indexOf('<li class="b_no">') > -1) return 0;
    if (text.indexOf('<div id="no_results">') > -1) return 0;
    if (text.indexOf('<div id="results"></div>') > -1) return 0;

    return -1;
};

sape.bing.next = function(me)
{
    var st = sape.toolbar;
    var timeout = (arguments.length > 1)? arguments[1] : sape.bing.timeout + Math.round(sape.bing.timeout * Math.random());

    if (me.inProgress) st.setTimer(me.nextone, timeout);
};

sape.bing.stop = function(me)
{
    if (me.inProgress || me.cTimer)
    {
        me.unload();
        return true;
    }
    else
        return false;
};

sape.bing.init = function()
{
    var st = sape.toolbar, me = sape.bing, prefs = st.prefs();

    me.skip     = prefs.getBoolPref("re.check");
    me.timeout  = Math.max(100, prefs.getIntPref("timeout.bing"));
    me.liveDays = prefs.getIntPref("livedays.gl");

    st.loadJS('antigate');
    me.antigate = sape.antigate.init();
};

sape.bing.nextrow = function(me)
{
    var st = sape.toolbar;
    if (!me.inProgress || !me.doc || !me.doc.defaultView) return;

    var row = me.doc.getElementsByTagName('tr');
    for (var i=0; i < row.length; i++)
    {
        if (row[i].hasAttribute(me.rowName)) continue;

        var col = row[i].cells;
        if (col.length !== me.lay.cols) continue;

        var as = col[me.lay.ico].querySelector('a.' + me.btnName);
		if (!as) continue;

		var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox || (sape.bing.skip && checkbox.checked)) continue;

        if (me.rowName == 'bing_l' && me.lastDate && sape.bing.liveDays > 0)
        {
            var linkDate = st.parseDate(col[me.lay.dc]);
            if (linkDate > me.lastDate) continue;
        }

        var a    = col[me.lc].getElementsByTagName('a');
        var link = st.getURL(a[me.lay.idx].getAttribute('href'));

        row[i].setAttribute(me.rowName, '1');

        var crow = row[i];
        if (me.cached(link, as, crow)) continue;

        me.query(link, as, crow);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.finish'), 2, sape.bing.img);
    }
};

sape.bing.placeButtons = function(me)
{
    var st = sape.toolbar;

    var row  = me.doc.getElementsByTagName('tr');
    for (var i = 0; i < row.length; i++)
    {
        if (row[i].hasAttribute(me.rowName))  continue;

        var col = row[i].cells;
        if (col.length !== me.lay.cols) continue;

        var as = col[me.lay.ico].querySelector('a.' + me.btnName);
		if (as) continue;

		var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var href = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var link = st.getURL(href);
        var btn  = me.button(link, row[i]);

        var yap = col[me.lay.ico].querySelector('.icon_in_yaca, .icon_in_dmoz, .icon_in_wl, .icon_wl, .icon_yal, .icon_bl, .icon_gbl, .icon_ya');
        if (yap)
        {
            yap.parentNode.insertBefore(btn, yap.nextSibling);
        }
        else
        {
            var div = col[me.lay.ico].querySelector('.page_icons') || me.doc.createElement('div');
                div.className = 'page_icons';
                div.appendChild(btn);

            col[me.lay.ico].appendChild(div);
        }

        if (me.rowName == 'bing_l' && me.lastDate && sape.bing.liveDays > 0)
        {
            var linkDate = st.parseDate(col[me.lay.dc]);
            if (linkDate > me.lastDate) continue;
        }
        if (me.cached(link, btn, row[i]))
        {
            row[i].setAttribute(me.rowName, '1');
        }
        col[me.lc].classList.remove('a_visited');
    }
    st.initDOM();
};

// ─────────────────────────────────────────────────────────────────────────────
// Проверка индексации страниц
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.bing.bp) sape.bing.bp =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    lay: {}
};

sape.bing.bp.button = function(link, row)
{
    var st = sape.toolbar, me = sape.bing.bp;

    var page = link.replace(/^http[^\/]*[\/]*/, '').replace(/^www\./i, '').replace(/\/$/, '');
    var q    = 'url:' + page + ' | url:www.' + page;
    var url  = sape.bing.bingurl + st.safeEncode(q).replace(/%20/g, '+') + '&form=OSDSRC';

    var as = me.doc.createElement('a');
        as.href = url;
        as.target = '_blank';
        as.className = 'icon_ya icon_bing_p';
        as.textContent = 'BP';

    return as;
};

sape.bing.bp.cached = function(link, place, row)
{
    var st = sape.toolbar, me = sape.bing.bp;
    if (st.cache.enabled)
    {
        var clink = link;
        var total = st.cache.pop(clink, 'bingp');
        if (total !== null)
        {
            if (+ total)
            {
                place.classList.add("icon_green");
            }
            else
            {
                place.classList.add("icon_red");

           		var checkbox = st.getCheckbox(row.cells[me.lay.check]);
                if (checkbox && !checkbox.checked)
                {
                    me.counter++;
                    checkbox.checked = true;
                    checkbox.setAttribute("reason", me.rowName);
                }
            }
            return true;
        }
    }
    return false;
};

sape.bing.bp.query = function(link, place, row)
{
    var st  = sape.toolbar, me = sape.bing.bp;
    var url = place.getAttribute("href");
    var clink = link;

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                if (sape.bing.isCaptcha(req))
                {
                    if (!me.cTimer)
                    {
                        sape.bing.anticaptcha(me, req);
                    }
                    row.removeAttribute(me.rowName);
                    return;
                }
                if (req.status == 200 && req.responseText.length)
                {
                    var total = sape.bing.getResult(req.responseText);
                    if (total > -1)
                    {
                        if (st.cache.enabled) st.cache.push(clink, 'bingp', total);
                        correct = 1;
                        if (+ total)
                        {
                            place.classList.add("icon_green");
                        }
                        else
                        {
                            place.classList.add("icon_red");

                       		var checkbox = st.getCheckbox(row.cells[me.lay.check]);
                            if (checkbox && !checkbox.checked)
                            {
                                me.counter++;
                                checkbox.checked = true;
                                checkbox.setAttribute("reason", me.rowName);
                            }
                        }
                    }
                }
                if (!correct)
                {
                    place.classList.add("icon_silver");
                }
                sape.bing.next(me);
        }
    };
    req.send(null);
};

sape.bing.bp.nextone = function()
{
   sape.bing.nextrow(sape.bing.bp);
};

sape.bing.bp.unload = function()
{
    var me = sape.bing.bp;
    if (me.doc && me.doc.defaultView) me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.bing.bp.start = function()
{
    var st = sape.toolbar, me = sape.bing.bp;

    var doc = st.getDocument();
    if (!st.inside(doc))
    {
        st.openService('BP');
        return;
    }
    if (sape.bing.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, sape.bing.img);
        return;
    }
    var lay = st.layout(doc);

    sape.bing.init();

    me.lay         = lay;
    me.lc          = (lay.url < 0)? lay.link : lay.url;
    me.counter     = 0;
    me.rowName     = 'bing_p';
    me.btnName     = 'icon_bing_p';

    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    if (me.lc == -1) return;
    sape.bing.placeButtons(me);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, sape.bing.img);

    sape.bing.next(me, 100);
    sape.bing.next(me, 1500);
};

// ─────────────────────────────────────────────────────────────────────────────
// Проверка индексации ссылок
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.bing.bl) sape.bing.bl =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    lay: {}
};

sape.bing.bl.gettext = function(cell)
{
    var st = sape.toolbar, result = "";
    var container = st.getTextCell(cell);

    var text  = container.innerHTML.replace(/[\r\n\f]*/g, '').replace(/\s\s+/g, ' ');
    var parts = text.split(/<\/?u[^>]*>/);

    while (parts.length)
    {
        text = parts.shift();
        text = text.replace(/<[^<>]+>/g, '');

        text = st.html_entity_decode(text);
        text = text.replace(/^[^0-9a-z\u0430-\u044F\u0451]+/i, '').replace(/[^0-9a-z\u0430-\u044F\u0451]+$/i, '');
        text = text.replace(/[""'']+/g, ' ').replace(/\s\s+/g, ' ').replace(/[\%\+]+/g, '" "');

        if (text.length > 2) result += '"' + text + '" ';
    }
    return result;
};

sape.bing.bl.cached = function(link, place, row)
{
    var st = sape.toolbar, me = sape.bing.bl;
    if (st.cache.enabled)
    {
        var text  = me.gettext(row.cells[me.tc]);
        var clink = link + '++' + text;
        var total = st.cache.pop(clink, 'bingl');
        if (total !== null)
        {
            if (+ total)
            {
                place.classList.add("icon_green");
            }
            else
            {
                place.classList.add("icon_red");

           		var checkbox = st.getCheckbox(row.cells[me.lay.check]);
                if (checkbox && !checkbox.checked)
                {
                    me.counter++;
                    checkbox.checked = true;
                    checkbox.setAttribute("reason", me.rowName);
                }
            }
            return true;
        }
    }
    return false;
};

sape.bing.bl.button = function(link, row)
{
    var st = sape.toolbar, me = sape.bing.bl;

    var col  = row.cells;
    var text = me.gettext(col[me.tc]);

    var page = link.replace(/^http[^\/]*[\/]*/, '').replace(/^www\./i, '').replace(/\/$/, '');
    var q    = '+' + text + ' (url:' + page + ' | url:www.' + page + ')';
    var url  = sape.bing.bingurl + st.safeEncode(q).replace(/%20/g, '+') + '&form=OSDSRC';

    var as = me.doc.createElement('a');
        as.href = url;
        as.target = '_blank';
        as.className = 'icon_ya icon_bing_l';
        as.textContent = 'BL';

    return as;
};

sape.bing.bl.query = function(link, place, row)
{
    var st  = sape.toolbar, me = sape.bing.bl;
    var url = place.getAttribute("href");

    var col   = row.cells;
    var text  = me.gettext(col[me.tc]);
    var clink = link + '++' + text;

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                if (sape.bing.isCaptcha(req))
                {
                    if (!me.cTimer)
                    {
                        sape.bing.anticaptcha(me, req);
                    }
                    row.removeAttribute(me.rowName);
                    return;
                }
                if (req.status == 200 && req.responseText.length)
                {
               		var checkbox = st.getCheckbox(col[me.lay.check]);

                    var total = sape.bing.getResult(req.responseText);
                    if (total > -1)
                    {
                        if (st.cache.enabled) st.cache.push(clink, 'bingl', total);
                        correct = 1;
                        if (+ total)
                        {
                            place.classList.add("icon_green");
                        }
                        else
                        {
                            place.classList.add("icon_red");

                            if (checkbox && !checkbox.checked)
                            {
                                me.counter++;
                                checkbox.checked = true;
                                checkbox.setAttribute("reason", me.rowName);
                            }
                        }
                    }
                }
                if (!correct)
                {
                    place.classList.add("icon_silver");

                    if (checkbox && !checkbox.checked && me.errcheck)
                    {
                        checkbox.checked = true;
                        me.counter++;
                    }
                }
                sape.bing.next(me);
        }
    };
    req.send(null);
};

sape.bing.bl.nextone = function()
{
   sape.bing.nextrow(sape.bing.bl);
};

sape.bing.bl.unload = function()
{
    var me = sape.bing.bl;
    if (me.doc && me.doc.defaultView) me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.bing.bl.start = function()
{
    var st = sape.toolbar, me = sape.bing.bl;

    if (sape.bing.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, sape.bing.img);
        return;
    }
    var doc = st.getDocument();
    if (!st.inside(doc)) return;

    var lay = st.layout(doc);
    if (lay.dc == -1) return;

    sape.bing.init();

    me.lay         = lay;
    me.lc          = (lay.link < 0)? lay.url : lay.link;
    me.tc          = lay.text;
    me.counter     = 0;
    me.rowName     = 'bing_l';
    me.btnName     = 'icon_bing_l';
    me.errcheck    = st.prefs().getBoolPref("gl.errors");

    me.lastDate = new Date();
    me.lastDate.setDate(me.lastDate.getDate() - sape.bing.liveDays);

    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    if (me.lc == -1) return;
    sape.bing.placeButtons(sape.bing.bl);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, sape.bing.img);

    sape.bing.next(me, 100);
    sape.bing.next(me, 1500);
};

// ─────────────────────────────────────────────────────────────────────────────
// Проверка индексации сайта
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.bing.bs) sape.bing.bs =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    lay: {}
};

sape.bing.bs.placeCounter = function(cell, count)
{
    var doc = cell.ownerDocument, s = doc.createTextNode("\x20[" + count + "]\x20");

    var b = doc.createElement('b');
        b.className = 'not-blocked-in-bing';
        b.title = sape.toolbar.str("bing.pages") + " Bing";
        b.textContent = 'B:';

    var root = cell.querySelector('.page_icons') || cell;
        root.appendChild(doc.createTextNode("\x20"));
        root.appendChild(b);
        root.appendChild(s);
};

sape.bing.bs.button = function(link, row)
{
    var st = sape.toolbar, me = sape.bing.bs;

    var host = link.split('/')[2].replace(/^www./i,'');
    var q    = "site:" + host;
    var url  = sape.bing.bingurl + st.safeEncode(q).replace(/%20/g, '+') + '&form=OSDSRC';

    var as = me.doc.createElement('a');
        as.href = url;
        as.target = '_blank';
        as.className = 'icon_ya icon_bing_s';
        as.textContent = 'BS';

    return as;
};

sape.bing.bs.cached = function(link, place, row)
{
    var st = sape.toolbar, me = sape.bing.bs;
    if (st.cache.enabled)
    {
        var host  = link.split('/')[2].replace(/^www./i,'');
        var clink = 'http://' + host + '/';
        var total = st.cache.pop(clink, 'bings');
        if (total !== null)
        {
            if (+ total)
            {
                place.classList.add("icon_green");
            }
            else
            {
                place.classList.add("icon_red");

           		var checkbox = st.getCheckbox(row.cells[me.lay.check]);
                if (checkbox && !checkbox.checked)
                {
                    me.counter++;
                    checkbox.checked = true;
                    checkbox.setAttribute("reason", me.rowName);
                }
            }
            if (!me.lay.black)
            {
                me.placeCounter(row.cells[me.lc], total.toString());
            }
            return true;
        }
    }
    return false;
};

sape.bing.bs.query = function(link, place, row)
{
    var st    = sape.toolbar, me = sape.bing.bs;
    var url   = place.getAttribute("href");
    var host  = link.split('/')[2].replace(/^www./i,'');
    var clink = 'http://' + host + '/';

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                if (sape.bing.isCaptcha(req))
                {
                    if (!me.cTimer)
                    {
                        sape.bing.anticaptcha(me, req);
                    }
                    row.removeAttribute(me.rowName);
                    return;
                }
                if (req.status == 200 && req.responseText.length)
                {
                    var total = sape.bing.getResult(req.responseText);
                    if (+ total > -1)
                    {
                        if (st.cache.enabled) st.cache.push(clink, 'bings', total);
                        correct = 1;
                        if (+ total)
                        {
                            place.classList.add("icon_green");
                        }
                        else
                        {
                            place.classList.add("icon_red");

                    		var checkbox = st.getCheckbox(row.cells[me.lay.check]);
                            if (checkbox && !checkbox.checked)
                            {
                                me.counter++;
                                checkbox.checked = true;
                                checkbox.setAttribute("reason", me.rowName);
                            }
                        }
                        me.placeCounter(row.cells[me.lc], total.toString());
                    }
                }
                if (!correct)
                {
                    place.classList.add("icon_silver");
                }
                sape.bing.next(me);
        }
    };
    req.send(null);
};

sape.bing.bs.nextone = function()
{
   sape.bing.nextrow(sape.bing.bs);
};

sape.bing.bs.unload = function()
{
    var me = sape.bing.bs;
    if (me.doc && me.doc.defaultView) me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.bing.bs.start = function()
{
    var st = sape.toolbar, me = sape.bing.bs;

    var doc = st.getDocument();
    if (!st.inside(doc))
    {
        st.openService('BS');
        return;
    }
    if (sape.bing.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, sape.bing.img);
        return;
    }
    var lay = st.layout(doc);

    sape.bing.init();

    me.lay         = lay;
    me.lc          = (lay.url < 0)? lay.link : lay.url;
    me.counter     = 0;
    me.rowName     = 'bing_s';
    me.btnName     = 'icon_bing_s';

    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    if (me.lc == -1) return;
    sape.bing.placeButtons(sape.bing.bs);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, sape.bing.img);

    sape.bing.next(me, 100);
    sape.bing.next(me, 1500);
};

