var sape = sape || {};

if (!sape.checker) sape.checker = {};

sape.checker.inverse = function()
{
    var st = sape.toolbar, doc = st.getDocument();

    var chkInverse = doc.getElementById("chkInverse");
    if (chkInverse)
        chkInverse.checked = false;

    var input = doc.querySelectorAll('#tablebody input[type="checkbox"]');
    for (var i=0; i < input.length; i++)
    {
        input[i].checked = !input[i].checked;
    }
    return false;
};

sape.checker.addurls = function()
{
    var st = sape.toolbar, doc = st.getDocument();

    var pages = doc.getElementById("urls").value;
    if (!pages.length) return;

    var page = pages.split("\n"), tablebody = doc.getElementById("tablebody");

    for (var i=0; i < page.length; i++)
    {
        var url = page[i].replace(/\r/g, "").trim();
        if (!url || !url.length)  continue;

        if (!url.match(/^https?\:/i))
        {
            if (url.indexOf('.') > -1) url = 'http://' + url;
            else continue;
        }

        var a = doc.createElement('a');
        try
        {
            var URI = st.getURI(url);

            a.setAttribute("href", URI.spec);
            a.textContent =  (URI.path == '/')? URI.host : URI.host + URI.path;
        }
        catch(ex)
        {
            a.setAttribute("href", url);
            a.textContent = url.replace(/^[^\/]+[\/]+/i, '').trim();
        }
        var c = doc.createElement('input');
            c.setAttribute("type", "checkbox");
        var td1 = doc.createElement('td');
            td1.appendChild(a);
        var td2 = doc.createElement('td');
            td2.className = 'ca';
        var td3 = doc.createElement('td');
            td3.className = 'ca';
        var td5 = doc.createElement('td');
            td5.appendChild(c);
        var tr = doc.createElement('tr');
            tr.appendChild(td1);
            tr.appendChild(td2);
            tr.appendChild(td3);
            tr.appendChild(td5);

        tablebody.appendChild(tr);
    }
};

sape.checker.init = function()
{
    var st = sape.toolbar, doc = (arguments.length)? arguments[0] : st.getDocument();

    var chkInverse = doc.getElementById("chkInverse");
    if (chkInverse)
        chkInverse.addEventListener("click", sape.checker.inverse, true);

    var btnAddURL = doc.getElementById("btnAddURL");
    if (btnAddURL)
        btnAddURL.addEventListener("click", sape.checker.addurls, true);
};
