var sape = sape || {};

if (!sape.checktrust) sape.checktrust =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    lay: {},
    img: "chrome://wmsape/skin/checktrust.png",
    check: {},
    limit: {}
};

sape.checktrust.run = function(link, place, row)
{
    var st = sape.toolbar, me = sape.checktrust;

    var img = me.doc.createElement('img');
        img.src = 'chrome://wmsape/skin/ajax-loader.gif';

    var loader = row.querySelector('div.checktrust-loader') || me.doc.createElement('div');
        loader.className = "checktrust-loader";
        loader.textContent = "";
        loader.appendChild(img);

    if (loader.parentNode && st.cache.enabled && me.cached(link, place, row))
    {
        loader.parentNode.removeChild(loader);
        return;
    }

    var URI = st.getURI(link);
    var data = {trust: 'n/a', spam: 'n/a'};

    var req = new XMLHttpRequest();
        req.open('GET', 'https://checktrust.ru/app.php?r=host/app/summary/basic&applicationKey=' + encodeURIComponent(me.apikey.trim()) + '&host=' + encodeURIComponent(URI.host), true);
        req.timeout = 30000;

    var correct = 0;
    req.onreadystatechange = function(evt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                try
                {
                    var result = JSON.parse(req.responseText);
                    if (result && result.success)
                    {
                        var trust = result.summary.trust, spam = result.summary.spam;

                        data.trust = (isFinite(trust) && (parseFloat(trust, 10) <= 100))? parseFloat(trust, 10) : 'n/a';
                        data.spam  = (isFinite(spam)  && (parseFloat(spam, 10) <= 100))?  parseFloat(spam, 10) : 'n/a';

                        if (st.cache.enabled)
                            st.cache.push(st.getURI(link).host, 'ct', JSON.stringify(data));

                        me.decorate(link, place, row, data);
                        correct = 1;
                    }
                    if (result && !result.success)
                    {
                        if (result.message && (result.message.indexOf('Limits expired') > -1))
                        {
                            if (me.inProgress)
                                st.showAlert(st.str('checktrust.limits.expired'), st.str('ya.stop'), 2, me.img);

                            me.unload();
                            return;
                        }
                        if (result.message && result.message.match(/(Host\sis\sin\sprocess)|(Waiting\sfor\sdata)/i))
                        {
                            var timeout = 1000 + (isFinite(result.tail)? 10 * parseInt(result.tail, 10) : 0);
                            var callback = function()
                            {
                                me.run(link, place, row);
                            };
                            st.setTimer(callback, timeout);
                            return;
                        }
                    }
                }
                catch(ex) {}
            }
            if (loader && loader.parentNode)
            {
                loader.parentNode.removeChild(loader);
            }
            if (req.status == 403)
            {
                if (me.inProgress)
                {
                    st.showAlert(st.str('checktrust.key.incorrect'), st.str('ya.stop'), 2, me.img);
                }
                row.removeAttribute('checktrust');
                me.unload();
                return;
            }
            if (!correct)
            {
                me.decorate(link, place, row, data);
            }
            me.next();
        }
    };
    place.appendChild(loader);
    req.send(null);
};

sape.checktrust.decorate = function(link, place, row, data)
{
    var st = sape.toolbar, me = sape.checktrust;

    var trust = (isFinite(data.trust) && (parseFloat(data.trust, 10) <= 100))? parseFloat(data.trust, 10) : 'n/a';
    var spam  = (isFinite(data.spam)  && (parseFloat(data.spam, 10) <= 100))?  parseFloat(data.spam, 10) : 'n/a';

    var trustLinkStyle = function(v)
    {
        var color = 'green';
        if (v <= 50) color = 'orange';
        if (v <= 30) color = 'red';

        return "color:" + color + "; font-weight:bold;";
    };
    var spamLinkStyle = function(v)
    {
        var color = 'green';
        if (v > 7)  color = 'orange';
        if (v > 12) color = 'red';

        return "color:" + color + "; font-weight:bold;";
    };

    var trustLink = me.doc.createElement('span');
        trustLink.textContent = trust;

    if (trust !== 'n/a')
        trustLink.setAttribute('style', trustLinkStyle(trust));

    var spamLink = me.doc.createElement('span');
        spamLink.textContent = spam;

    if (spam !== 'n/a')
        spamLink.setAttribute('style', spamLinkStyle(spam));

    var div = row.querySelector('div.checktrustPlace') || me.doc.createElement('div');
        div.className = 'checktrustPlace';
        div.textContent = "";
        div.appendChild(me.doc.createTextNode(st.str('checktrust.trust') + ':\xA0'));
        div.appendChild(trustLink);
        div.appendChild(me.doc.createElement('br'));
        div.appendChild(me.doc.createTextNode(st.str('checktrust.spam') + ':\xA0'));
        div.appendChild(spamLink);

    place.appendChild(div);

    var a = me.check.trust && (trust !== 'n/a') && (trust < me.limit.trust);
    var b = me.check.spam && (spam !== 'n/a') && (spam > me.limit.spam);

    var checkbox = st.getCheckbox(row.cells[me.lay.check]), checkit = (me.check.together)? a&&b : a||b;

    if (checkbox && !checkbox.checked && checkit)
    {
        checkbox.checked = true;
        checkbox.setAttribute('reason', 'checktrust');
        me.counter++;
    }
};

sape.checktrust.cached = function(link, place, row)
{
    var st = sape.toolbar, me = sape.checktrust;

    if (st.cache.enabled)
    {
        var URI = st.getURI(link);

        var data = st.cache.pop(URI.host, 'ct');
        if (data !== null)
        {
            me.decorate(URI.spec, place, row, JSON.parse(data));
            return true;
        }
    }
    return false;
};


sape.checktrust.nextone = function()
{
    var st = sape.toolbar, me = sape.checktrust;

    if (!me.doc || !me.doc.defaultView) return;

    var row = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i = 0; i < rl; i++)
    {
        if (row[i].hasAttribute('checktrust')) continue;

        var col = row[i].cells;
        if ((me.lay.cols > 0) && (col.length < me.lay.cols)) continue;

        var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox || (checkbox.checked && me.skip)) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var url = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(url)) continue;

        row[i].setAttribute('checktrust', '1');

        if (st.cache.enabled && me.cached(url, col[me.lc], row[i])) continue;

        me.run(url, col[me.lc], row[i]);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.finish'), 2, me.img);
    }
};

sape.checktrust.next = function()
{
    var me = sape.checktrust, timeout = (arguments.length)? arguments[0] : 100;
    if (me.inProgress)
        sape.toolbar.setTimer(me.nextone, timeout);
};

sape.checktrust.unload = function()
{
    var me = sape.checktrust;
    if (me.doc && me.doc.defaultView) me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.inProgress = me.doc = 0;
};

sape.checktrust.start = function()
{
    var st = sape.toolbar, me = sape.checktrust, doc = st.getDocument();

    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, me.img);
        return;
    }
    if (me.doc) me.unload();

    if (!st.inside(doc))
        return;

    var lay = st.layout(doc);

    if ((me.lc = (lay.url == -1)? lay.link : lay.url) < 0)
        return;

    var prefs = st.prefs();

    me.apikey         = prefs.getCharPref("checktrust.api") || "";
    me.limit.trust    = prefs.getIntPref("checktrust.limit.trust");
    me.limit.spam     = prefs.getIntPref("checktrust.limit.spam");
    me.check.trust    = prefs.getBoolPref("checktrust.check.trust");
    me.check.spam     = prefs.getBoolPref("checktrust.check.spam");
    me.skip           = prefs.getBoolPref("re.check");
    me.check.together = prefs.getBoolPref("checktrust.check.together");

    if (!me.apikey.trim())
    {
        st.showAlert(st.str('checktrust.key.notfound'), st.str('ya.stop'), 2, me.img);
        return;
    }

    me.counter = 0;
    me.inProgress = 1;
    me.lay = lay;
    me.doc = st.getDocument();
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    st.showAlert(st.str('nice'), st.str('ya.start'), 1, me.img);

    if (st.cache.enabled)
    {
        var row = me.doc.getElementsByTagName('tr'), rl = row.length;
        for (var i = 0; i < rl; i++)
        {
            if (row[i].hasAttribute('checktrust')) continue;

            var col = row[i].cells;
            if ((me.lay.cols > 0) && (col.length < me.lay.cols)) continue;

            var checkbox = st.getCheckbox(col[me.lay.check]);
            if (!checkbox || (checkbox.checked && me.skip)) continue;

            var a = col[me.lc].getElementsByTagName('a');
            if (a.length < me.lay.idx + 1) continue;

            var url = a[me.lay.idx].getAttribute('href');
            if (!st.urlCheck(url)) continue;

            if (me.cached(url, col[me.lc], row[i]))
            {
                row[i].setAttribute('checktrust', '1');
            }
        }
    }
    for (var j=0; j<3; j++) me.next(100 + 500*j);
};