var sape = sape || {};

if (!sape.exports) sape.exports = {};

//------------------------------------------------------------------------------
// Экспорт ссылок
//------------------------------------------------------------------------------

sape.exports.links = function()
{
   var st = sape.toolbar, doc = st.getDocument(), lay = st.layout(doc);
   var lc  = (lay.url < 0)? lay.link : lay.url;

   if (lc < 0) return;

   var row  = doc.getElementsByTagName('tr');
   for (var i=0, data = []; i < row.length; i++)
   {
		var td = row[i].cells;
        if (td.length < lay.cols) continue;

        var checkbox = st.getCheckbox(td[lay.check]);
        if (!checkbox || !checkbox.checked) continue;

        var a = td[lc].getElementsByTagName('a');
        if (a.length < lay.idx + 1) continue;

        var href = a[lay.idx].getAttribute('href');
        if (st.urlCheck(href) && (data.indexOf(href) == -1)) data.push(href);
   }
   if (!data.length)
   {
        st.showAlert(st.str('nice'), st.str('links.nochecked'), 0, "chrome://wmsape/skin/disk.png");
        return;
   }

   var text = data.sort().join("\n");

   var nsIFilePicker = Components.interfaces.nsIFilePicker;

   var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
       fp.init(window, st.str('fp.saveas'), nsIFilePicker.modeSave);
       fp.defaultString = "links.txt";
       fp.appendFilter(st.str('fp.text'), "*.txt");
       fp.appendFilter(st.str('fp.tsv'), "*.tsv");
       fp.appendFilter(st.str('fp.excel'), "*.xls");
       fp.appendFilter(st.str('fp.all'), "*.*");

   var res = fp.show();
   if (res == nsIFilePicker.returnOK || res == nsIFilePicker.returnReplace)
   {
       var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
           foStream.init(fp.file, 0x02 | 0x08 | 0x10, 438, 0);

       var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
           os.init(foStream, "windows-1251", 0, 0);
           os.writeString(text);
           os.close();
   }
};

//------------------------------------------------------------------------------
// Экспорт ссылок в буфер обмена
//------------------------------------------------------------------------------

sape.exports.clipboard = function()
{
    var st = sape.toolbar, doc = st.getDocument(), lay = st.layout(doc);
    var lc = (lay.url < 0)? lay.link : lay.url;

    if (lc < 0) return;

    var row  = doc.getElementsByTagName('tr');
    for (var i=0, data = []; i < row.length; i++)
    {
		var td = row[i].cells;
        if (td.length < lay.cols) continue;

        var checkbox = st.getCheckbox(td[lay.check]);
        if (!checkbox || !checkbox.checked) continue;

        var a = td[lc].getElementsByTagName('a');
        if (a.length < lay.idx + 1) continue;

        var href = a[lay.idx].getAttribute('href');
        if (st.urlCheck(href) && (data.indexOf(href) == -1)) data.push(href);
    }
    if (!data.length)
    {
        st.showAlert(st.str('links.nochecked'), st.str('clipboard'), 0, "chrome://wmsape/skin/copy.png");
        return;
    }
    try
    {
        var copytext = data.join("\n");

        var str = Components.Constructor("@mozilla.org/supports-string;1", "nsISupportsString")();
        if (!str) return;

        str.data = copytext;

        var Transferable = function(source)
        {
           if (source instanceof Components.interfaces.nsIDOMWindow)
               source = source.QueryInterface(Components.interfaces.nsIInterfaceRequestor).getInterface(Components.interfaces.nsIWebNavigation);

            var res = Components.Constructor("@mozilla.org/widget/transferable;1", "nsITransferable")();
            if ('init' in res) res.init(source);

            return res;
        };
        var trans = Transferable(doc.defaultView);
            trans.addDataFlavor("text/unicode");
            trans.setTransferData("text/unicode", str, copytext.length * 2);

        var clipid = Components.interfaces.nsIClipboard;
        var clip   = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
        if (!clip) return;

        clip.setData(trans, null, clipid.kGlobalClipboard);

        st.showAlert(st.str('links.added') + ' ' + data.length, st.str('clipboard'), 0, "chrome://wmsape/skin/copy.png");
    }
    catch(e){}
};

sape.exports.opentabs = function()
{
    var st = sape.toolbar, doc = st.getDocument(), me = sape.exports, lay = st.layout(doc);
    var lc = (lay.url < 0)? lay.link : lay.url;

    if (lc < 0) return;

    var row  = doc.getElementsByTagName('tr');
    for (var i=0, data = []; i < row.length; i++)
    {
		var td = row[i].cells;
        if (td.length < lay.cols) continue;

        var checkbox = st.getCheckbox(td[lay.check]);
        if (!checkbox || !checkbox.checked) continue;

        var a = td[lc].getElementsByTagName('a');
        if (a.length < lay.idx + 1) continue;

        var href = a[lay.idx].getAttribute('href');
        if (st.urlCheck(href) && (data.indexOf(href) == -1)) data.push(href);
    }
    if (!data.length)
    {
        st.showAlert('o_O', st.str('links.nochecked'), 0, "chrome://wmsape/skin/arrow-green.png");
        return;
    }
    if (!me.queueTimer)
    {
        me.queueTimer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
    }
    me.queue = (me.queue)? me.queue.concat(data) : data;

    me.queueTimer.initWithCallback(
    {
        notify: function(timer)
        {
            if (!sape.exports.queue || !sape.exports.queue.length)
            {
                sape.exports.queueTimer.cancel();
                return;
            }
            try
            {
                openUILinkIn(sape.exports.queue.shift(), 'tabshifted', false, null, null);
            }
            catch(e){}
        }
    }, 500, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
};

//------------------------------------------------------------------------------
// Экспорт сообщений / автор блока: chahlic
//------------------------------------------------------------------------------

sape.exports.messages = function()
{
    function getMessagesText()
    {
        var st = sape.toolbar, doc = st.getDocument();

        var text = "", table = doc.querySelector('#message_list table');
        if (!table) return false;

        var row = table.getElementsByTagName("tr");
    	for (var i=1; i < row.length; i++)
        {
            var col = row[i].cells;
            if (col.length < 2) continue;

            var time = col[0].innerHTML.replace(/<[^>]+>/g, ' ');
            var msg  = col[2].textContent;

            text += time + "\n" + msg + "\n\n";
    	}
    	return (text.length)? text : false;
    }

    function getOptionsMess()
    {
        var st = sape.toolbar, doc = st.getDocument(), options = "";

        var word = doc.querySelector('#message_search_form input[name="word"]');
        if (word && word.value !== "")
        {
            options += st.str('msgs.filter') + " " + word.value + "\n";
        }
    	options += st.str('msgs.type') + "\n";

        var s = doc.querySelectorAll('#message_search_form option[selected="selected"]');
		for (var j=0; j < s.length; j++)
        {
            var label = (!s[j].label)? st.str('msgs.all') : s[j].label;
			options += label + "\n";
		}

        var op = doc.querySelector('#pginator option[selected="selected"]');
		var messPerPage = (op)? st.str('msgs.count') + " " + op.textContent : "";

        var div = doc.querySelector('div.pagination_selector_total');
        var messCount = (div)? div.textContent.replace(/(^\s+)|(\s+$)/g, '') : "";

		return options + "\n" + messCount + "\n" + messPerPage + "\n";
    }

    var st = sape.toolbar, doc = st.getDocument();
    if (!st.sape(doc)) return;

    var separator = "-------------------------------------------------------------------------";

    var data = getMessagesText();
    if (!data)
    {
        st.showAlert(st.str('nice'), st.str('msgs.noone'), 0);
        return;
    }
    var header = getOptionsMess();
    if (header) data = separator + "\n" + header + separator + "\n\n" + data + "\n\n" + st.str('msgs.endpage') + "\n" + separator + "\n\n";

    var nsIFilePicker = Components.interfaces.nsIFilePicker;
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
        fp.init(window, st.str('fp.saveas'), nsIFilePicker.modeSave);
        fp.defaultString = "messages.txt";
        fp.appendFilter(st.str('fp.text'), "*.txt");
        fp.appendFilter(st.str('fp.all'), "*.*");

    var res = fp.show();
    if (res == nsIFilePicker.returnOK || res == nsIFilePicker.returnReplace)
    {
       var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
           foStream.init(fp.file, 0x02 | 0x08 | 0x10, 438, 0);

       var os = Components.classes["@mozilla.org/intl/converter-output-stream;1"].createInstance(Components.interfaces.nsIConverterOutputStream);
           os.init(foStream, "windows-1251", 0, 0);
           os.writeString(data);
           os.close();

       foStream.close();
    }
};