var sape = sape || {};

if (!sape.flow) sape.flow =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    lay: {},
    img: "chrome://wmsape/skin/majestic.png",
    check: {},
    limit: {},
    urls: []
};

sape.flow.show = function(data, place)
{
    var st = sape.toolbar, me = sape.flow;

    var url = data.Item;
    var trust = data.TrustFlow;
    var citation = data.CitationFlow;

    if (data.Status == "MayExist")
    {
        trust = (parseInt(data.TrustFlow, 10) === 0)? 'n/a' : data.TrustFlow;
        citation = (parseInt(data.CitationFlow, 10) === 0)? 'n/a' : data.CitationFlow;
    }

    var infoURL = 'https://majesticseo.com/reports/site-explorer?folder=&IndexDataSource=F&q=' + encodeURIComponent(url);

    var linkStyle = function(exp)
    {
        return (exp)? 'color:red; font-weight:bold;' : 'color:green; font-weight:bold;';
    };
    var citationLink = me.doc.createElement('a');
        citationLink.setAttribute('href', infoURL);
        citationLink.setAttribute('target', '_blank');
        citationLink.textContent = citation;
    if (citation !== 'n/a')
    {
        citationLink.setAttribute('style', linkStyle(citation < me.limit.citation));
    }

    var trustLink = me.doc.createElement('a');
        trustLink.setAttribute('href', infoURL);
        trustLink.setAttribute('target', '_blank');
        trustLink.textContent = trust;
    if (trust !== 'n/a')
    {
        trustLink.setAttribute('style', linkStyle(trust < me.limit.trust));
    }

    var div = me.doc.createElement('div');
        div.className = 'flowPlace';
        div.appendChild(me.doc.createTextNode((me.check.domain)? 'Domain\xA0Citation:\xA0' : 'Citation\xA0Flow:\xA0'));
        div.appendChild(citationLink);
        div.appendChild(me.doc.createElement('br'));
        div.appendChild(me.doc.createTextNode((me.check.domain)? 'Domain\xA0Trust:\xA0' : 'Trust\xA0Flow:\xA0'));
        div.appendChild(trustLink);

    place.appendChild(div);
};

sape.flow.cleanup = function()
{
    var me = sape.flow;

    if (!me.doc || !me.doc.defaultView) return;

    var row = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i = 1; i < rl; i++)
    {
        if (!row[i].hasAttribute('flow')) continue;
        if ( row[i].getAttribute('flow') == '1')
        {
            var loader = row[i].querySelector('b.flow-loader');
            if (loader && loader.parentNode) loader.parentNode.removeChild(loader);
            row[i].removeAttribute('flow');
        }
    }
};

sape.flow.check = function(data, checkbox)
{
    var st = sape.toolbar, me = sape.flow, t, c;

    var trust = parseInt(data.TrustFlow, 10);
    var citation = parseInt(data.CitationFlow, 10);

    if (checkbox.checked) return;

    if (data.Status == "Found")
    {
        t = (me.check.trust && (trust < me.limit.trust));
        c = (me.check.citation && (citation < me.limit.citation));

        checkbox.checked = (me.check.both)? t&&c : t||c;
        if (checkbox.checked)
        {
            checkbox.setAttribute("reason", "flow");
            me.counter++;
            return;
        }
    }
    if (data.Status == "MayExist")
    {
        // Оба недоступны и включена отметка недоступных
        if (me.check.na && (!trust && !citation))
        {
            checkbox.checked = true;
            checkbox.setAttribute("reason", "flow");
            me.counter++;
            return;
        }
        t = (me.check.trust && (trust > 0) && (trust < me.limit.trust)) || (me.check.trust && me.check.na && !trust);
        c = (me.check.citation && (citation > 0) && (citation < me.limit.citation)) || (me.check.citation && me.check.na && !citation);

        checkbox.checked = (me.check.both)? t&&c : t||c;
        if (checkbox.checked)
        {
            checkbox.setAttribute("reason", "flow");
            me.counter++;
            return;
        }
    }
};

sape.flow.fill = function(data)
{
    var st = sape.toolbar, me = sape.flow;

    if (!me.doc || !me.doc.defaultView) return;

    var linksEqual = function(link1, link2)
    {
        var l1 = link1.replace(/[\/]+$/, '').toLowerCase();
        var l2 = link2.replace(/[\/]+$/, '').toLowerCase();

        return (l1 == l2);
    };

    var row = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i = 1; i < rl; i++)
    {
        if (!row[i].hasAttribute('flow')) continue;
        if ( row[i].getAttribute('flow') == '1')
        {
            var loader = row[i].querySelector('b.flow-loader');
            if (loader && loader.parentNode) loader.parentNode.removeChild(loader);

            var col = row[i].cells;
            if ((me.lay.cols > 0) && (col.length < me.lay.cols)) continue;

            var checkbox = st.getCheckbox(col[me.lay.check]);
            if (!checkbox) continue;

            var a = col[me.lc].getElementsByTagName('a');
            if (a.length < me.lay.idx + 1) continue;

            var url  = a[me.lay.idx].getAttribute('href');
            if (!st.urlCheck(url)) continue;

            var aURI = st.getURI(url);
            var pURL = (me.check.domain)? aURI.asciiHost : aURI.asciiSpec;

            for (var j=0; j < data.length; j++)
            {
                if (data[j].Item && linksEqual(data[j].Item, pURL))
                {
                    if (st.cache.enabled) st.cache.push(pURL, 'flow', JSON.stringify(data[j]));

                    sape.flow.check(data[j], checkbox);
                    sape.flow.show(data[j], col[me.lc]);
                    row[i].setAttribute('flow', '2');
                    break;
                }
            }
        }
    }
};

sape.flow.run = function()
{
    var st = sape.toolbar, me = sape.flow;
    var data = JSON.stringify(me.urls);

    for (var j=0, items = ''; me.urls.length && items.length < 1024; j++)
    {
        items += '&item' + j + '=' + encodeURIComponent(me.urls.shift());
    }

    var requestURL  = 'http://simpleapi.majesticseo.com/sapi/GetBacklinkStats?sak=SOXMAJD8DZ41&datasource=Fresh'; // ETEZ5R4ACB
        requestURL += '&items=' + j + items;

    var req = new XMLHttpRequest();
        req.open('GET', requestURL, true);
        req.timeout = 30000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseText.length)
            {
                try
                {
                    var result = JSON.parse(req.responseText);
                    if (result.ResponseCode && result.ResponseCode == "OK")
                    {
                        me.fill(result.Data);
                        me.errorCounter = 0;
                        me.next();
                        return;
                    }
                }
                catch(ex) {}
            }
            me.errorCounter += 1;
            if (me.errorCounter > 2)
            {
                st.showAlert(st.str('mozrank.error.3'), 'Majestic', 2, me.img);
                me.cleanup();
                me.unload();
            }
            else
            {
                me.urls = JSON.parse(data);
                me.next();
            }
        }
    };
    try {req.send(null);} catch(e) {req.abort();}
};

sape.flow.nextone = function()
{
    var st = sape.toolbar, me = sape.flow;

    if (!me.doc || !me.doc.defaultView) return;

    if (me.urls.length >= 10)
    {
        me.run();
        return;
    }
    var row = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i = 1; i < rl; i++)
    {
        if (row[i].hasAttribute('flow')) continue;

        var col = row[i].cells;
        if ((me.lay.cols > 0) && (col.length < me.lay.cols)) continue;

        var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox || (checkbox.checked && me.skip)) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var url  = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(url)) continue;

        var aURI = sape.toolbar.getURI(url);
        var pURL = (me.check.domain)? aURI.asciiHost : aURI.asciiSpec;

        if (st.cache.enabled)
        {
            var result = st.cache.pop(pURL, 'flow');
            if (result)
            {
                var data = JSON.parse(result);
                sape.flow.check(data, checkbox);
                sape.flow.show(data, col[me.lc]);

                row[i].setAttribute('flow', '2');
                continue;
            }
        }
        row[i].setAttribute('flow', '1');

        var loader = me.doc.createElement('b');
            loader.className = 'flow-loader';
            loader.style.color = 'blue';
            loader.textContent = '\xA0...';

        col[me.lc].appendChild(loader);

        if (me.urls.indexOf(pURL) == -1)
        {
            me.urls.push(pURL);
            if (me.urls.length >= 10)
            {
                me.run();
                return;
            }
        }
    }
    if (me.urls.length)
    {
        me.run();
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.finish'), 2, me.img);
        me.cleanup();
    }
};

sape.flow.next = function()
{
    sape.flow.inProgress && sape.toolbar.setTimer(sape.flow.nextone, 1000);
};

sape.flow.unload = function()
{
    var me = sape.flow;
    me.doc && me.doc.defaultView && me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = me.inProgress = 0;
};

sape.flow.start = function()
{
    var st = sape.toolbar, me = sape.flow, doc = st.getDocument();
    if (!st.inside(doc))
    {
        st.openService('CF');
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        me.cleanup();
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, me.img);
        return;
    }
    if (me.doc) me.unload();

    var lay = st.layout(st.getDocument());

    if ((me.lc = (lay.url == -1)? lay.link : lay.url) < 0) return;

    me.lay = lay;
    me.urls = [];

    me.doc = st.getDocument();
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    var prefs = st.prefs();
    me.limit.citation = prefs.getIntPref("flow.limit.citation");
    me.limit.trust    = prefs.getIntPref("flow.limit.trust");
    me.skip           = prefs.getBoolPref("re.check");
    me.check.citation = prefs.getBoolPref("flow.check.citation");
    me.check.trust    = prefs.getBoolPref("flow.check.trust");
    me.check.na       = prefs.getBoolPref("mozrank.check.na");
    me.check.domain   = prefs.getBoolPref("mozrank.check.domain");
    me.check.both     = prefs.getBoolPref("flow.check.both");
    me.check.both     = me.check.both && me.check.trust && me.check.citation;

    me.counter   = 0;
    me.errorCounter = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, me.img);
    me.next();
};