var sape = sape || {};

if (!sape.google) sape.google =
{
    img: "chrome://wmsape/skin/google.png",
    defaultURL: 'https://www.google.ru/search?hl=ru&gl=RU&q='
};

sape.google.selectURL = function()
{
    var google = sape.google, requestURL = google.defaultURL;

    if (google.domain == "com") requestURL  = 'https://www.google.com/search?hl=en&gl=US&q=';
    if (google.domain == "ru")  requestURL  = 'https://www.google.ru/search?hl=ru&gl=RU&q=';
    if (google.domain == "ua")  requestURL  = 'https://www.google.com.ua/search?hl=ru&gl=UA&q=';
    if (google.domain == "by")  requestURL  = 'https://www.google.by/search?hl=ru&gl=BY&q=';
    if (google.domain == "uk")  requestURL  = 'https://www.google.co.uk/search?hl=en&gl=GB&q=';
    if (google.domain == "ca")  requestURL  = 'https://www.google.ca/search?hl=en&gl=CA&q=';
    if (google.domain == "de")  requestURL  = 'https://www.google.de/search?hl=en&gl=DE&q=';
    if (google.domain == "fr")  requestURL  = 'https://www.google.fr/search?hl=en&gl=FR&q=';
    if (google.domain == "it")  requestURL  = 'https://www.google.it/search?hl=en&gl=IT&q=';

    return requestURL;
};

sape.google.inIndex = function(text, link)
{
    var total = sape.google.countIndex(text);
    if (total < 1) return total;

    var cleanTail = function(t)
    {
        return t.replace(/[\/]$/, '');
    };
    var cleanHost = function(host)
    {
        return host.replace(/^www\./i, '');
    };

    var st = sape.toolbar, URI = st.getURI(link), tail = cleanTail(URI.path);

    var a_exp = /<[\s]*a[\s][^>]+>/ig;
    var h_exp = /[\s]+href[\s]*\=[""''\s]*(https?\:[^""''\s<]+)/i;

    a_exp.lastIndex = 0;
    h_exp.lastIndex = 0;

    var a, href;
    while ((a = a_exp.exec(text)) !== null)
    {
        if ((href = h_exp.exec(a[0])) !== null)
        {
            var lURI = st.getURI(st.html_entity_decode(href[1])), linkTail = cleanTail(lURI.path);

            if (cleanHost(lURI.asciiHost) !== cleanHost(URI.asciiHost)) continue;

            if (URI.equals(lURI) || (URI.asciiSpec == lURI.asciiSpec))
            {
                return 1;
            }
            if ((linkTail == tail) || (decodeURIComponent(linkTail) == decodeURIComponent(tail)))
            {
                return 1;
            }
        }
    }
    return 0;
};

sape.google.countIndex = function(text)
{
    var st = sape.toolbar, google = sape.google;

    var exp = /div\s*id\=[""'']?resultStats([^<]+)<nobr/i;
        exp = exp.exec(text);

    if (exp)
    {
        var txt = st.html_entity_decode(exp[1]).replace(/[^\d]+/g, '');

        return parseInt(txt, 10);
    }
    if (text.indexOf('Your search') > -1 && text.indexOf('did not match any documents') > -1) return 0; // en
    if (text.indexOf('Sorry, no information is available for the URL') > -1)                  return 0; // en
    if (text.indexOf('По запросу') > -1 && text.indexOf('ничего не найдено') > -1)            return 0; // ru
    if (text.indexOf('Извините, у нас нет информации об адресе') > -1)                        return 0; // ru

    return -1;
};


sape.google.isCaptcha = function(req)
{
    var URI = req.channel.URI, text = req.responseText;

    if (req.status == 403 || req.status == 503) return true;
    if (URI.path.match(/^[\/]sorry[\/]/)) return true;
    if (URI.host.match(/\sorry\.google/)) return true;
    if (text.indexOf('form action="Captcha"') > -1) return true;
    if (text.match(/(Suspected Terms of Service Abuse)|(network may be sending automated queries)/)) return true;
    return false;
};

sape.google.anticaptcha = function(me, req, callback)
{
    var st = sape.toolbar;
    if (me.inProgress)
    {
        me.inProgress = 0;

        if (sape.google.antigate)
        {
            me.cTimer = 1;
            st.showAlert(st.str('ag.wait'), st.str('captcha'), 3, sape.google.img);
            sape.antigate.addTask(me, req, callback);
        }
        else st.showAlert(st.str('ya.stop'), st.str('captcha'), 2, sape.google.img);
    }
};

sape.google.next = function(me)
{
    var timeout = (arguments.length > 1)? +arguments[1] : me.timeout + Math.round(me.timeout * Math.random());
    if (me.doc && me.inProgress) sape.toolbar.setTimer(me.nextone, timeout);
};

sape.google.stop = function(me)
{
    if (me.inProgress || me.cTimer)
    {
        me.unload();
        return true;
    }
    else
        return false;
};

sape.google.init = function()
{
    var st = sape.toolbar, google = sape.google, prefs = st.prefs();

    google.skip         = prefs.getBoolPref("re.check");
    google.changeselect = prefs.getBoolPref("changeselect");
    google.liveDays     = prefs.getIntPref("livedays.gl");
    google.domain       = prefs.getCharPref("google.domain").replace(/[^a-z\.]+/, '');
    google.requery      = prefs.getBoolPref("google.requery");

    st.loadJS('antigate');
    google.antigate = sape.antigate.init();
};

sape.google.nextrow = function(me)
{
    var st = sape.toolbar;
    if (!me.inProgress || !me.doc || !me.doc.defaultView) return;

    var row = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i=0; i < rl; i++)
    {
        if (row[i].hasAttribute(me.rowName)) continue;

        var col = row[i].cells;
        if (col.length !== me.lay.cols) continue;

        var as = row[i].querySelector('a.' + me.btnName);
		if (!as) continue;

		var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox || (sape.google.skip && checkbox.checked)) continue;

        if ((me.rowName == 'gl') && me.lastDate && sape.google.liveDays > 0)
        {
            var linkDate = st.parseDate(col[me.lay.dc]);
            if (linkDate > me.lastDate) continue;
        }

        var a    = col[me.lc].getElementsByTagName('a');
        var link = st.getURL(a[me.lay.idx].getAttribute('href'));

        row[i].setAttribute(me.rowName, '1');

        var crow = row[i];
        if (me.cached(link, as, crow)) continue;

        me.query(link, as, crow);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.finish'), 2, sape.google.img);

        if (me.counter > 0)
        {
            if (sape.google.changeselect && !me.lay.seo) st.changeSelect(me.doc, 'placementRemove');
        }
    }
};

sape.google.placeButtons = function(me)
{
    var st = sape.toolbar;

    var row  = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i = 0; i < rl; i++)
    {
        if (row[i].hasAttribute(me.rowName))  continue;

        var col = row[i].cells;
        if (col.length !== me.lay.cols) continue;

		var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var href = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var link = st.getURL(href);
        var btn  = me.button(link, row[i]);

        var as = row[i].querySelector('a.' + me.btnName);
        if (as)
        {
            as.parentNode.replaceChild(btn, as);
        }
        else
        {
            var yap = col[me.lay.ico].querySelector('.icon_in_yaca, .icon_in_dmoz, .icon_in_wl, .icon_wl, .icon_yal, .icon_bl, .icon_gbl, .icon_ya');
            if (yap)
            {
                yap.parentNode.insertBefore(btn, yap.nextSibling);
            }
            else
            {
                var div = col[me.lay.ico].querySelector('.page_icons') || me.doc.createElement('div');
                    div.className = 'page_icons';
                    div.appendChild(btn);

                col[me.lay.ico].appendChild(div);
            }
        }
        if ((me.rowName == 'gl') && me.lastDate && sape.google.liveDays > 0)
        {
            var linkDate = st.parseDate(col[me.lay.dc]);
            if (linkDate > me.lastDate) continue;
        }
        if (me.cached(link, btn, row[i]))
        {
            row[i].setAttribute(me.rowName, '1');
        }
        col[me.lc].classList.remove('a_visited');
        col[me.lay.ico].classList.remove('a_visited');
    }
    st.initDOM();
};

// ─────────────────────────────────────────────────────────────────────────────
// Проверка индексации страниц
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.google.gp) sape.google.gp =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    rowName: 'gp',
    btnName: 'icon_gp',
    lay: {}
};

sape.google.gp.select = function()
{
    var type = sape.toolbar.prefs().getIntPref("gp.type");
    if (type)
    {
        sape.google.gm.start();
    }
    else
    {
        sape.google.gp.start();
    }
};

sape.google.gp.queryURL = function(link)
{
    var st = sape.toolbar, me = sape.google.gp, URI = st.getURI(link);

    var page = URI.host + URI.path;
    var url  = me.requestURL + encodeURIComponent('info:' + page);

    return url;
};

sape.google.gp.button = function(link, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gp;

    var as = me.doc.createElement('a');
        as.href = me.queryURL(link);
        as.target = '_blank';
        as.className = 'icon_gp icon_ya';
        as.textContent = 'GP';

    return as;
};

sape.google.gp.cached = function(link, place, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gp;

    var URI = st.getURI(link);
    if (place.hasAttribute('requery'))
    {
        URI.host = (URI.host.match(/^www/i))? URI.host.replace(/^www./i, '') : 'www.' + URI.host;
    }

    if (st.cache.enabled)
    {
        var inIndex = st.cache.pop(URI.spec, 'gp');
        if (inIndex !== null)
        {
            if (!me.requery || +inIndex || place.hasAttribute('requery'))
            {
                me.decorate(URI.spec, place, row, +inIndex);
                return true;
            }
        }
    }
    return false;
};

sape.google.gp.decorate = function(link, place, row, inIndex)
{
    var st = sape.toolbar, google = sape.google, me = google.gp;

    var checkbox = st.getCheckbox(row.cells[me.lay.check]);

    if (inIndex < 0)
    {
        place.classList.add("icon_silver");
        return;
    }
    if (!inIndex)
    {
        place.classList.add("icon_red");

        if (!checkbox.checked)
        {
            checkbox.setAttribute("reason", "gp");
            checkbox.checked = true;
            me.counter++;
        }
    }
    if (inIndex > 0)
    {
        place.classList.add("icon_green");
        place.setAttribute("href", me.queryURL(link));
    }
};

sape.google.gp.query = function(link, place, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gp;

    if (me.megaindex)
    {
        sape.megaindex.gp(link, place, row);
        return;
    }

    var URI = st.getURI(link);
    if (place.hasAttribute('requery'))
    {
        URI.host = (URI.host.match(/^www/i))? URI.host.replace(/^www./i, '') : 'www.' + URI.host;
    }

    var checkResult = function(req)
    {
        if (google.isCaptcha(req))
        {
            if (!me.cTimer) google.anticaptcha(me, req, checkResult);
            row.removeAttribute(me.rowName);
            return;
        }

        var correct = 0;
        if ((req.status == 200) && req.responseText.length)
        {
            row.setAttribute(me.rowName, '1');

            var inIndex = google.inIndex(req.responseText, URI.spec);
            if (+inIndex > -1)
            {
                correct = 1;
                if (st.cache.enabled)
                {
                    st.cache.push(URI.spec, 'gp', inIndex);
                }
                if (me.requery && !inIndex && !place.hasAttribute('requery'))
                {
                    place.setAttribute('requery', '1');
                    row.removeAttribute(me.rowName);
                }
                else
                {
                    me.decorate(URI.spec, place, row, +inIndex);
                }
            }
        }
        if (!correct)
        {
            me.decorate(URI.spec, place, row, -1);
        }
        google.next(me);
    };

    if (st.cache.enabled && me.requery)
    {
        var inIndex = st.cache.pop(URI.spec, 'gp');
        if (inIndex !== null)
        {
            if (!inIndex && !place.hasAttribute('requery'))
            {
                place.setAttribute('requery', '1');
                row.removeAttribute(me.rowName);

                me.nextone();
                return;
            }
        }
    }

    var url = me.queryURL(URI.spec);
    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            checkResult(req);
        }
    };
    req.send(null);
};

sape.google.gp.nextone = function()
{
    sape.google.nextrow(sape.google.gp);
};

sape.google.gp.unload = function()
{
    var me = sape.google.gp;
    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.google.gp.start = function()
{
    var st = sape.toolbar, google = sape.google, me = google.gp, doc = st.getDocument();

    if (!st.inside(doc))
    {
        st.openService('GP');
        return;
    }
    if (google.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, google.img);
        return;
    }
    google.init();

    var lay = st.layout(doc);

    me.lay      = lay;
    me.lc       = (lay.url < 0)? lay.link : lay.url;
    me.counter  = 0;

    if (me.lc == -1) return;

    var prefs = st.prefs();

    me.timeout    = Math.max(50, prefs.getIntPref("timeout.google"));
    me.requestURL = google.selectURL();
    me.requery    = google.requery;

    me.megaindex = prefs.getBoolPref("megaindex.gs");
    if (me.megaindex)
    {
        st.loadJS('megaindex');
        sape.megaindex.init();

        me.requestURL = google.defaultURL;
        me.timeout    = 10;
    }

    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, google.img);

    google.placeButtons(me);
    google.next(me, 100);

    if (me.megaindex)
    {
        google.next(me, 1000);
    }
};

// ─────────────────────────────────────────────────────────────────────────────
// Проверка индексации страниц (основной индекс)
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.google.gm) sape.google.gm =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    rowName: 'gm',
    btnName: 'icon_gm',
    lay: {}
};

sape.google.gm.queryURL = function(link)
{
    var st = sape.toolbar, me = sape.google.gm, URI = st.getURI(link);

    var host = URI.host.replace(/^www\./i, '');
    var path = URI.path.replace(/\&/g, '*').replace(/#.*$/g, '');

    var url = me.requestURL + encodeURIComponent('inurl:' + host + path + ' site:' + host + '/&');
    return url;
};

sape.google.gm.button = function(link, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gm;

    var as = me.doc.createElement('a');
        as.href = me.queryURL(link);
        as.target = '_blank';
        as.className = 'icon_gm icon_ya';
        as.textContent = 'GM';

    return as;
};

sape.google.gm.cached = function(link, place, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gm, URI = st.getURI(link);

    if (st.cache.enabled)
    {
        var inIndex = st.cache.pop(URI.spec, 'gm');
        if (inIndex !== null)
        {
            me.decorate(URI.spec, place, row, +inIndex);
            return true;
        }
    }
    return false;
};

sape.google.gm.decorate = function(link, place, row, inIndex)
{
    var st = sape.toolbar, google = sape.google, me = google.gm;

    var checkbox = st.getCheckbox(row.cells[me.lay.check]);

    if (inIndex < 0)
    {
        place.classList.add("icon_silver");

        if (checkbox && !checkbox.checked && me.errcheck)
        {
            checkbox.checked = true;
            me.counter++;
        }
        return;
    }
    if (!inIndex)
    {
        place.classList.add("icon_red");

        if (!checkbox.checked)
        {
            checkbox.setAttribute("reason", "gp");
            checkbox.checked = true;
            me.counter++;
        }
    }
    if (inIndex > 0)
    {
        place.classList.add("icon_green");
        place.setAttribute("href", me.queryURL(link));
    }
};

sape.google.gm.query = function(link, place, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gm;

    var URI = st.getURI(link);

    var checkResult = function(req)
    {
        if (google.isCaptcha(req))
        {
            if (!me.cTimer) google.anticaptcha(me, req, checkResult);
            row.removeAttribute(me.rowName);
            return;
        }

        var correct = 0;
        if ((req.status == 200) && req.responseText.length)
        {
            row.setAttribute(me.rowName, '1');

            var inIndex = google.inIndex(req.responseText, URI.spec);
            var cIndex  = google.countIndex(req.responseText);

            if (inIndex > 0 || (inIndex > -1 && cIndex < 11))
            {
                correct = 1;
                if (st.cache.enabled)
                {
                    st.cache.push(URI.spec, 'gm', inIndex);
                }
                me.decorate(URI.spec, place, row, +inIndex);
            }
        }
        if (!correct)
        {
            me.decorate(URI.spec, place, row, -1);
        }
        google.next(me);
    };

    var url = me.queryURL(URI.spec);
    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            checkResult(req);
        }
    };
    req.send(null);
};

sape.google.gm.nextone = function()
{
    sape.google.nextrow(sape.google.gm);
};

sape.google.gm.unload = function()
{
    var me = sape.google.gm;
    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.google.gm.start = function()
{
    var st = sape.toolbar, google = sape.google, me = google.gm, doc = st.getDocument();

    if (!st.inside(doc))
    {
        st.openService('GM');
        return;
    }
    if (google.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, google.img);
        return;
    }
    google.init();

    var lay = st.layout(doc);

    me.lay      = lay;
    me.lc       = (lay.url < 0)? lay.link : lay.url;
    me.counter  = 0;

    if (me.lc == -1) return;

    var prefs = st.prefs();

    me.timeout    = Math.max(50, prefs.getIntPref("timeout.google"));
    me.requestURL = google.selectURL();
    me.errcheck   = prefs.getBoolPref("gl.errors");

    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, google.img);

    google.placeButtons(me);
    google.next(me, 100);
};


// ─────────────────────────────────────────────────────────────────────────────
// Проверка индексации ссылок
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.google.gl) sape.google.gl =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    rowName: 'gl',
    btnName: 'icon_gl',
    lay: {}
};

sape.google.gl.getQueryText = function(cell)
{
    var st = sape.toolbar, result = "";
    var container = st.getTextCell(cell);

    var text  = container.innerHTML.replace(/[\r\n\f]*/g, '');
    var parts = text.split(/<\/?u[^>]*>/);

    while (parts.length)
    {
        text = parts.shift();
        text = text.replace(/<[^<>]+>/g, '');

        text = st.html_entity_decode(text);
        text = text.replace(/^[^0-9a-z\u0430-\u044F\u0451]+/i, '').replace(/[^0-9a-z\u0430-\u044F\u0451]+$/i, '');
        text = text.replace(/[""'']+/g, ' ').replace(/\s\s+/g, ' ').replace(/[\%\+]+/g, '" "');

        if (text.length > 2) result += '"' + text + '" ';
    }
    return result;
};

sape.google.gl.button = function(link, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gl, URI = st.getURI(link);

    var host = URI.host.replace(/^www\./i, '');
    var text = me.getQueryText(row.cells[me.lay.text]);
    var url  = me.requestURL + encodeURIComponent(text + ' site:' + host) + '&tbs=li:1';

    var as = me.doc.createElement('a');
        as.href = url;
        as.target = '_blank';
        as.className = 'icon_gl icon_ya';
        as.textContent = 'GL';

    return as;
};

sape.google.gl.cached = function(link, place, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gl;
    if (st.cache.enabled)
    {
        var URI   = st.getURI(link);
        var text  = me.getQueryText(row.cells[me.lay.text]);
        var clink = URI.spec + '++' + text;

        var inIndex = st.cache.pop(clink, 'gl');
        if (inIndex !== null)
        {
            me.decorate(link, place, row, +inIndex);
            return true;
        }
    }
    return false;
};

sape.google.gl.decorate = function(link, place, row, inIndex)
{
    var st = sape.toolbar, google = sape.google, me = google.gl;

    var checkbox = st.getCheckbox(row.cells[me.lay.check]);

    if (inIndex < 0)
    {
        place.classList.add("icon_silver");

        if (checkbox && !checkbox.checked && me.errcheck)
        {
            checkbox.checked = true;
            me.counter++;
        }
        return;
    }
    if (!inIndex)
    {
        place.classList.add("icon_red");

        if (checkbox && !checkbox.checked)
        {
            checkbox.setAttribute("reason", "gl");
            checkbox.checked = true;
            me.counter++;
        }
    }
    if (inIndex > 0)
    {
        place.classList.add("icon_green");
    }
};

sape.google.gl.query = function(link, place, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gl, URI = st.getURI(link);
    var text = me.getQueryText(row.cells[me.lay.text]);

    var checkResult = function(req)
    {
        if (google.isCaptcha(req))
        {
            if (!me.cTimer) google.anticaptcha(me, req, checkResult);
            row.removeAttribute(me.rowName);
            return;
        }

        var correct = 0;
        if ((req.status == 200) && req.responseText.length)
        {
            row.setAttribute(me.rowName, '1');

            var inIndex = google.inIndex(req.responseText, link);
            var cIndex  = google.countIndex(req.responseText);

            if (inIndex > 0 || (inIndex > -1 && cIndex < 11))
            {
                correct = 1;
                if (st.cache.enabled)
                {
                    st.cache.push(URI.spec + '++' + text, 'gl', inIndex);
                }
                me.decorate(link, place, row, inIndex);
            }
        }
        if (!correct)
        {
            me.decorate(link, place, row, -1);
        }
        if (me.inProgress) google.next(me);
    };

    var host = URI.host.replace(/^www\./i, '');
    var url  = me.requestURL + encodeURIComponent(text + ' site:' + host) + '&tbs=li:1';

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            checkResult(req);
        }
    };
    req.send(null);
};

sape.google.gl.nextone = function()
{
    sape.google.nextrow(sape.google.gl);
};

sape.google.gl.unload = function()
{
    var me = sape.google.gl;
    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.google.gl.start = function()
{
    var st = sape.toolbar, google = sape.google, me = google.gl, doc = st.getDocument();

    if (google.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, google.img);
        return;
    }
    google.init();

    var lay = st.layout(doc);

    me.lay      = lay;
    me.lc       = (lay.link < 0)? lay.url : lay.link;
    me.counter  = 0;

    if (me.lc == -1 || me.lay.text == -1 || me.lay.dc == -1) return;

    var prefs = st.prefs();

    me.timeout    = Math.max(50, prefs.getIntPref("timeout.google"));
    me.requestURL = google.selectURL();
    me.errcheck   = prefs.getBoolPref("gl.errors");

    me.lastDate = new Date();
    me.lastDate.setDate(me.lastDate.getDate() - google.liveDays);

    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, google.img);

    google.placeButtons(me);
    google.next(me, 100);
};

// ─────────────────────────────────────────────────────────────────────────────
// Проверка индексации сайтов
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.google.gs) sape.google.gs =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    rowName: 'gs',
    btnName: 'icon_gs',
    lay: {}
};

sape.google.gs.button = function(link, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gs, URI = st.getURI(link);

    var host = URI.host.replace(/^www\./i, '');
    var url  = me.requestURL + encodeURIComponent('site:' + host);

    var as = me.doc.createElement('a');
        as.href = url;
        as.target = '_blank';
        as.className = 'icon_gs icon_ya';
        as.textContent = 'GS';

    return as;
};

sape.google.gs.placeCounter = function(cell, count)
{
    var doc = cell.ownerDocument, s = doc.createTextNode("\x20[" + count + "]\x20");

    var e = cell.querySelector('b.blocked-in-google, b.not-blocked-in-google');
    if (e && e.nextSibling)
    {
        if (e.className == 'blocked-in-google')
        {
            e.className = 'not-blocked-in-google';
            e.textContent = '\u042F:';
            e.parentNode.insertBefore(s, e.nextSibling);
        }
        if (e.className == 'not-blocked-in-google')
        {
            e.parentNode.replaceChild(s, e.nextSibling);
        }
        return;
    }

    var b = doc.createElement('b');
        b.className = 'not-blocked-in-google';
        b.title = sape.toolbar.str("bing.pages") + " Google";
        b.textContent = 'G:';

    var root = cell.querySelector('.page_icons') || cell;
        root.appendChild(doc.createTextNode("\x20"));
        root.appendChild(b);
        root.appendChild(s);
};

sape.google.gs.cached = function(link, place, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gs;
    if (st.cache.enabled)
    {
        var host = st.getURI(link).host.replace(/^www./i, '');

        var inIndex = st.cache.pop(host, 'gs');
        if (inIndex !== null)
        {
            me.decorate(link, place, row, +inIndex);
            return true;
        }
    }
    return false;
};

sape.google.gs.decorate = function(link, place, row, inIndex)
{
    var st = sape.toolbar, google = sape.google, me = google.gs;

    var checkbox = st.getCheckbox(row.cells[me.lay.check]);

    if (inIndex < 0)
    {
        place.classList.add("icon_silver");
        return;
    }
    if (!inIndex)
    {
        place.classList.add("icon_red");

        if (!checkbox.checked)
        {
            checkbox.setAttribute("reason", "gs");
            checkbox.checked = true;
            me.counter++;
        }
    }
    if (inIndex > 0)
    {
        place.classList.add("icon_green");
    }
    me.placeCounter(row.cells[me.lc], +inIndex);
};

sape.google.gs.query = function(link, place, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gs, URI = st.getURI(link), host = URI.host.replace(/^www\./i, '');

    if (me.seobudget)
    {
        sape.seobudget.gs(link, place, row);
        return;
    }
    if (me.megaindex)
    {
        sape.megaindex.gs(link, place, row);
        return;
    }

    var checkResult = function(req)
    {
        if (google.isCaptcha(req))
        {
            if (!me.cTimer) google.anticaptcha(me, req, checkResult);
            row.removeAttribute(me.rowName);
            return;
        }

        var correct = 0;
        if ((req.status == 200) && req.responseText.length)
        {
            row.setAttribute(me.rowName, '1');

            var inIndex = google.countIndex(req.responseText);
            if (+inIndex > -1)
            {
                correct = 1;
                if (st.cache.enabled)
                {
                    st.cache.push(host, 'gs', inIndex);
                }
                me.decorate(link, place, row, +inIndex);
            }
        }
        if (!correct)
        {
            me.decorate(link, place, row, -1);
        }
        if (me.inProgress) google.next(me);
    };

    var url = me.requestURL + encodeURIComponent('site:' + host);
    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            checkResult(req);
        }
    };
    req.send(null);
};

sape.google.gs.nextone = function()
{
    sape.google.nextrow(sape.google.gs);
};

sape.google.gs.unload = function()
{
    var me = sape.google.gs;
    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.google.gs.start = function()
{
    var st = sape.toolbar, google = sape.google, me = google.gs, doc = st.getDocument();

    if (!st.inside(doc))
    {
        st.openService('GS');
        return;
    }
    if (google.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, google.img);
        return;
    }
    google.init();

    var lay = st.layout(doc);

    me.lay      = lay;
    me.lc       = (lay.url < 0)? lay.link : lay.url;
    me.counter  = 0;

    if (me.lc == -1) return;

    var prefs = st.prefs();

    me.timeout    = Math.max(50, prefs.getIntPref("timeout.google"));
    me.requestURL = google.selectURL();

    me.seobudget = prefs.getBoolPref("seobudget.gs");
    if (me.seobudget)
    {
        st.loadJS('seobudget');
        sape.seobudget.init();

        me.requestURL = google.defaultURL;
        me.timeout    = 10;
    }

    me.megaindex = prefs.getBoolPref("megaindex.gs");
    if (me.megaindex)
    {
        st.loadJS('megaindex');
        sape.megaindex.init();

        me.requestURL = google.defaultURL;
        me.timeout    = 10;
    }

    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, google.img);

    google.placeButtons(me);
    google.next(me, 100);

    if (me.seobudget || me.megaindex)
    {
        google.next(me, 1000);
    }
};

// ─────────────────────────────────────────────────────────────────────────────
// Проверка кэша страниц
// ─────────────────────────────────────────────────────────────────────────────
if (!sape.google.gc) sape.google.gc =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    rowName: 'gc',
    btnName: 'icon_gc',
    requestURL: 'https://webcache.googleusercontent.com/search?hl=en&q=',
    lay: {}
};

sape.google.gc.placeCounter = function(cachedate, row)
{
    var st = sape.toolbar, me = sape.google.gc, doc = row.ownerDocument, cell = row.cells[me.lay.ico];

    if (row.querySelector('.google-cache-date')) return;

    var b = doc.createElement('b');
        b.className = 'google-cache-date';
        b.textContent = 'GC:';
        b.title = st.str('yac.date');

    var s  = doc.createTextNode("\xA0[" + cachedate + "]\xA0");
    var sp = doc.createTextNode("\x20");

    var root = cell.querySelector('.page_icons') || cell;
        root.appendChild(sp);
        root.appendChild(b);
        root.appendChild(s);
};

sape.google.gc.searchLink = function(link, text, myLink)
{
    var st = sape.toolbar, me = sape.google.gc;

    var URI = st.getURI(link);
    var myLinkURI = st.getURI(myLink);

    if (!sape.hasOwnProperty('external'))
    {
        st.loadJS('external');
    }

    var linkPos = sape.external.utSearchLinkPos(text, myLink, URI.host), ok = (linkPos > -1);
    if (!ok && me.lay.seo)
    {
        linkPos = sape.external.utSearchLinkPos(text, myLinkURI.prePath, URI.host);
        ok = (linkPos > -1);
    }
    return (ok)? 1 : 0;
};

sape.google.gc.queryURL = function(link)
{
    var st = sape.toolbar, me = sape.google.gc, URI = st.getURI(link);

    var page = URI.host + URI.path;
    var url  = me.requestURL + encodeURIComponent('cache:' + page);

    return url;
};

sape.google.gc.button = function(link, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gc;

    var as = me.doc.createElement('a');
        as.href = me.queryURL(link);
        as.target = '_blank';
        as.className = 'icon_gc';
        as.textContent = 'GC';

    return as;
};

sape.google.gc.cached = function(link, place, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gc;

    var URI = st.getURI(link);
    if (place.hasAttribute('requery'))
    {
        URI.host = (URI.host.match(/^www/i))? URI.host.replace(/^www./i, '') : 'www.' + URI.host;
    }

    if (st.cache.enabled)
    {
        var inIndex = st.cache.pop(URI.spec, 'gc');
        if (inIndex !== null)
        {
            if (!me.requery || +inIndex || place.hasAttribute('requery'))
            {
                me.decorate(URI.spec, place, row, +inIndex);

                var cachedate = st.cache.pop(URI.spec,  'gcd');
                if (cachedate !== null)
                {
                   me.placeCounter(cachedate, row);
                }

                var myLink = st.getMyLink(me, row), present = (myLink)? st.cache.pop(URI.spec + '++' + myLink,  'gcl') : 0;
                if (present !== null)
                {
                    if (present)
                    {
                        place.textContent = "GC+";
                        place.title = st.str('yac.found');
                    }
                    else
                    {
                        if (me.ageCheck && cachedate) me.placeOld(cachedate, place, row);
                    }
                }
                return true;
            }
        }
    }
    return false;
};

sape.google.gc.decorate = function(link, place, row, inIndex)
{
    var st = sape.toolbar, google = sape.google, me = google.gc;

    var checkbox = st.getCheckbox(row.cells[me.lay.check]);

    if (inIndex < 0)
    {
        place.classList.add("icon_silver");
        return;
    }
    if (!inIndex)
    {
        place.classList.add("icon_red");

        if (!checkbox.checked)
        {
            checkbox.setAttribute("reason", "gc");
            checkbox.checked = true;
            me.counter++;
        }
    }
    if (inIndex > 0)
    {
        place.classList.add("icon_green");
        place.setAttribute("href", me.queryURL(link));
    }
};

sape.google.gc.placeOld = function(cachedate, place, row)
{
    var st = sape.toolbar, me = sape.google.gc, doc = row.ownerDocument;

    if (row.querySelector('.icon_old_gc')) return;

    var lastDate = new Date();
        lastDate.setDate(lastDate.getDate() - me.ageLimit);

    var pageDate = st.parseDate(cachedate);
    if (pageDate > lastDate) return;

    var a = doc.createElement('a');
        a.className = 'icon_old_gc icon_ya';
        a.textContent = "OLD";
        a.title = st.str("yac.old");

    var div = row.cells[me.lay.ico].querySelector('.page_icons') || me.doc.createElement('div');
        div.className = 'page_icons';
        div.appendChild(a);

    row.cells[me.lay.ico].appendChild(div);

    var checkbox = st.getCheckbox(row.cells[me.lay.check]);
    if (me.ageCheck && checkbox && !checkbox.checked)
    {
        checkbox.checked = true;
        me.counter++;
    }
};

sape.google.gc.query = function(link, place, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gc, myLink = st.getMyLink(me, row);

    var URI = st.getURI(link);
    if (place.hasAttribute('requery'))
    {
        URI.host = (URI.host.match(/^www/i))? URI.host.replace(/^www./i, '') : 'www.' + URI.host;
    }

    var fz = function(n)
    {
        return ("0" + n).slice(-2);
    };

    var copyDate = function(text)
    {
        var res = /appeared\s*on\s*([^<]*GMT)/.exec(text);
        if (res)
        {
            var pageDate = new Date(res[1]);
            var strDate  = fz(pageDate.getDate()) + '.' + fz(pageDate.getMonth() + 1) + '.' + pageDate.getFullYear();

            return strDate;
        }
        return 0;
    };

    var inCache = function(req)
    {
        if (req.responseText.indexOf('It is a snapshot of the page as it appeared') > 0)
        {
            return 1;
        }
        if ((req.status == 404) || (req.responseText.indexOf('Try more general keywords') > 0) || (req.responseText.indexOf('Error 404 (Not Found)') > 0))
        {
            return 0;
        }
        return -1;
    };

    var checkResult = function(req)
    {
        if (google.isCaptcha(req))
        {
            if (!me.cTimer) google.anticaptcha(me, req, checkResult);
            row.removeAttribute(me.rowName);
            return;
        }

        var correct = 0;
        if ((req.status == 200 || req.status == 404) && req.responseText)
        {
            row.setAttribute(me.rowName, '1');

            var inIndex = inCache(req);
            if (inIndex > -1)
            {
                correct = 1;
                if (st.cache.enabled)
                {
                    st.cache.push(URI.spec, 'gc', inIndex);
                }
                if (me.requery && !inIndex && !place.hasAttribute('requery'))
                {
                    place.setAttribute('requery', '1');
                    row.removeAttribute(me.rowName);
                }
                else
                {
                    me.decorate(URI.spec, place, row, +inIndex);
                }
            }
            if (inIndex > 0)
            {
                var cachedate = copyDate(req.responseText);
                if (cachedate)
                {
                    me.placeCounter(cachedate, row);
                    if (st.cache.enabled)
                    {
                        st.cache.push(URI.spec,  'gcd', cachedate);
                    }
                }
                var present = (myLink)? me.searchLink(URI.spec, req.responseText, myLink) : 0;
                if (myLink && present)
                {
                    place.textContent = "GC+";
                    place.title = st.str('yac.found');
                    if (st.cache.enabled)
                    {
                        st.cache.push(URI.spec + '++' + myLink,  'gcl', 1);
                    }
                }
                if (me.ageCheck && cachedate && !present)
                {
                    me.placeOld(cachedate, place, row);
                }
            }
        }
        if (!correct)
        {
            me.decorate(URI.spec, place, row, -1);
        }
        if (me.inProgress) google.next(me);
    };

    if (st.cache.enabled && me.requery)
    {
        var inIndex = st.cache.pop(URI.spec, 'gc');
        if (inIndex !== null)
        {
            if (!inIndex && !place.hasAttribute('requery'))
            {
                place.setAttribute('requery', '1');
                row.removeAttribute(me.rowName);

                me.nextone();
                return;
            }
        }
    }

    var url = me.queryURL(URI.spec);
    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            checkResult(req);
        }
    };
    req.send(null);
};

sape.google.gc.nextone = function()
{
    sape.google.nextrow(sape.google.gc);
};

sape.google.gc.unload = function()
{
    var me = sape.google.gc;
    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.google.gc.start = function()
{
    var st = sape.toolbar, google = sape.google, me = google.gc, doc = st.getDocument();

    if (!st.inside(doc))
    {
        st.openService('GC');
        return;
    }
    if (google.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, google.img);
        return;
    }
    google.init();

    var lay = st.layout(doc);

    me.lay      = lay;
    me.lc       = (lay.url < 0)? lay.link : lay.url;
    me.counter  = 0;

    if (me.lc == -1) return;

    var prefs = st.prefs();

    me.timeout  = Math.max(50, prefs.getIntPref("timeout.google"));
    me.ageCheck = prefs.getBoolPref('gc.check.age');
    me.ageLimit = prefs.getIntPref('gc.age');
    me.requery  = google.requery;

    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, google.img);

    google.placeButtons(me);
    google.next(me, 100);
};
