var sape = sape || {};

if (!sape.likes) sape.likes =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    skip: false,
    img: "chrome://wmsape/skin/social/twitter.png",
    anonymous: true,
    lay: {}
};

sape.likes.checkRow = function(row, url)
{
    var me = sape.likes, st = sape.toolbar;

    var div = row.querySelector('div.iSapeLikes');
    if (!div) return;

    var busy = div.querySelectorAll('span.loading');
    if (busy.length < 3)
    {
        var status = row.getAttribute('likes_checked');
        if (status === '1')
        {
            row.setAttribute('likes_checked', '2');
            sape.likes.next(sape.likes, 10 + (100 * busy.length));
        }
    }
    if (busy.length) return;

    var total = 0, cached, results = {};
    if (st.cache.enabled)
    {
        if ((cached = st.cache.pop(url, 'like')))
        {
            results = JSON.parse(cached);
        }
    }
    for (var i=0; i < me.services.length; i++)
    {
        var span = div.querySelector('span.' + me.services[i]);
        if (span && span.textContent.length)
        {
            var v = parseInt(span.textContent, 10);

            results[me.services[i]] = v;
            total += v;
        }
        else
        {
            results[me.services[i]] = 0;
            if (span)
            {
                span.parentNode.removeChild(span);
            }
        }
    }
    if (st.cache.enabled)
    {
        st.cache.push(url, 'like', JSON.stringify(results));
    }
    if (total < me.limit)
    {
        var checkbox = st.getCheckbox(row.cells[me.lay.check]);
        if (checkbox && !checkbox.checked)
        {
            checkbox.checked = true;
            checkbox.setAttribute("reason", "social");
        }
    }
    var any = div.querySelectorAll('span.like');
    if (!any.length)
    {
        var sp = div.ownerDocument.createElement('span');
            sp.textContent = '0';
            sp.title = st.str('social.title.notfound');
            sp.className = "like notfound";

        div.appendChild(sp);
    }
};

sape.likes.vkapi = function(req)
{
    var exp = /VK\.init[^\d]+(\d+)/i;
    if ((exp = exp.exec(req.responseText)) !== null)
    {
        sape.toolbar.cache.push(req.channel.URI.prePath, 'vkapi', exp[1]);
        return;
    }
    exp = /vk\:app_id[^\d\n]+(\d+)/i;
    if ((exp = exp.exec(req.responseText)) !== null)
    {
        sape.toolbar.cache.push(req.channel.URI.prePath, 'vkapi', exp[1]);
    }
};

sape.likes.farm =
{
    facebook: function(url, callback)
    {
        var req = new XMLHttpRequest();
            req.mozBackgroundRequest = true;
            req.open('GET', 'https://api.facebook.com/method/fql.query?query=select%20total_count%20from%20link_stat%20where%20url=%22' + encodeURIComponent(url) + '%22&format=json', true);
            req.timeout = 15000;

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                if (req.status == 200 && req.responseText.length)
                {
                    var res, exp = /"total_count"\:(\d+)/;
                    if ((res = exp.exec(req.responseText)) !== null)
                    {
                        callback(+res[1], 'facebook');
                        return;
                    }
                }
                callback(0, 'facebook');
            }
        };
        req.send(null);
    },

    vkontakte: function(url, callback)
    {
        var st  = sape.toolbar, exp, path;
        var api = st.cache.pop(st.getURI(url).prePath, 'vkapi');

        if (api && arguments.length == 2)
        {
            path = 'https://api.vk.com/method/likes.getList?type=sitepage&owner_id=' + api + '&count=1&v=5.20&page_url=' + encodeURIComponent(url);
        }
        else
        {
            path = 'https://vk.com/share.php?act=count&index=0&url=' + encodeURIComponent(url);
        }

        var req = new XMLHttpRequest();
            req.mozBackgroundRequest = true;
            req.open('GET', path, true);
            req.timeout = 15000;

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                if (req.status == 200 && req.responseText.length)
                {
                    if (req.channel.URI.host == 'api.vk.com')
                    {
                        exp = /"count"\:\s*(\d+)/;
                        return (exp = exp.exec(req.responseText))? callback(+exp[1], 'vkontakte') : sape.likes.farm.vkontakte(url, callback, -1);
                    }
                    else
                    {
                        exp = /VK\.Share\.count\(0\,\s*(\d+)/;
                        return (exp = exp.exec(req.responseText))? callback(+exp[1], 'vkontakte') : callback(0, 'vkontakte');
                    }
                }
                callback(0, 'vkontakte');
            }
            return 0;
        };
        req.send(null);

    },

    moimir: function(url, callback)
    {
        var req = new XMLHttpRequest();
            req.mozBackgroundRequest = true;
            req.open('GET', 'https://connect.mail.ru/share_count?url_list=' + encodeURIComponent(url), true);
            req.timeout = 15000;

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                if (req.status == 200 && req.responseText.length)
                {
                    var res, exp, total = 0;

                    exp = /\"shares\"\:(\d+)/;
                    if ((res = exp.exec(req.responseText)) !== null)
                    {
                        total += parseInt(res[1], 10);
                    }
                    exp = /\"clicks\"\:(\d+)/;
                    if ((res = exp.exec(req.responseText)) !== null)
                    {
                        total += parseInt(res[1], 10);
                    }
                    if (total)
                    {
                        callback(total, 'moimir');
                        return;
                    }
                }
                callback(0, 'moimir');
            }
        };
        req.send(null);
    },

    gplus: function(url, callback)
    {
        var req = new XMLHttpRequest();
            req.mozBackgroundRequest = true;
            req.open('GET', 'https://share.yandex.net/counter/gpp/?url=' + encodeURIComponent(url), true);
            req.timeout = 15000;

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                if (req.status == 200 && req.responseText.length)
                {
                    var res, exp = /\"(\d+)\"/;
                    if ((res = exp.exec(req.responseText)) !== null)
                    {
                        callback(parseInt(res[1], 10), 'gplus');
                        return;
                    }
                }
                callback(0, 'gplus');
            }
        };
        req.send(null);
    },

    odnoklassniki: function(url, callback)
    {
        var req = new XMLHttpRequest();
            req.mozBackgroundRequest = true;
            req.open('GET', 'https://connect.ok.ru/dk?st.cmd=extLike&uid=odklocs0&ref=' + encodeURIComponent(url), true);
            req.timeout = 15000;

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                if (req.status == 200 && req.responseText.length)
                {
                    var res, exp = /updateCount\(.*'(\d+)'\)/;
                    if ((res = exp.exec(req.responseText)) !== null)
                    {
                        callback(parseInt(res[1], 10), 'odnoklassniki');
                        return;
                    }
                }
                callback(0, 'odnoklassniki');
            }
        };
        req.send(null);
    },

    linkedin: function(url, callback)
    {
        var req = new XMLHttpRequest();
            req.mozBackgroundRequest = true;
            req.open('GET', 'http://www.linkedin.com/countserv/count/share?url=' + encodeURIComponent(url) + '&lang=en_US', true);
            req.timeout = 15000;

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                if (req.status == 200 && req.responseText.length)
                {
                    var res, exp = /\"count\"\:\s*(\d+)/;
                    if ((res = exp.exec(req.responseText)) !== null)
                    {
                        callback(parseInt(res[1], 10), 'linkedin');
                        return;
                    }
                }
                callback(0, 'linkedin');
            }
        };
        req.send(null);
    },

    pinterest: function(url, callback)
    {
        var req = new XMLHttpRequest();
            req.mozBackgroundRequest = true;
            req.open('GET', 'http://widgets.pinterest.com/v1/urls/count.json?url=' + encodeURIComponent(url), true);
            req.timeout = 15000;

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                if (req.status == 200 && req.responseText.length)
                {
                    var res, exp = /\"count\"\:\s*(\d+)/;
                    if ((res = exp.exec(req.responseText)) !== null)
                    {
                        callback(parseInt(res[1], 10), 'pinterest');
                        return;
                    }
                }
                callback(0, 'pinterest');
            }
        };
        req.send(null);
    },

    stumbleupon: function(url, callback)
    {
        var req = new XMLHttpRequest();
            req.mozBackgroundRequest = true;
            req.open('GET', 'http://badge.stumbleupon.com/badge/embed/1/?url=' + encodeURIComponent(url), true);
            req.timeout = 15000;

        req.onreadystatechange = function (aEvt)
        {
            if (req.readyState == 4)
            {
                if (req.status == 200 && req.responseText.length)
                {
                    if (req.responseText.indexOf('>Submit<') > -1)
                    {
                        callback(0, 'stumbleupon');
                        return;
                    }

                    var exp = />(\d+[^<]*)</;
                    if ((exp = exp.exec(req.responseText)) !== null)
                    {
                        var res = +(exp[1].replace(/[^\d]+/g, ''));

                        if (exp[1].indexOf('K') > -1) res = res * 1000;

                        callback(res, 'stumbleupon');
                        return;
                    }
                }
                callback(0, 'stumbleupon');
            }
        };
        req.send(null);
    }

};

sape.likes.next = function(me)
{
      var timeout = (arguments.length > 1)? arguments[1] : 500;
      if (me.inProgress) sape.toolbar.setTimer(me.nextone, timeout);
};

sape.likes.nextone = function()
{
    var st = sape.toolbar, me = sape.likes;

    if (!me.doc.defaultView) return;

    var rows = me.doc.getElementsByTagName('tr');
    var rl   = rows.length;

    for (var i = me.first; i < rl; i++)
    {
        var row = rows[i];
        if (row.hasAttribute('likes_checked')) continue;

        var col = row.cells;
        if (col.length < me.lay.cols) continue;

        var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox) continue;

        var links = col[me.lc].getElementsByTagName("a");
        if (links.length < me.lay.idx + 1) continue;

        var href = links[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        if (!me.first) me.first = i;

        var place = col[me.lc], span;
        var aURI  = st.getURI(href);
        var pURL  = (me.checkmain)? aURI.prePath : aURI.asciiSpec;

        st.antivir(pURL, col[me.lay.check]);
        row.setAttribute('likes_checked', '1');

        var div = me.doc.createElement('div');
            div.className = 'iSapeLikes';

        for (var is=0; is < me.services.length; is++)
        {
            span = me.doc.createElement('span');
            span.className = 'like ' + me.services[is] + ' loading';
            span.textContent = '..';
            span.title = st.str('social.title.' + me.services[is]);

            div.appendChild(span);
        }
        place.appendChild(div);

        var cached, results = {};
        if (st.cache.enabled)
        {
            if ((cached = st.cache.pop(pURL, 'like')) !== null)
            {
                results = JSON.parse(cached);
            }
        }

        var firstQuery = 1;
        for (var j=0; j < me.services.length; j++)
        {
            span = place.querySelector('span.' + me.services[j]);

            if (me.services[j] in results)
            {
                span.textContent = (results[me.services[j]])? '' + results[me.services[j]] : '';
                span.className = span.className.replace('loading', '');
            }
            else
            {
                firstQuery = 0;
                var callback = function(text, serviceName)
                {
                        var sp = row.querySelector('span.' + serviceName);
                        if (sp)
                        {
                            sp.textContent = (parseInt('' + text, 10))? text : '';
                            sp.className = sp.className.replace('loading', '');
                        }
                        me.checkRow(row, pURL);
                };
                me.farm[me.services[j]](pURL, callback);
            }
        }
        if (firstQuery) me.checkRow(row, pURL);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('nice'), st.str('social.finish'), 2, me.img);
    }
};

sape.likes.unload = function()
{
    var me = sape.likes;

    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.likes.start = function()
{
    var st = sape.toolbar, me = sape.likes, doc = st.getDocument();
    if (!st.inside(doc))
    {
        st.openService('SOC');
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('bad'), st.str('social.stop'), 2, me.img);
        return;
    }
    if (me.doc) me.unload();

    var lay   = st.layout(doc);
    var prefs = st.prefs();

    me.skip = prefs.getBoolPref("re.check");
    me.doc  = doc;
    me.lay  = lay;
    me.lc   = (lay.url < 0)? lay.link : lay.url;

    me.limit     = prefs.getIntPref("social.limit");
    me.checkmain = prefs.getBoolPref("social.main");
    me.anonymous = prefs.getBoolPref("anonymous");

    me.services  = new Array();
    if (prefs.getBoolPref("social.vkontakte"))     me.services.push('vkontakte');
    if (prefs.getBoolPref("social.facebook"))      me.services.push('facebook');
    if (prefs.getBoolPref("social.odnoklassniki")) me.services.push('odnoklassniki');
    if (prefs.getBoolPref("social.moimir"))        me.services.push('moimir');
    if (prefs.getBoolPref("social.gplus"))         me.services.push('gplus');
    if (prefs.getBoolPref("social.linkedin"))      me.services.push('linkedin');
    if (prefs.getBoolPref("social.pinterest"))     me.services.push('pinterest');
    if (prefs.getBoolPref("social.stumbleupon"))   me.services.push('stumbleupon');

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    if (me.lc < 0) return;
    me.first        = 0;
    me.inProgress   = 1;

    st.showAlert(st.str('nice'), st.str('social.start'), 1, me.img);
    me.next(me, 100);
};
