var sape = sape || {};

if (!sape.linkpad) sape.linkpad =
{
    sapi: 'http://xml.linkpad.ru/?url=',
    surl: 'http://linkpad.ru/default.aspx',
    inProgress: 0,
    doc: null,
    lc: -1,
    lay: {},
    pages: {},
    total: {},
    inout: {},
    average: {},
    img: "chrome://wmsape/skin/linkpad.png",
    timeout: 500
};

sape.linkpad.show = function(host, place, checkbox, dataString)
{
    var st = sape.toolbar, me = sape.linkpad;

    var notAvailable = (!dataString);
    var res = (notAvailable)? {} : JSON.parse(dataString);

    var div = me.doc.createElement('div');
        div.className = 'linkpadPlace';

    var linkStyle = function(exp)
    {
        return (exp)? 'color:red; font-weight:bold;' : 'color:green; font-weight:bold;';
    };
    var spanStyle = function(exp)
    {
        return (exp)? 'color:red; cursor:help;' : 'color:green; cursor:help;';
    };
    var URI = st.getURI(host);

    var pagesText = (notAvailable)? 'n/a' : res.pages;
    var pagesLink = me.doc.createElement('a');
        pagesLink.target = '_blank';
        pagesLink.textContent = pagesText;
        pagesLink.href = me.surl + '?r=13&i=' + encodeURIComponent(URI.asciiHost);
    if (isFinite(pagesText))
    {
        pagesLink.setAttribute('style', linkStyle(+pagesText < me.pages.limit));
    }
    div.appendChild(me.doc.createTextNode(st.str('solomono.pages') + '\xA0'));
    div.appendChild(pagesLink);

    var outText = (notAvailable)? 'n/a' : ((me.domains)? res.dout : res.hout);
    var outLink = me.doc.createElement('a');
        outLink.target = '_blank';
        outLink.textContent = outText;
        outLink.href = me.surl + ((me.domains)? '?r=16&i=' : '?r=15&i=') + encodeURIComponent(URI.asciiHost);
    if (isFinite(outText))
    {
        outLink.setAttribute('style', linkStyle(outText > me.total.limit));
    }
    div.appendChild(me.doc.createElement('br'));
    div.appendChild(me.doc.createTextNode((me.domains)? st.str('solomono.dout') + '\xA0' : st.str('solomono.hout') + '\xA0'));
    div.appendChild(outLink);

    if (isFinite(pagesText) && me.pages.check && (+pagesText < me.pages.limit))
    {
        checkbox.checked = true;
        checkbox.setAttribute("reason", "outlinks");
    }
    if (isFinite(pagesText) && isFinite(outText) && res.pages > 0)
    {
        var average = ((me.domains)? res.dout : res.hout) / res.pages;

        if (me.total.check && (+outText > me.total.limit))
        {
            checkbox.checked = true;
            checkbox.setAttribute("reason", "outlinks");
        }
        if (me.average.check && (+average > (me.average.limit / me.average.pages)))
        {
            checkbox.checked = true;
            checkbox.setAttribute("reason", "outlinks");
        }
        if (average >= 0.01)
        {
            var averageSpan = me.doc.createElement('span');
                averageSpan.textContent = '\xA0[' + average.toFixed(2) + ']';
                averageSpan.title = st.str('solomono.average');
                averageSpan.setAttribute('style', spanStyle(average > (me.average.limit / me.average.pages)));

            div.appendChild(averageSpan);
        }
    }

    var inText  = (notAvailable)? 'n/a' : ((me.domains)? res.din : res.hin);
    var inLink = me.doc.createElement('a');
        inLink.target = '_blank';
        inLink.textContent = inText;
        inLink.href = me.surl + ((me.domains)? '?r=4&i=' : '?r=3&i=') + encodeURIComponent(URI.asciiHost);
    if (isFinite(inText))
    {
        inLink.setAttribute('style', linkStyle(0));
    }
    div.appendChild(me.doc.createElement('br'));
    div.appendChild(me.doc.createTextNode((me.domains)? st.str('solomono.din') + '\xA0' : st.str('solomono.hin') + '\xA0'));
    div.appendChild(inLink);

    if (isFinite(inText) && isFinite(outText) && (outText > inText))
    {
        var inout = (me.domains)? (res.dout / Math.max(res.din, 1)) : (res.hout / Math.max(res.hin, 1));
        var needCheck = true;
        if (isFinite(pagesText))
        {
            needCheck = (me.domains)? (outText > pagesText/100) : (outText > pagesText/10);
        }
        if (needCheck && me.inout.check && (inout > me.inout.limit))
        {
            checkbox.checked = true;
            checkbox.setAttribute("reason", "outlinks");
        }
        if (needCheck && inout >= 0.01)
        {
            var inoutSpan = me.doc.createElement('span');
                inoutSpan.title = st.str('solomono.inout');
                inoutSpan.textContent = '\xA0[' + inout.toFixed(2) + ']';
                inoutSpan.setAttribute('style', spanStyle(inout > me.inout.limit));

            div.appendChild(inoutSpan);
        }
    }
    place.appendChild(div);
};

sape.linkpad.run = function(host, place, checkbox)
{
    var st  = sape.toolbar, me = sape.linkpad, doc = place.ownerDocument;
    var url = me.sapi + encodeURIComponent(host.split('/')[2]);

    var loader = doc.createElement("img");
        loader.src = 'chrome://wmsape/skin/ajax-loader.gif';

    if  (place.hasAttribute("linkpad_rank")) return;
    else place.setAttribute("linkpad_rank", 1);

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                if (loader) place.removeChild(loader);

                if (req.status == 200 && req.responseText.length)
                {
                    var xml = req.responseXML;

                    var xml_hin   = xml.querySelector('hin');
                    var xml_din   = xml.querySelector('din');
                    var xml_hout  = xml.querySelector('hout');
                    var xml_dout  = xml.querySelector('dout');
                    var xml_pages = xml.querySelector('index');

                    var data = {};
                        data.hin   = (xml_hin)?   parseInt(xml_hin.textContent, 10) : 0;
                        data.din   = (xml_din)?   parseInt(xml_din.textContent, 10) : 0;
                        data.hout  = (xml_hout)?  parseInt(xml_hout.textContent, 10) : 0;
                        data.dout  = (xml_dout)?  parseInt(xml_dout.textContent, 10) : 0;
                        data.pages = (xml_pages)? parseInt(xml_pages.textContent, 10) : 0;

                    if (xml_pages) correct = 1;
                    if (correct)
                    {
                        var dataString = JSON.stringify(data);

                        if (st.cache.enabled) st.cache.push(host, 'lpad', dataString);
                        me.show(host, place, checkbox, dataString);
                    }
                }
                if (req.status == 503)
                {
                    if (me.inProgress)
                        st.showAlert(st.str('bad'), st.str('ya.503'), 2, me.img);

                    me.inProgress = 0;
                }
                if (!correct)
                {
                    me.show(host, place, checkbox, null);
                }
                me.next(me, 100);
        }
    };
    place.appendChild(loader);
    req.send(null);
};

sape.linkpad.next = function(me)
{
      var timeout = (arguments.length > 1)? arguments[1] : me.timeout;
      if (me.inProgress) sape.toolbar.setTimer(me.nextone, timeout);
};


sape.linkpad.nextone = function()
{
    var st = sape.toolbar, me = sape.linkpad;
    if (!me.inProgress) return;

    if (!me.doc || !me.doc.defaultView)
    {
        me.unload();
        return;
    }
    var row = me.doc.getElementsByTagName('tr');

    for (var i=0; i < row.length; i++)
    {
        if (row[i].hasAttribute('linkpad')) continue;

        var col = row[i].cells;
        if (col.length < me.lay.cols) continue;

		var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox || (checkbox.checked && me.skip)) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var href = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var host = st.getURL(href).split('/')[2].replace(/^www\./i, '');
            host = 'http://' + host + '/';

        row[i].setAttribute("linkpad", 1);

        if (st.cache.enabled)
        {
            var dataString = st.cache.pop(host, 'lpad');
            if (dataString)
            {
                me.show(host, col[me.lc], checkbox, dataString);
                continue;
            }
        }
        me.run(host, col[me.lc], checkbox);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('nice'), st.str('ya.finish'), 2, me.img);
    }
};

sape.linkpad.unload = function()
{
    var me = sape.linkpad;

    if (me.doc && me.doc.defaultView) me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
    me.inProgress = 0;
};

sape.linkpad.init = function()
{
    var st = sape.toolbar, me = sape.linkpad, prefs = st.prefs();

    me.skip    = prefs.getBoolPref("re.check");
    me.domains = prefs.getBoolPref("linkpad.domains");

    me.pages.check   = prefs.getBoolPref("linkpad.pages.check");
    me.pages.limit   = prefs.getIntPref("linkpad.pages.limit");

    me.total.check   = prefs.getBoolPref("linkpad.total.check");
    me.total.limit   = prefs.getIntPref("linkpad.total.limit");

    me.inout.check   = prefs.getBoolPref("linkpad.inout.check");
    me.inout.limit   = prefs.getIntPref("linkpad.inout.limit");

    me.average.check = prefs.getBoolPref("linkpad.average.check");
    me.average.limit = prefs.getIntPref("linkpad.average.limit");
    me.average.pages = Math.max(1, prefs.getIntPref("linkpad.average.pages"));
};

sape.linkpad.start = function()
{
    var st = sape.toolbar, me = sape.linkpad;

    var doc = st.getDocument();
    if (!st.inside(doc))
    {
        st.openService('D');
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('bad'), st.str('ya.stop'), 2, me.img);
        return;
    }
    if (me.doc) me.unload(me);

    me.doc = st.getDocument();

    var lay = st.layout(me.doc);
    me.lc   = (lay.url == -1)? lay.link : lay.url;
    me.lay  = lay;

    if (me.lc < 0) return;

    me.init();

    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, me.img);

    me.doc.defaultView.addEventListener('unload', me.unload, false);

    for (var i=1; i < 4; i++) me.next(me, 500*i);
};