var sape = sape || {};

sape.megaindex =
{
    login: null,
    password: null,
    img: "chrome://wmsape/skin/megaindex.png"
};

sape.megaindex.getLogin = function()
{
    var info = {login: null, password: null};
    var host = "chrome://wmsape/megaindex";

    if ("@mozilla.org/login-manager;1" in Components.classes)
    {
        try
        {
            var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
            var logins = myLoginManager.findLogins({}, host, null, 'Megaindex Registration');
            if (logins.length)
            {
                info.login = logins[0].username;
                info.password = logins[0].password;
            }
        }
        catch(ex) {}
     }
     return info;
};

sape.megaindex.init = function()
{
    var info = sape.megaindex.getLogin();

    sape.megaindex.login = info.login;
    sape.megaindex.password = info.password;
};

sape.megaindex.isError = function(result, me)
{
    var st = sape.toolbar;

    if (result.status)
    {
        if (me.inProgress)
        {
            st.showAlert(result.err_msg.toString(), 'Megaindex', 2, sape.megaindex.img);
        }
        me.inProgress = 0;
        return true;
    }
    return false;
};

// ─────────────────────────────────────────────────────────────────────────────
// Проверка на вылет из индекса Google (GS)
// ─────────────────────────────────────────────────────────────────────────────

sape.megaindex.gs = function(link, place, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gs, URI = st.getURI(link);

    var host = URI.host.replace(/^www\./i, '');

    var url = 'http://api.megaindex.ru/scan_google_indexed_pages?host=' + encodeURIComponent(host);
    if (sape.megaindex.login && sape.megaindex.password)
    {
        url += '&user=' + encodeURIComponent(sape.megaindex.login) + '&password=' + encodeURIComponent(sape.megaindex.password);
    }

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 30000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            var correct = 0;
            if ((req.status == 200) && req.responseText.length)
            {
                   var result = JSON.parse(req.responseText.trim());

                   if (sape.megaindex.isError(result, me))
                   {
                       row.removeAttribute(me.rowName);
                       return;
                   }
                   var inIndex = (result.data !== null)? +result.data : -1;
                   if (inIndex > -1)
                   {
                       correct = 1;
                       me.decorate(link, place, row, +inIndex);

                       if (st.cache.enabled)
                       {
                            st.cache.push(host, 'gs', inIndex);
                       }
                   }
            }
            if (!correct)
            {
                me.decorate(link, place, row, -1);
            }
            if (me.inProgress) google.next(me, 10);
        }
    };
    try {req.send(null);} catch(e) {req.abort();}
};

// ─────────────────────────────────────────────────────────────────────────────
// Проверка индексации страниц в Google (GP)
// ─────────────────────────────────────────────────────────────────────────────

sape.megaindex.gp = function(link, place, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gp, URI = st.getURI(link);

    URI.host = URI.host.replace(/^www\./i, '');
    var page = URI.host + URI.path;

    var url = 'http://api.megaindex.ru/scan_google_page_index?url=' + encodeURIComponent(page);
    if (sape.megaindex.login && sape.megaindex.password)
    {
        url += '&user=' + encodeURIComponent(sape.megaindex.login) + '&password=' + encodeURIComponent(sape.megaindex.password);
    }

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 30000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            var correct = 0;
            if ((req.status == 200) && req.responseText.length)
            {
                   var result = JSON.parse(req.responseText.trim());

                   if (sape.megaindex.isError(result, me))
                   {
                       row.removeAttribute(me.rowName);
                       return;
                   }
                   var inIndex = (result.data !== null)? +result.data : -1;
                   if (inIndex > -1)
                   {
                       correct = 1;
                       if (inIndex && result.www)
                       {
                           URI.host = 'www.' + URI.host;
                       }
                       if (st.cache.enabled)
                       {
                           st.cache.push(URI.spec, 'gp', inIndex);
                       }
                       me.decorate(URI.spec, place, row, +inIndex);
                   }
            }
            if (!correct)
            {
                me.decorate(link, place, row, -1);
            }
            if (me.inProgress) google.next(me, 10);
        }
    };
    try {req.send(null);} catch(e) {req.abort();}
};
