var sape = sape || {};

if (!sape.mozrank) sape.mozrank =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    lay: {},
    img: "chrome://wmsape/skin/seomoz.png",
    check: {},
    limit: {},
    urls: [],
    apiURL: 'https://lsapi.seomoz.com/linkscape/url-metrics/',
    apiOptions: {'secret_key':'', 'expires':0, 'access_id':'', 'Cols':'103079264260'}
};

sape.mozrank.isExpired = function()
{
    return (Math.floor(Date.now() / 1000) > sape.mozrank.apiOptions.expires);
};

sape.mozrank.ping = function(callback)
{
    var me = sape.mozrank, o = me.apiOptions;

    Components.utils["import"]("resource://wmsape/hmac-sha1.jsm", me);
    o.expires = Math.floor(Date.now() / 1000) + 300;

    var text2sign = o.access_id + "\n" + o.expires;

    var signature = me.CryptoJS.HmacSHA1(text2sign, o.secret_key);
    var signatureInBase64 = me.CryptoJS.enc.Base64.stringify(signature);

    me.apiURL  = 'http://lsapi.seomoz.com/linkscape/url-metrics/?Cols=' + o.Cols;
    me.apiURL += '&AccessID='  + o.access_id;
    me.apiURL += '&Expires='   + o.expires;
    me.apiURL += '&Signature=' + encodeURIComponent(signatureInBase64);

    if (callback) callback();
};

sape.mozrank.show = function(link, place, checkbox, dataString)
{
    var st = sape.toolbar, me = sape.mozrank;

    var infoURL = 'http://www.opensiteexplorer.org/links.html?site=' + encodeURIComponent(link);

    var notAvailable = (!dataString);
    var res = (notAvailable)? null : JSON.parse(dataString);

    var mozRank       =   (notAvailable)? 0 : parseFloat(res.umrp);
    var pageAuthority =   (notAvailable)? 1 : parseFloat(res.upa);
    var domainMozRank =   (notAvailable)? 0 : parseFloat(res.fmrp);
    var domainAuthority = (notAvailable)? 1 : parseFloat(res.pda);

    var div = me.doc.createElement('div');
        div.className = 'mozPlace';

    var linkStyle = function(exp)
    {
        return (exp)? 'color:red; font-weight:bold;' : 'color:green; font-weight:bold;';
    };
    if (me.check.domain)
    {
        var domainMozRankString   = (notAvailable || (Math.floor(domainMozRank) === 0))? 'n/a' : domainMozRank.toFixed(2);
        var domainAuthorityString = (notAvailable || (Math.floor(domainAuthority) === 1))? 'n/a' : domainAuthority.toFixed(0);

        var domainMozRankLink = me.doc.createElement('a');
            domainMozRankLink.setAttribute('href', infoURL);
            domainMozRankLink.setAttribute('target', '_blank');
            domainMozRankLink.textContent = domainMozRankString;
        if (domainMozRankString !== 'n/a')
        {
            domainMozRankLink.setAttribute('style', linkStyle(domainMozRank < me.limit.mR));

        }
        var domainAuthorityLink = me.doc.createElement('a');
            domainAuthorityLink.setAttribute('href', infoURL);
            domainAuthorityLink.setAttribute('target', '_blank');
            domainAuthorityLink.textContent = domainAuthorityString;
        if (domainAuthorityString !== 'n/a')
        {
            domainAuthorityLink.setAttribute('style', linkStyle(domainAuthority < me.limit.pA));
        }
        div.appendChild(me.doc.createTextNode('Domain\xA0MozRank:\xA0'));
        div.appendChild(domainMozRankLink);
        div.appendChild(me.doc.createElement('br'));
        div.appendChild(me.doc.createTextNode('Domain\xA0Authority:\xA0'));
        div.appendChild(domainAuthorityLink);
    }
    else
    {
        var mozRankString       = (notAvailable || (Math.floor(mozRank) === 0))? 'n/a' : mozRank.toFixed(2);
        var pageAuthorityString = (notAvailable || (Math.floor(pageAuthority) === 1))? 'n/a' : pageAuthority.toFixed(0);

        var mozRankLink = me.doc.createElement('a');
            mozRankLink.setAttribute('href', infoURL);
            mozRankLink.setAttribute('target', '_blank');
            mozRankLink.textContent = mozRankString;
        if (mozRankString !== 'n/a')
        {
            mozRankLink.setAttribute('style', linkStyle(mozRank < me.limit.mR));

        }
        var pageAuthorityLink = me.doc.createElement('a');
            pageAuthorityLink.setAttribute('href', infoURL);
            pageAuthorityLink.setAttribute('target', '_blank');
            pageAuthorityLink.textContent = pageAuthorityString;
        if (pageAuthorityString !== 'n/a')
        {
            pageAuthorityLink.setAttribute('style', linkStyle(pageAuthority < me.limit.pA));
        }
        div.appendChild(me.doc.createTextNode('MozRank:\xA0'));
        div.appendChild(mozRankLink);
        div.appendChild(me.doc.createElement('br'));
        div.appendChild(me.doc.createTextNode('Page\xA0Authority:\xA0'));
        div.appendChild(pageAuthorityLink);
    }

    place.appendChild(div);

    if (!me.check.na && notAvailable) return;
    if (!checkbox.checked)
    {
        var a, b;
        if (me.check.domain)
        {
            a = (me.check.pA && (domainAuthority < me.limit.pA)) || (me.check.pA && me.check.na && (domainAuthorityString === 'n/a'));
            b = (me.check.mR && (domainMozRank < me.limit.mR))   || (me.check.mR && me.check.na && (domainMozRankString === 'n/a'));
        }
        else
        {
            a = (me.check.pA && (pageAuthority < me.limit.pA)) || (me.check.pA && me.check.na && (pageAuthorityString === 'n/a'));
            b = (me.check.mR && (mozRank < me.limit.mR))       || (me.check.mR && me.check.na && (mozRankString === 'n/a'));
        }
        checkbox.checked = (me.check.both)? a&&b : a||b;
        if (checkbox.checked)
        {
            checkbox.setAttribute("reason", "mozrank");
            me.counter++;
        }
    }
};

sape.mozrank.cleanup = function()
{
    var me = sape.mozrank;

    if (!me.doc || !me.doc.defaultView) return;

    var row = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i = 1; i < rl; i++)
    {
        if (!row[i].hasAttribute('mozrank')) continue;
        if ( row[i].getAttribute('mozrank') == '1')
        {
            var loader = row[i].querySelector('b.mozrank-loader');
            if (loader) loader.parentNode.removeChild(loader);
            row[i].removeAttribute('mozrank');
        }
    }
};

sape.mozrank.fill = function(data)
{
    var st = sape.toolbar, me = sape.mozrank;

    if (!me.doc || !me.doc.defaultView) return;

    var linksEqual = function(link1, link2)
    {
        var l1 = link1.replace(/[\/]+$/, '').toLowerCase();
        var l2 = link2.replace(/[\/]+$/, '').toLowerCase();

        return (l1 == l2);
    };

    var row = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i = 1; i < rl; i++)
    {
        if (!row[i].hasAttribute('mozrank')) continue;
        if ( row[i].getAttribute('mozrank') == '1')
        {
            var loader = row[i].querySelector('b.mozrank-loader');
            if (loader) loader.parentNode.removeChild(loader);

            var col = row[i].cells;
            if ((me.lay.cols > 0) && (col.length < me.lay.cols)) continue;

            var checkbox = st.getCheckbox(col[me.lay.check]);
            if (!checkbox || (checkbox.checked && me.skip)) continue;

            var a = col[me.lc].getElementsByTagName('a');
            if (a.length < me.lay.idx + 1) continue;

            var url  = a[me.lay.idx].getAttribute('href');
            if (!st.urlCheck(url)) continue;

            var aURI = st.getURI(url);
            var pURL = (me.check.domain)? aURI.asciiHost : aURI.asciiHost + aURI.path.substring(0, aURI.path.indexOf('#')) + aURI.path.substring(aURI.path.indexOf('#'));

            var foundLink = false;
            for (var j=0; j < data.length; j++)
            {
                if (('uu' in data[j]) && linksEqual(data[j].uu, pURL))
                {
                    var dataString = JSON.stringify(data[j]);
                    if (st.cache.enabled)
                    {
                        st.cache.push(pURL, 'mozrank', dataString);
                    }
                    sape.mozrank.show(pURL, col[me.lc], checkbox, dataString);
                    foundLink = true;
                    break;
                }
            }
            if (!foundLink)
            {
                sape.mozrank.show(pURL, col[me.lc], checkbox, null);
            }
            row[i].setAttribute('mozrank', '2');
        }
    }
};

sape.mozrank.run = function()
{
    var st = sape.toolbar, me = sape.mozrank;

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('POST', me.apiURL, true);
        req.timeout = 30000;

    var data = JSON.stringify(me.urls);
        req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        req.setRequestHeader('Content-Length', data.length);

    req.onreadystatechange = function(aEvt)
    {
        if (req.readyState == 4)
        {
            if (req.status !== 200)
            {
                me.errorCounter += 1;

                if (req.status == 429)
                {
                    me.timeout = 10000;
                }
                if (me.errorCounter > 2)
                {
                    st.showAlert(st.str('mozrank.error.3'), 'Moz', 2, me.img);
                    me.cleanup();
                    me.unload();
                }
                else
                {
                    sape.mozrank.urls = JSON.parse(data);
                    me.next();
                }
                return;
            }
            if (req.status == 200 && req.responseText.length)
            {
                try
                {
                    var result = JSON.parse(req.responseText);
                    if (result.length)
                    {
                        me.errorCounter = 0;
                        me.fill(result);
                        me.next();
                        return;
                    }
                }
                catch(ex) {}
            }
        }
    };
    me.urls = [];
    req.send(data);
};

sape.mozrank.nextone = function()
{
    var st = sape.toolbar, me = sape.mozrank;
    if (!me.inProgress) return;

    if (sape.mozrank.isExpired())
    {
        me.ping(me.nextone);
        return;
    }
    if (me.urls.length)
    {
        me.run();
        return;
    }
    if (!me.doc || !me.doc.defaultView) return;

    var row = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i = me.first; i < rl; i++)
    {
        if (row[i].hasAttribute('mozrank')) continue;

        var col = row[i].cells;
        if ((me.lay.cols > 0) && (col.length < me.lay.cols)) continue;

        var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox || (checkbox.checked && me.skip)) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var url  = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(url)) continue;

        var aURI = st.getURI(url);
        var pURL = (me.check.domain)? aURI.asciiHost : aURI.asciiHost + aURI.path.substring(0, aURI.path.indexOf('#')) + aURI.path.substring(aURI.path.indexOf('#'));

        if (!me.first) me.first = i;

        if (st.cache.enabled)
        {
            var result = st.cache.pop(pURL, 'mozrank');
            if (result)
            {
                sape.mozrank.show(pURL, col[me.lc], checkbox, result);
                row[i].setAttribute('mozrank', '2');
                continue;
            }
        }
        row[i].setAttribute('mozrank', '1');

        var loader = me.doc.createElement('b');
            loader.className = 'mozrank-loader';
            loader.style.color = 'blue';
            loader.textContent = '\xA0...';

        col[me.lc].appendChild(loader);

        if (me.urls.indexOf(pURL) == -1)
        {
            me.urls.push(pURL);
            if (me.urls.length == 10)
            {
                me.run();
                return;
            }
        }
    }
    if (me.urls.length)
    {
        me.run();
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('ya.finish') + "\n" + st.str('links.checked') + ' ' + me.counter, 'Moz', 2, me.img);
        me.cleanup();
    }
};

sape.mozrank.next = function()
{
    var st = sape.toolbar, me = sape.mozrank;
    if (me.inProgress) st.setTimer(me.nextone, (arguments.length)? arguments[0] : me.timeout);
};

sape.mozrank.unload = function()
{
    var me = sape.mozrank;

    me.inProgress = 0;
    me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = null;
};

sape.mozrank.start = function()
{
    var st = sape.toolbar, me = sape.mozrank, doc = st.getDocument();
    if (!st.inside(doc))
    {
        st.openService('MR');
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('ya.stop') + "\n" + st.str('links.checked') + " " + me.counter, 'Moz', 2, me.img);
        return;
    }
    if (me.doc) me.unload();

    var lay = st.layout(st.getDocument());

    if ((me.lc = (lay.url == -1)? lay.link : lay.url) < 0) return;

    var prefs = st.prefs();
    me.skip         = prefs.getBoolPref("re.check");
    me.check.mR     = prefs.getBoolPref("mozrank.check.mr");
    me.check.pA     = prefs.getBoolPref("mozrank.check.pa");
    me.check.both   = prefs.getBoolPref("mozrank.check.both");
    me.check.na     = prefs.getBoolPref("mozrank.check.na");
    me.check.domain = prefs.getBoolPref("mozrank.check.domain");
    me.limit.mR     = prefs.getIntPref("mozrank.limit.mr");
    me.limit.pA     = prefs.getIntPref("mozrank.limit.pa");
    me.check.both   = me.check.both && me.check.mR && me.check.pA;
    me.timeout      = prefs.getIntPref("mozrank.timeout");

    me.apiOptions.secret_key = prefs.getCharPref("mozrank.secret_key").trim();
    me.apiOptions.access_id  = prefs.getCharPref("mozrank.access_id").trim();

    if (!me.apiOptions.secret_key || !me.apiOptions.access_id)
    {
        st.showAlert(st.str('mozrank.error.1') + "\n" + st.str('mozrank.error.2'), 'Moz', 2, me.img);
        return;
    }

    me.lay        = lay;
    me.doc        = st.getDocument();
    me.urls       = [];
    me.counter    = 0;
    me.first      = 0;
    me.inProgress = 1;
    me.errorCounter = 0;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    st.showAlert(st.str('ya.start'), 'Moz', 1, me.img);
    me.ping(me.nextone);
};