var sape = sape || {};

if (!sape.nowait) sape.nowait =
{
    waitTimer: null,
    mess: '',

    decorate: function(row, color)
    {
        var col = row.cells;
        for (var i=0; i < col.length; i++)
        {
            if (!col[i].hasAttribute("trusted") && !col[i].hasAttribute("trusted_anejo")) col[i].style.backgroundColor = color;
        }
    },

    addTask: function()
    {
        var me = sape.nowait;
        var url = 'https://www.sape.ru/ajax_task.php?act=add&task=messageSearch';
        var req  = new XMLHttpRequest();
            req.open('POST', url, true);
            req.onreadystatechange = function (aEvt)
            {
                if (req.readyState == 4)
                {
                    me.waitTimer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
                    me.waitTimer.initWithCallback(sape.nowait, 1000, Components.interfaces.nsITimer.TYPE_REPEATING_SLACK);
                }
            };
            req.setRequestHeader('Content-Length', me.mess.length);
            req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            req.send(me.mess);
    },

    notify: function()
    {
        var me = sape.nowait;
        var url = 'https://www.sape.ru/ajax_task.php?act=status&task=messageSearch';
        var req  = new XMLHttpRequest();
            req.open('POST', url, true);
            req.onreadystatechange = function (aEvt)
            {
                if (req.readyState == 4)
                {
                    if ((req.responseText.indexOf('"error":1') > -1) || (req.responseText.indexOf('"done":1') > -1))
                    {
                        me.waitTimer.cancel(); me.waitTimer = null;
                        if (req.responseText.indexOf('"done":1') > -1) me.getMessages();
                    }
                }
            };
            req.send(null);
    },

    getMessages: function()
    {
        var me = sape.nowait;
        var url = 'https://www.sape.ru/messages.php' + me.mess;
        var req  = new XMLHttpRequest();
            req.open('GET', url, true);
            req.onreadystatechange = function (aEvt)
            {
                if (req.readyState == 4) me.markIt(req.responseText);
            };
            req.send(null);
    },

    markIt: function(responseText)
    {
        var st = sape.toolbar, me = sape.nowait;

        if (!me.doc) return;

        var total = 0, url = "", urls = [], URI, host;
        var uexp = /URL <b>([^<]+)/g; uexp.lastIndex = 0;

        while ((url = uexp.exec(responseText)) !== null)
        {
            try {
                URI  = st.getURI(url[1]);
                host = URI.asciiHost.toLowerCase();
            }
            catch(ex) {continue;}

            if (urls.indexOf(host) == -1) urls[urls.length] = host;
        }
        if (!urls.length)
        {
            st.showAlert(st.str('nice'), st.str('links.no'), 0);
            return;
        }
        var blacklist = new RegExp(urls.join('|'), 'i');

        var rows = me.doc.getElementsByTagName('tr');
        for (var i=0; i < rows.length; i++)
      	{
            var col = rows[i].cells;
            if (col.length < me.lay.cols) continue;

            var checkbox = st.getCheckbox(col[me.lay.check]);
            if (!checkbox) continue;

            var as = col[me.lc].getElementsByTagName('a');
            if (as.length < me.lay.idx + 1) continue;

            var href = as[me.lay.idx].getAttribute('href');
            if (!st.urlCheck(href)) continue;

            try {
                URI  = st.getURI(href);
                host = URI.asciiHost.toLowerCase();

                if (blacklist.test(host))
                {
                    me.decorate(rows[i], me.bgcolor);
                    if (rows[i].querySelector('a.icon_stat'))
                    {
                        if (!(checkbox.checked) && rows[i].querySelector('a.stat_wait'))
                        {
                            checkbox.checked = true;
                            total++;
                        }
                    }
                    else
                    {
                        if (!(checkbox.checked))
                        {
                            checkbox.checked = true;
                            total++;
                        }
                    }
                 }
            }
            catch(err){}
        }
        if (total > 0)
        {
            st.changeSelect(me.doc, 'placementRemove');
            st.showAlert(st.str('links.checked') + ' ' + total, st.str('ya.finished'), 2);
        }
        else
        {
            st.showAlert(st.str('links.no'), st.str('ya.finished'), 2);
        }
    },

    unload: function()
    {
        var me = sape.nowait;
        if (me.doc && me.doc.defaultView)
        {
            me.doc.defaultView.removeEventListener('unload', me.unload, false);
        }
        if (me.waitTimer) me.waitTimer.cancel();
        me.doc = 0;
    },

    start: function()
    {
        var st = sape.toolbar, me = sape.nowait, doc = st.getDocument();

        if (!st.inside(doc) || me.waitTimer) return;

        me.lay = st.layout(doc);
        me.lc  = (me.lay.url < 0)? me.lay.link : me.lay.url;

        if (me.lc < 0) return;

        var m = me.lay.loc.match(/site_id\=([0-9]+)/);
        var site_id = (m)? parseInt(m[1], 10) : 0;

        var prefs = st.prefs();
        me.bgcolor      = prefs.getCharPref("bgcolor").replace(/[^0-9a-z#]+/ig,"");
        me.changeselect = prefs.getBoolPref("changeselect");

        me.mess = '?message_search=1&mode=&url_id_val=0&ps=500&user_type[]=2&site_id=' + site_id + '&message_type=4&word=%ED%E5+%E1%FB%EB%EE+%F0%E5%E0%EA%F6%E8%E8+%ED%E0+%EF%F0%E8%ED%FF%F2%F3%FE+%E7%E0%FF%E2%EA%F3';

        for (var i=0; i<16; i++)
        {
            var DT = new Date();
                DT.setDate(DT.getDate() - i);

            var DY = DT.getFullYear();
            var DM = ("0" + (DT.getMonth() + 1)).slice(-2);
            var DD = ("0" + (DT.getDate())).slice(-2);

            me.mess += '&dates[]=' + DY + '-' + DM + '-' + DD;
        }
        st.showAlert("WAIT " + st.str('nice'), st.str('ya.start'), 0);

        me.doc = st.getDocument();
        me.doc.defaultView.addEventListener('unload', me.unload, false);
        me.addTask();
    }
};