var sape = sape || {};

sape.seobudget =
{
    uid: null,
    pid: "51f21418fdabf7beab3d47c751ab1cdb",
    img: "chrome://wmsape/skin/seobudget.png"
};

sape.seobudget.getLogin = function()
{
    var info = {login: null, password: null};
    var host = "chrome://wmsape/seobudget";

    if ("@mozilla.org/login-manager;1" in Components.classes)
    {
        try
        {
            var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
            var logins = myLoginManager.findLogins({}, host, null, 'SEOBudget Registration');
            if (logins.length)
            {
                info.login = logins[0].username;
                info.password = logins[0].password;
            }
        }
        catch(ex) {}
     }
     return info;
};

sape.seobudget.init = function()
{
    function md5(str)
    {
        return sape.toolbar.md5(str);
    }
    function guid(login, password)
	{
        return (login && password && login.length && password.length)? md5(md5(login) + md5(password + md5(login))) : null;
    }
    var info = sape.seobudget.getLogin();
    sape.seobudget.uid = guid(info.login, info.password);
};

sape.seobudget.isError = function(result, me)
{
    var st = sape.toolbar;

    if (result.match(/REQUEST ERROR/i) || result.match(/PARAMETERS ERROR/i))
    {
        if (me.inProgress)
        {
            st.showAlert(st.str('bad'), st.str('seobudget.inc.query'), 2, sape.seobudget.img);
        }
        me.inProgress = 0;
        return true;
    }
    if (result.match(/BAD UID OR HAVE NO MONEY/i))
    {
        if (me.inProgress)
        {
            st.showAlert(st.str('bad'),  st.str('seobudget.inc.login'), 2, sape.seobudget.img);
        }
        me.inProgress = 0;
        return true;
    }
    return false;
};

// -----------------------------------------------
// Проверка проиндексированности страницы (YAP)
// -----------------------------------------------

sape.seobudget.yap = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yap;

    var URI  = st.getURI(link);
    var data = 'uid=' + sape.seobudget.uid + '&pid=' + sape.seobudget.pid + '&action=pindex&param1[]=' + st.safeEncode(URI.spec);

    var req = new XMLHttpRequest();
        req.open('POST', 'http://if.seobudget.ru/yazzle/', true);
        req.timeout = 30000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            var correct = 0;
            if ((req.status == 200) && req.responseText.length)
            {
                var result = req.responseText.trim();
                if (sape.seobudget.isError(result, me))
                {
                    row.removeAttribute(me.rowName);
                    return;
                }
                var inIndex = (isNaN(result))? -1 : parseInt(result, 10);
                if (inIndex > -1)
                {
                    correct = 1;
                    me.decorate(link, place, row, +inIndex);

                    if (st.cache.enabled)
                    {
                        st.cache.push(URI.spec, 'yap.0', inIndex);
                    }
                }
            }
            if (!correct)
            {
                me.decorate(link, place, row, -1);
            }
            if (me.inProgress) ya.next(me);
        }
    };
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-Length', data.length);
    try {req.send(data);} catch(e) {req.abort();}
};

// -----------------------------------------------
// Проверка проиндексированности ссылок (YAL)
// -----------------------------------------------
sape.seobudget.yal = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yal;

    var URI  = st.getURI(link);
    var text = me.getText(row.cells[me.lay.text]);
    var data = 'uid=' + sape.seobudget.uid + '&pid=' + sape.seobudget.pid + '&action=lindex&param1[]=' + st.safeEncode(URI.spec) + '&param2[]=' + st.safeEncode(text);

    var req = new XMLHttpRequest();
        req.open('POST', 'http://if.seobudget.ru/yazzle/', true);
        req.timeout = 30000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            var correct = 0;
            if ((req.status == 200) && req.responseText.length)
            {
                var result = req.responseText.trim();
                if (sape.seobudget.isError(result, me))
                {
                    row.removeAttribute(me.rowName);
                    return;
                }
                var inIndex = (isNaN(result))? -1 : parseInt(result, 10);
                if (inIndex > -1)
                {
                    correct = 1;
                    me.decorate(link, place, row, +inIndex);

                    if (st.cache.enabled)
                    {
                        var clink = URI.spec + '++' + text;

                        st.cache.push(clink, 'yal.0', inIndex);
                        if (inIndex)
                        {
                            st.cache.push(URI.spec, 'yap.0', inIndex);
                        }
                    }
                }
            }
            if (!correct)
            {
                me.decorate(link, place, row, -1);
            }
            if (me.inProgress) ya.next(me);
        }
    };
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-Length', data.length);
    try {req.send(data);} catch(e) {req.abort();}
};

// -----------------------------------------------
// Проверка на вылет из индекса (HOST)
// -----------------------------------------------

sape.seobudget.host = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.host;

    var URI   = st.getURI(link);
    var host  = URI.host.replace(/^www\./i, '');
    var hlink = 'http://' + host + '/';
    var data  = 'uid=' + sape.seobudget.uid + '&pid=' + sape.seobudget.pid + '&action=sindex&engine=yandex&param1[]=' + st.safeEncode(hlink);

    var req = new XMLHttpRequest();
        req.open('POST', 'http://if.seobudget.ru/yazzle/', true);
        req.timeout = 30000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            var correct = 0;
            if ((req.status == 200) && req.responseText.length)
            {
                   var result = req.responseText.trim();
                   if (sape.seobudget.isError(result, me))
                   {
                       row.removeAttribute(me.rowName);
                       return;
                   }
                   var inIndex = (isNaN(result))? -1 : parseInt(result, 10);
                   if (inIndex > -1)
                   {
                       correct = 1;
                       me.decorate(link, place, row, +inIndex);

                       if (st.cache.enabled)
                       {
                            var clink = host;
                            if (me.regionCheck) clink += '++' + me.regionNumber;
                            if (me.likeGoogle)  clink += '++' + 'sub';

                            st.cache.push(clink, 'host.0', inIndex);
                       }
                   }
            }
            if (!correct)
            {
                me.decorate(link, place, row, -1);
            }
            if (me.inProgress) ya.next(ya.host);
        }
    };
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-Length', data.length);
    try {req.send(data);} catch(e) {req.abort();}
};


// -----------------------------------------------
// Проверка на вылет из индекса Google (GS)
// -----------------------------------------------

sape.seobudget.gs = function(link, place, row)
{
    var st = sape.toolbar, google = sape.google, me = google.gs;

    var URI   = st.getURI(link);
    var host  = URI.host.replace(/^www\./i, '');
    var hlink = 'http://' + host + '/';
    var data  = 'uid=' + sape.seobudget.uid + '&pid=' + sape.seobudget.pid + '&action=sindex&engine=google&param1[]=' + st.safeEncode(hlink);

    var req = new XMLHttpRequest();
        req.open('POST', 'http://if.seobudget.ru/yazzle/', true);
        req.timeout = 30000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            var correct = 0;
            if ((req.status == 200) && req.responseText.length)
            {
                   var result = req.responseText.trim();
                   if (sape.seobudget.isError(result, me))
                   {
                       row.removeAttribute(me.rowName);
                       return;
                   }
                   var inIndex = (isNaN(result))? -1 : parseInt(result, 10);
                   if (inIndex > -1)
                   {
                       correct = 1;
                       me.decorate(link, place, row, +inIndex);

                       if (st.cache.enabled)
                       {
                            st.cache.push(host, 'gs', inIndex);
                       }
                   }
            }
            if (!correct)
            {
                me.decorate(link, place, row, -1);
            }
            if (me.inProgress) google.next(me, 10);
        }
    };
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-Length', data.length);
    try {req.send(data);} catch(e) {req.abort();}
};

// -----------------------------------------------
// Проверка уникальности контента
// -----------------------------------------------

sape.seobudget.uniq =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    rowName: 'uniq',
    lay: {}
};

sape.seobudget.uniq.next = function()
{
      var st = sape.toolbar, me = sape.seobudget.uniq;
      if (me.inProgress) st.setTimer(me.nextone, (arguments.length)? arguments[0] : 250);
};

sape.seobudget.uniq.show = function(place, count)
{
      var st = sape.toolbar, me = sape.seobudget.uniq;

      var b = me.doc.createElement('b');
          b.style.color = 'green';
          b.style.cursor = 'help';
          b.title = st.str('seobudget.unique');
          b.textContent = 'Q:\xA0';

      if (count == 'n/a')
      {
          b.title = st.str('seobudget.unique.no');
      }
      else
      {
          if (parseInt(count, 10) < me.limit) b.style.color = 'red';
      }
      var root = place.querySelector('.page_icons') || place;
          root.appendChild(me.doc.createTextNode(' '));
          root.appendChild(b);
          root.appendChild(me.doc.createTextNode('[' + count + ']'));
};

sape.seobudget.uniq.run = function(link, place, row)
{
    var st = sape.toolbar, me = sape.seobudget.uniq;
    var data  = 'uid=' + sape.seobudget.uid + '&pid=' + sape.seobudget.pid + '&action=punique&param1[]=' + st.safeEncode(link);

    var loader = me.doc.createElement("img");
        loader.src = 'chrome://wmsape/skin/ajax-loader.gif';

    if  (row.hasAttribute(me.rowName)) return;
    else row.setAttribute(me.rowName, 1);

    var req = new XMLHttpRequest();
        req.open('POST', 'http://if.seobudget.ru/yazzle/', true);
        req.timeout = 30000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            if (loader) place.removeChild(loader);
            if (req.status == 200 && req.responseText.length)
            {
                var result = req.responseText;
                if (sape.seobudget.isError(result, me))
                {
                    row.removeAttribute(me.rowName);
                    return;
                }
                if (parseInt(result, 10) > -1)
                {
                    me.show(place, result.toString() + '%');
                    if (st.cache.enabled) st.cache.push(link, 'unique', result.toString() + '%');

                    if (me.checkit && parseInt(result, 10) < me.limit)
                    {
                        var checkbox = st.getCheckbox(row.cells[me.lay.check]);
                        if (checkbox) checkbox.checked = true;
                    }
                    me.next(100);
                    return;
                }
            }
            me.show(place, 'n/a');
            if (st.cache.enabled) st.cache.push(link, 'unique', 'n/a');
            me.next(100);
        }
    };
    req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    req.setRequestHeader('Content-Length', data.length);

    place.appendChild(loader);
    try {req.send(data);} catch(e) {req.abort();}
};

sape.seobudget.uniq.nextone = function()
{
      var st = sape.toolbar, me = sape.seobudget.uniq;
      if (!me.inProgress || !me.doc || !me.doc.defaultView) return;

      var row = me.doc.getElementsByTagName('tr'), rl = row.length;
      for (var i=0; i < rl; i++)
      {
        if (row[i].hasAttribute(me.rowName)) continue;

        var col = row[i].cells;
        if (col.length < me.lay.cols) continue;

        var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var link  = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(link)) continue;

        var place = col[me.lc].querySelector('div.page_icons');
        if (!place)
        {
            place = me.doc.createElement('div');
            place.className = 'page_icons';
            col[me.lc].appendChild(place);
        }
        var crow = row[i];

        if (st.cache.enabled)
        {
            var _cache = st.cache.pop(link, 'unique');
            if (_cache !== null)
            {
                crow.setAttribute(me.rowName, 1);
                me.show(place, _cache);
                if (me.checkit && (_cache !== 'n/a') && (parseInt(_cache, 10) < me.limit)) checkbox.checked = true;
                continue;
            }
        }
        me.run(link, place, crow);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('nice'), st.str('ya.finish'), 2, sape.seobudget.img);
    }
};

sape.seobudget.uniq.unload = function()
{
    var me = sape.seobudget.uniq;
    if (me.doc && me.doc.defaultView) me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = me.inProgress = 0;
};

sape.seobudget.uniq.start = function()
{
    var st = sape.toolbar, me = sape.seobudget.uniq;

    var doc = st.getDocument();
    if (!st.inside(doc)) return;

    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('bad'), st.str('ya.stop'), 2, sape.seobudget.img);
        return;
    }
    if (me.doc) me.unload();

    sape.seobudget.init();

    var lay = st.layout(doc);
    me.lc   = (lay.url == -1)? lay.link : lay.url;
    me.lay  = lay;

    if (me.lc < 0) return;

    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    var prefs  = st.prefs();
    me.checkit = prefs.getBoolPref("seobudget.unique.check");
    me.limit   = prefs.getIntPref("seobudget.unique.limit");

    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, sape.seobudget.img);

    for (var i=0; i < 3; i++) me.next(500 * (i+1));
};