var sape = sape || {};

if (!sape.sleeps) sape.sleeps =
{
    bgc: "pink",
    show: true,
    prices: {}
};

//------------------------------------------------------------------------------
// Функции инициализации
//------------------------------------------------------------------------------

sape.sleeps.init = function(doc)
{
    if (doc.location.pathname.match(/^[\/]links.php/i))
    {
        sape.sleeps.buttonPlaceWL(doc);
    }
    if (doc.location.pathname.match(/^[\/]site_links.php/i))
    {
        var prefs = sape.toolbar.prefs();

        sape.sleeps.bgc   = prefs.getCharPref("bgcolor").replace(/[^0-9a-z#]+/ig,"");
        sape.sleeps.show  = prefs.getBoolPref("showalerts");

        sape.sleeps.buttonPlace(doc);
    }
};

//------------------------------------------------------------------------------
// Функции интерфейса
//------------------------------------------------------------------------------

sape.sleeps.buttonPlace = function(doc)
{
    var div = doc.querySelector('div.sorter_list');
    if (!div) return;

    var link_1 = doc.createElement("a");
        link_1.setAttribute("rel", "M");
        link_1.setAttribute("title", sape.toolbar.str('sleep.title.m'));
        link_1.setAttribute("style", "cursor:pointer");
        link_1.textContent = "SLEEP M";
        link_1.addEventListener("click", sape.sleeps.check, false);

    var span_1 = doc.createElement("span");
        span_1.appendChild(link_1);
        span_1.appendChild(doc.createTextNode('\xA0\xA0'));

    var link_2 = doc.createElement("a");
        link_2.setAttribute("rel", "B");
        link_2.setAttribute("style", "cursor:pointer");
        link_2.setAttribute("title", sape.toolbar.str('sleep.title.b'));
        link_2.textContent = "SLEEP B";
        link_2.addEventListener("click", sape.sleeps.check, false);

    var span_2 = doc.createElement("span");
        span_2.appendChild(link_2);
        span_2.appendChild(doc.createTextNode('\xA0\xA0'));

    var link_3 = doc.createElement("a");
        link_3.setAttribute("style", "cursor:pointer");
        link_3.setAttribute("title", sape.toolbar.str('sleep.title.d'));
        link_3.textContent = "SLEEP D";
        link_3.addEventListener("click", sape.sleeps.check_date, false);

    var span_3 = doc.createElement("span");
        span_3.appendChild(link_3);
        span_3.appendChild(doc.createTextNode('\xA0\xA0'));

    var link_4 = doc.createElement("a");
        link_4.setAttribute("style", "cursor:pointer");
        link_4.setAttribute("title", sape.toolbar.str('sleep.title.p'));
        link_4.textContent = "PRICE";
        link_4.addEventListener("click", sape.sleeps.check_price, false);

    var span_4 = doc.createElement("span");
        span_4.appendChild(link_4);
        span_4.appendChild(doc.createTextNode('\xA0\xA0'));

    div.appendChild(span_1);
    div.appendChild(span_2);
    div.appendChild(span_3);

    if (doc.location.search.match(/site_id/))
    {
        div.appendChild(span_4);
    }
};

sape.sleeps.buttonPlaceWL = function(doc)
{
    var a = doc.querySelector('a[class="ibutton ib_star"]');
    if (!a) return;

    var b = doc.createElement('a');
        b.className = "ibutton ib_star";
        b.textContent = sape.toolbar.str('clear.wl.name');
        b.title = sape.toolbar.str('clear.wl.title');
        b.setAttribute("style", "margin-left:5px !important;");
        b.addEventListener("click", sape.filters.cleanupwl, false);

    a.parentNode.appendChild(b);
};

//------------------------------------------------------------------------------
// Функции обработки заявок
//------------------------------------------------------------------------------
sape.sleeps.check = function(aEvent)
{
    var st = sape.toolbar, total = 0;

    var lnk = aEvent.originalTarget;
    var rel = lnk.getAttribute("rel");
    var doc = st.getDocument();
    var lay = st.layout(doc);

    var row  = doc.getElementsByTagName('tr');
    for (var i=0; i < row.length; i++)
    {
         var col = row[i].cells;
         if (col.length < lay.cols) continue;

         if ((col[0].textContent.indexOf('SLEEP')   > -1) && (col[0].textContent.indexOf(rel + ':') > -1))
         {
             var checkbox = st.getCheckbox(col[lay.check]);
             if (checkbox && !checkbox.checked)
             {
                 total++;
                 checkbox.checked = true;
             }
             sape.filters.decorate(row[i], sape.sleeps.bgc);
         }
    }
    if (sape.sleeps.show) st.showAlert(st.str('links.checked') + total, st.str('ya.finish'), 2);
};

sape.sleeps.check_date = function(aEvent)
{
    var st = sape.toolbar, total = 0;

    var prefs = sape.toolbar.prefs();
    var days  = prefs.getIntPref("sleep.days");

    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    var check = {value: false}; 
    var input = {value: days};

    var result = prompts.prompt(null, st.str('sleep.check.1'), st.str('sleep.check.2'), input, null, check);
    if (!result) return;

    days = parseInt(input.value, 10);
    if (!days || days < 0) return;

    sape.toolbar.prefs().setIntPref("sleep.days", days);

    var sleepTime = days * 24 * 60 * 60 * 1000;
    var nowDate = new Date();
    
    var doc = st.getDocument();
    var lay = st.layout(doc);

    var row  = doc.getElementsByTagName('tr');
    for (var i=0; i < row.length; i++)
    {
         var col = row[i].cells;
         if (col.length < lay.cols) continue;

         if (col[0].textContent.indexOf('SLEEP')   > -1)
         {
                var dateText = col[0].textContent.match(/[BM]+\:[^\d]+([0-9]+)\.([0-9]+)\.([0-9]+)/);
                if (!dateText || dateText.length < 4) continue;

                var dd = parseInt(dateText[1], 10);
                var mm = parseInt(dateText[2], 10)-1;
                var yy = parseInt(dateText[3], 10);

                if (yy < 2000) yy += 2000;

                var sleepDate = new Date(yy,mm,dd);

                if (nowDate - sleepDate > sleepTime)
                {
                    var checkbox = st.getCheckbox(col[lay.check]);
                    if (checkbox && !checkbox.checked)
                    {
                        total++;
                        checkbox.checked = true;
                    }
                    sape.filters.decorate(row[i], sape.sleeps.bgc);
                }
            }
    }
    if (sape.sleeps.show) st.showAlert(st.str('links.checked') + total, st.str('ya.finish'), 2);
};

sape.sleeps.show_price = function(doc, site_id)
{
    var st = sape.toolbar, prices = sape.sleeps.prices, lay = st.layout(doc);

    st.showAlert(st.str('sleep.alert.msg.2'), st.str('sleep.alert.title'), 0);

    var row = doc.getElementsByTagName('tr');
    for (var i=0; i < row.length; i++)
    {
         var col = row[i].cells;
         if (col.length < lay.cols) continue;

         var place = col[lay.price].querySelector('.actual_price');
         if (!place)
         {
            place = doc.createElement('div');
            place.className = 'actual_price';

            col[lay.price].appendChild(place);
         }
         place.textContent = '';

         var links = col[lay.link].getElementsByTagName("a");
         if (links.length < 1) continue;

         var href = links[0].getAttribute('href');
         if (!st.urlCheck(href)) continue;

         var aURI = st.getURI(href);
         var spec = aURI.asciiSpec;

         if (prices[site_id].hasOwnProperty(spec))
         {
            var price_now = parseFloat(col[lay.price].textContent);
            var price_actual = parseFloat(prices[site_id][spec]);

            place.textContent = prices[site_id][spec];
            place.style.color = (price_now < price_actual)? 'red' : 'blue';
         }
    }
};

sape.sleeps.check_price = function(aEvent)
{
    var st = sape.toolbar, prices = sape.sleeps.prices, doc = aEvent.target.ownerDocument, exp = /site_id=(\d+)/;

    var site_id = (exp = exp.exec(doc.location.search))? exp[1] : 0;
    if (!site_id) return;

    if (prices.hasOwnProperty(site_id))
    {
        sape.sleeps.show_price(doc, site_id);
        return;
    }
    else
    {
        prices[site_id] = {};
    }

    var data = 'fields[site_url]=site_url&fields[pages_uri]=pages_uri&fields[pages_price]=pages_price&currency=RUR&export_format=TSV&price_separator=,&site_id=' + site_id + '&referer=site_pages';

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('POST', 'https://www.sape.ru/export/linkspages/', true);
        req.timeout = 30000;
        req.overrideMimeType('text/html; charset=windows-1251');
        req.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
        req.setRequestHeader('Content-Length', data.length);

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            var text = req.responseText.trim();
            var lines = text.split("\n");

            for (var i=1; i<lines.length; i++)
            {
                try
                {
                    var parts = lines[i].split("\t");
                    if (parts.length > 2)
                    {
                        var link = parts[0].trim() + parts[1].trim();
                        if (st.urlCheck(link))
                        {
                            var spec = st.getURI(link).asciiSpec;
                            prices[site_id][spec] = parts[2].trim();
                        }
                    }
                } catch(ex) {}
            }
            sape.sleeps.show_price(doc, site_id);
        }
    };

    st.showAlert(st.str('sleep.alert.msg.1'), st.str('sleep.alert.title'), 0);
    req.send(data);
};