var sape = sape || {};

//------------------------------------------------------------------------------
// Проверка трафика
//------------------------------------------------------------------------------

if (!sape.traffic) sape.traffic =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    img: "chrome://wmsape/skin/traffic.png",
    lay: {}
};

sape.traffic.liru =
{
    baseline: 'http://counter.yadro.ru/values?site=',
    infourl: 'http://www.liveinternet.ru/stat/'
};

sape.traffic.alexa =
{
    baseline: 'http://data.alexa.com/data/?cli=10&ver=alxf-2.01&url=',
    infourl: 'http://www.alexa.com/siteinfo/'
};

sape.traffic.semrush =
{
    baseline: 'http://publicapi.semrush.com/wmsape/',
    infourl:  'http://www.semrush.com/search.php',
    key: ''
};

sape.traffic.similarweb =
{
    baseline: 'https://api.similarweb.com/SimilarWebAddon/',
    infourl:  'https://www.similarweb.com/website/'
};

sape.traffic.next = function()
{
    if (sape.traffic.inProgress) sape.toolbar.setTimer(sape.traffic.nextone, (arguments.length)? arguments[0] : 250);
};

sape.traffic.nextone = function()
{
    var st = sape.toolbar, me = sape.traffic;
    if (!me.inProgress || !me.doc || !me.doc.defaultView) return;

    var row = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i=0; i < rl; i++)
    {
        var col = row[i].cells;
        if (col.length < me.lay.cols) continue;

		var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox || (checkbox.checked && me.skip)) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var link  = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(link)) continue;

        var URI  = st.getURI(link);
        var host = URI.asciiHost.replace(/^www./, '');

        var place = col[me.lc];

        var noa = (place.hasAttribute('alexa_rank')      || !me.alexa.checkit);
        var nos = (place.hasAttribute('semrush_rank')    || !me.semrush.checkit);
        var nol = (place.hasAttribute('liru_rank')       || !me.liru.checkit);
        var nom = (place.hasAttribute('similarweb_rank') || !me.similarweb.checkit);
        if (nos && noa && nol && nom) continue;

        if (!noa)
        {
            if (st.cache.enabled)
            {
                place.setAttribute('alexa_rank', 1);
                st.cache.pop(host, 'alexa', function(_cache)
                {
                    if (_cache !== null)
                    {
                        me.alexa.show(host, place, _cache);
                        if (parseFloat(_cache) > me.alexa.limit * 1000)
                        {
                            checkbox.setAttribute("reason", "traffic:alexa");
                            checkbox.checked = true;
                        }
                        me.nextone();
                    }
                    else
                    {
                        place.removeAttribute('alexa_rank');
                        me.alexa.run(host, place, checkbox);
                    }
                });
            }
            else
            {
                me.alexa.run(host, place, checkbox);
            }
            return;
        }

        if (!nos)
        {
            if (st.cache.enabled)
            {
                place.setAttribute('semrush_rank', 1);
                st.cache.pop(host, 'rush' + '.' + me.semrush.base, function(_cache)
                {
                    if (_cache !== null)
                    {
                        me.semrush.show(host, place, _cache);
                        if ((_cache !== 'n/a') && (parseFloat(_cache) < me.semrush.limit))
                        {
                            checkbox.setAttribute("reason", "traffic:semrush");
                            checkbox.checked = true;
                        }
                        if (_cache == 'n/a')
                        {
                            checkbox.setAttribute("nosemrush", 1);
                            me.checkData(checkbox);
                        }
                        me.nextone();
                    }
                    else
                    {
                        place.removeAttribute('semrush_rank');
                        me.semrush.run(host, place, checkbox);
                    }
                });
            }
            else
            {
                me.semrush.run(host, place, checkbox);
            }
            return;
        }

        if (!nom)
        {
            if (st.cache.enabled)
            {
                place.setAttribute('similarweb_rank', 1);
                st.cache.pop(host, 'similar', function(_cache)
                {
                    if (_cache !== null)
                    {
                        me.similarweb.show(host, place, _cache);
                        if ((_cache !== 'n/a') && (parseFloat(_cache) < me.similarweb.limit))
                        {
                            checkbox.setAttribute("reason", "traffic:similarweb");
                            checkbox.checked = true;
                        }
                        if (_cache == 'n/a')
                        {
                            checkbox.setAttribute("nosimilarweb", 1);
                            me.checkData(checkbox);
                        }
                        me.nextone();
                    }
                    else
                    {
                        place.removeAttribute('similarweb_rank');
                        me.similarweb.run(host, place, checkbox);
                    }
                });
            }
            else
            {
                me.similarweb.run(host, place, checkbox);
            }
            return;
        }

        if (!nol)
        {
            if (st.cache.enabled)
            {
                place.setAttribute('liru_rank', 1);
                st.cache.pop(host, 'liru', function(_cache)
                {
                    if (_cache !== null)
                    {
                        me.liru.show(host, place, _cache);
                        if ((_cache !== 'n/a') && (parseFloat(_cache) < me.liru.limit))
                        {
                            checkbox.setAttribute("reason", "traffic:liveinternet");
                            checkbox.checked = true;
                        }
                        if (_cache == 'n/a')
                        {
                            checkbox.setAttribute("noliru", 1);
                            me.checkData(checkbox);
                        }
                        me.nextone();
                    }
                    else
                    {
                        place.removeAttribute('liru_rank');
                        me.liru.run(host, place, checkbox);
                    }
                });
            }
            else
            {
                me.liru.run(host, place, checkbox);
            }
            return;
        }

    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('ya.finish'), st.str('traffic.name'), 2, me.img);
    }
};

sape.traffic.checkData = function(checkbox)
{
    var st = sape.toolbar, me = sape.traffic;
    if (me.notraffic)
    {
        var a = (me.semrush.checkit    && checkbox.hasAttribute('nosemrush'));
        var b = (me.alexa.checkit      && checkbox.hasAttribute('noalexa'));
        var c = (me.liru.checkit       && checkbox.hasAttribute('noliru'));
        var d = (me.similarweb.checkit && checkbox.hasAttribute('nosimilarweb'));

        var v1 = 0 + me.semrush.checkit + me.alexa.checkit + me.liru.checkit + me.similarweb.checkit;
        var v2 = 0 + a + b + c + d;

        if (v1 && (v2 == v1))
        {
            checkbox.setAttribute("reason", "traffic");
            checkbox.checked = true;
        }
    }
};

sape.traffic.formatNumber = function(text)
{
    var n = parseFloat(text);
    if (n > 1000000000)
    {
        return (n / 1000000000).toFixed(2) + 'G';
    }
    if (n > 1000000)
    {
        return (n / 1000000).toFixed(2) + 'M';
    }
    return text;
};

sape.traffic.unload = function()
{
    var me = sape.traffic;
    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    me.inProgress = me.doc = 0;
};

sape.traffic.start = function()
{
    var st = sape.toolbar, me = sape.traffic, doc = st.getDocument();
    if (!st.inside(doc))
    {
        st.openService('T');
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('ya.stop'), st.str('traffic.name'), 2, me.img);
        return;
    }
    if (me.doc) me.unload();

    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    var lay = st.layout(me.doc);
    me.lc   = (lay.url == -1)? lay.link : lay.url;
    me.lay  = lay;

    if (me.lc < 0) return;

    var prefs = st.prefs();
    me.notraffic = prefs.getBoolPref("traffic.check");
    me.skip      = prefs.getBoolPref("re.check");

    me.semrush.checkit = prefs.getBoolPref("semrush.check");
    me.semrush.limit   = prefs.getIntPref("semrush.amount");
    me.semrush.base    = prefs.getCharPref("semrush.base");

    me.alexa.checkit = prefs.getBoolPref("alexa.check");
    me.alexa.limit   = prefs.getIntPref("alexa.amount");

    me.liru.checkit = prefs.getBoolPref("liru.check");
    me.liru.limit   = prefs.getIntPref("liru.amount");

    me.similarweb.checkit = prefs.getBoolPref("similarweb.check");
    me.similarweb.limit   = prefs.getIntPref("similarweb.amount");

    var streams = 2 + me.liru.checkit + me.alexa.checkit + me.semrush.checkit + me.similarweb.checkit;
    if (streams == 2)
    {
        st.showAlert(st.str('traffic.noservice'), st.str('traffic.name'), 2, me.img);
        me.unload();
        return;
    }

    me.inProgress = 1;
    st.showAlert(st.str('ya.start'), st.str('traffic.name'), 1, me.img);

    for (var i=0; i<streams; i++) me.next(500 * (i+1));
};

//------------------------------------------------------------------------------
// LiveInternet
//------------------------------------------------------------------------------

sape.traffic.liru.show = function(host, place, text)
{
    var st = sape.toolbar, me = sape.traffic.liru, doc = place.ownerDocument;

    var div = place.querySelector('div.liTrafficPlace');
    if (!div)
    {
        div = doc.createElement('div');
        div.className = 'liTrafficPlace';

        place.appendChild(div);
    }
    else
    {
        div.appendChild(doc.createElement('br'));
    }
    var linkStyle = function(exp)
    {
        return (exp)? 'color:red; font-weight:bold;' : 'color:green; font-weight:bold;';
    };

    var liLink = doc.createElement('a');
        liLink.target = '_blank';
        liLink.href   = me.infourl + encodeURIComponent(host) + '/';
        liLink.textContent = sape.traffic.formatNumber(text);
        liLink.title = st.str('liru.help');
    if (text !== 'n/a')
    {
        liLink.setAttribute('style', linkStyle(parseFloat(text) < me.limit));
    }
    div.appendChild(doc.createTextNode('LiveInternet:\xA0'));
    div.appendChild(liLink);
};

sape.traffic.liru.run = function(host, place, checkbox)
{
    var st = sape.toolbar, me = sape.traffic.liru, doc = place.ownerDocument;

    var url = me.baseline + encodeURIComponent(host);

    var loader = doc.createElement('b');
        loader.style.color = 'green';
        loader.textContent = '\xA0...';

    if  (place.hasAttribute("liru_rank")) return;
    else place.setAttribute("liru_rank", 1);

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                if (loader) place.removeChild(loader);

                if (req.status == 200 && req.responseText.length)
                {
                    var s, exp = /LI_month_vis\s\=\s([0-9]+)/;
                    if ((s = exp.exec(req.responseText)) !== null)
                    {
                        if (s.length)
                        {
                            var vis = parseInt(s[1], 10);
                            me.show(host, place, vis); correct = 1;

                            if (me.checkit && (vis < me.limit))
                            {
                               checkbox.setAttribute("reason", "traffic:liveinternet");
                               checkbox.checked = true;
                            }
                            if (st.cache.enabled) st.cache.push(host, 'liru', vis);
                        }
                    }
                    if ((req.responseText.indexOf('Unregistered site') > -1) && st.cache.enabled) st.cache.push(host, 'liru', 'n/a');
                }
                if (!correct)
                {
                    me.show(host, place, 'n/a');
                    checkbox.setAttribute('noliru', 1);
                    sape.traffic.checkData(checkbox);
                }
                sape.traffic.next(500);
        }
    };
    place.appendChild(loader);
    req.send(null);
};

//------------------------------------------------------------------------------
// Alexa Rank
//------------------------------------------------------------------------------

sape.traffic.alexa.show = function(host, place, text)
{
    var st = sape.toolbar, me = sape.traffic.alexa, doc = place.ownerDocument;

    var div = place.querySelector('div.liTrafficPlace');
    if (!div)
    {
        div = doc.createElement('div');
        div.className = 'liTrafficPlace';

        place.appendChild(div);
    }
    else
    {
        div.appendChild(doc.createElement('br'));
    }
    var linkStyle = function(exp)
    {
        return (exp)? 'color:red; font-weight:bold;' : 'color:green; font-weight:bold;';
    };

    var alexaLink = doc.createElement('a');
        alexaLink.target = '_blank';
        alexaLink.href   = me.infourl + encodeURIComponent(host);
        alexaLink.textContent = sape.traffic.formatNumber(text);
        alexaLink.title = 'Alexa Rank';
    if (text !== 'n/a')
    {
        alexaLink.setAttribute('style', linkStyle(parseFloat(text) > me.limit * 1000));
    }
    div.appendChild(doc.createTextNode('Alexa\xA0Rank:\xA0'));
    div.appendChild(alexaLink);
};

sape.traffic.alexa.run = function(host, place, checkbox)
{
    var st = sape.toolbar, me = sape.traffic.alexa, doc = place.ownerDocument;
    var url = me.baseline + encodeURIComponent(host);

    var loader = doc.createElement('b');
        loader.style.color = 'green';
        loader.textContent = '\xA0...';

    if  (place.hasAttribute("alexa_rank")) return;
    else place.setAttribute("alexa_rank", 1);

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                if (loader) place.removeChild(loader);

                if (req.status == 200 && req.responseText.length)
                {
                    var xml = req.responseXML;
                    var rank = xml.getElementsByTagName("POPULARITY");
                    if (rank && rank.length)
                    {
                        var text = parseFloat(rank[0].getAttribute("TEXT"));
                        me.show(host, place, text); correct = 1;

                        if (me.checkit && (me.limit * 1000 < text))
                        {
                            checkbox.setAttribute("reason", "traffic:alexa");
                            checkbox.checked = true;
                        }
                        if (st.cache.enabled) st.cache.push(host, 'alexa', text);
                    }
                }
                if (!correct)
                {
                    me.show(host, place, 'n/a');
                    checkbox.setAttribute('noalexa', 1);
                    sape.traffic.checkData(checkbox);
                }
                sape.traffic.next(500);
        }
    };
    place.appendChild(loader);
    req.send(null);
};

//------------------------------------------------------------------------------
// SEMRush
//------------------------------------------------------------------------------

sape.traffic.semrush.show = function(host, place, text)
{
    var st = sape.toolbar, me = sape.traffic.semrush, doc = place.ownerDocument;

    var div = place.querySelector('div.liTrafficPlace');
    if (!div)
    {
        div = doc.createElement('div');
        div.className = 'liTrafficPlace';

        place.appendChild(div);
    }
    else
    {
        div.appendChild(doc.createElement('br'));
    }
    var linkStyle = function(exp)
    {
        return (exp)? 'color:red; font-weight:bold;' : 'color:green; font-weight:bold;';
    };

    var semLink = doc.createElement('a');
        semLink.target = '_blank';
        semLink.title  = st.str('semrush.help');
        semLink.href   = me.infourl + '?db=' + me.base + '&q=' + host
        semLink.textContent = sape.traffic.formatNumber(text);
    if (text !== 'n/a')
    {
        semLink.setAttribute('style', linkStyle(parseFloat(text) < me.limit));
    }
    div.appendChild(doc.createTextNode('SEMrush:\xA0'));
    div.appendChild(semLink);
};

sape.traffic.semrush.run = function(host, place, checkbox)
{
    var st = sape.toolbar, me = sape.traffic.semrush, doc = place.ownerDocument;
    var url = me.baseline + me.base + '/info.php?url=' + st.urlEncode(host);

    var loader = doc.createElement('b');
        loader.style.color = 'blue';
        loader.textContent = '\xA0...';

    if  (place.hasAttribute("semrush_rank")) return;
    else place.setAttribute("semrush_rank", 1);

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                if (loader) place.removeChild(loader);

                if (req.status == 200 && req.responseText.length)
                {
                    var error  = req.responseText.match(/ERROR\s(\d+)/);
                    if (!error && req.responseXML)
                    {
                        var status = req.responseXML.querySelector("status");
                        if (status && status.textContent == 'ok')
                        {
                            var traffic = req.responseXML.querySelector("traffic");
                            if (traffic)
                            {
                                var text = parseInt(traffic.textContent, 10);
                                me.show(host, place, text); correct = 1;

                                if (me.checkit && me.limit > text)
                                {
                                    checkbox.checked = true;
                                    checkbox.setAttribute("reason", "traffic:semrush");
                                }
                                if (st.cache.enabled) st.cache.push(host, 'rush' + '.' + me.base, text);
                            }
                        }
                    }
                    if (error)
                    {
                        var errn = parseInt(error[1], 10);
                        if (errn < 50)
                        {
                            st.showAlert(st.str('semrush.error.' + errn), st.str('traffic.name'), 0, sape.traffic.img);
                            me.semrush.checkit = false;
                            correct = 1;
                        }
                    }
                }
                if (!correct)
                {
                    me.show(host, place, 'n/a');
                    if (st.cache.enabled) st.cache.push(host, 'rush' + '.' + me.base, 'n/a');

                    checkbox.setAttribute('nosemrush', 1);
                    sape.traffic.checkData(checkbox);
                }
                sape.traffic.next(500);
        }
    };
    place.appendChild(loader);
    req.send(null);
};

//------------------------------------------------------------------------------
// SimilarWeb
//------------------------------------------------------------------------------

sape.traffic.similarweb.show = function(host, place, text)
{
    var st = sape.toolbar, me = sape.traffic.similarweb, doc = place.ownerDocument;

    var div = place.querySelector('div.liTrafficPlace');
    if (!div)
    {
        div = doc.createElement('div');
        div.className = 'liTrafficPlace';

        place.appendChild(div);
    }
    else
    {
        div.appendChild(doc.createElement('br'));
    }
    var linkStyle = function(exp)
    {
        return (exp)? 'color:red; font-weight:bold;' : 'color:green; font-weight:bold;';
    };

    var simLink = doc.createElement('a');
        simLink.target = '_blank';
        simLink.title  = st.str('similarweb.help');
        simLink.href   = me.infourl + host;
        simLink.textContent = sape.traffic.formatNumber(text);
    if (text !== 'n/a')
    {
        simLink.setAttribute('style', linkStyle(parseFloat(text) < me.limit));
    }
    div.appendChild(doc.createTextNode('SimilarWeb:\xA0'));
    div.appendChild(simLink);
};

sape.traffic.similarweb.run = function(host, place, checkbox)
{
    var st = sape.toolbar, me = sape.traffic.similarweb, doc = place.ownerDocument;

    var url = me.baseline + st.urlEncode(host) + '/all';

    var loader = doc.createElement('b');
        loader.style.color = 'blue';
        loader.textContent = '\xA0...';

    if  (place.hasAttribute("similarweb_rank")) return;
    else place.setAttribute("similarweb_rank", 1);

    var req = new XMLHttpRequest();
        req.mozBackgroundRequest = true;
        req.open('GET', url, true);
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        var correct = 0;
        if (req.readyState == 4)
        {
                if (loader) place.removeChild(loader);

                if (req.status == 200 && req.responseText.length)
                {
                    if (req.responseXML)
                    {
                        var traffic = req.responseXML.querySelector("Visits");
                        if (traffic)
                        {
                            var text = Math.floor(parseFloat(traffic.textContent));
                            me.show(host, place, text); correct = 1;

                            if (me.checkit && me.limit > text)
                            {
                                checkbox.checked = true;
                                checkbox.setAttribute("reason", "traffic:similarweb");
                            }
                            if (st.cache.enabled) st.cache.push(host, 'similar', text);
                        }
                    }
                }
                if (!correct)
                {
                    me.show(host, place, 'n/a');
                    if (st.cache.enabled) st.cache.push(host, 'similar', 'n/a');

                    checkbox.setAttribute('nosimilarweb', 1);
                    sape.traffic.checkData(checkbox);
                }
                sape.traffic.next(500);
        }
    };
    place.appendChild(loader);
    req.send(null);
};

