var sape = sape || {};

if (!sape.tryout) sape.tryout =
{
    doc: 0,
    inProgress: 0,
    show_mode: 0,
    reqData: '',
    reqUrl: 'https://www.sape.ru/ajax_orders.php?ajax_act=search&return_result=true',

    init: function(doc)
    {
        if (doc.getElementById('filterForm'))
        {
            sape.tryout.buttonPlace(doc);
        }
    },

    buttonPlace: function(doc)
    {
        var a = doc.getElementById('folders_options');
        if (!a) return;

        var b = doc.createElement('a');
            b.id = "wmsape_tryout_button";
            b.className = "ibutton ib_star";
            b.textContent = sape.toolbar.str('tryout.btn.text');
            b.setAttribute("style", "margin:0px 5px !important; float:right; max-width:200px;");
            b.addEventListener("click", sape.tryout.start, false);

        var div = doc.createElement('div');
            div.appendChild(b);

        if (!doc.getElementById('wmsape_tryout_button'))
        {
            a.parentNode.parentNode.appendChild(b);
        }
    },

    show: function(row, text)
    {
        var st = sape.toolbar, me = sape.tryout;

        var place = row.querySelector('div.tryout_place') || me.doc.createElement('div');
            place.className = "tryout_place";
            place.textContent = "";

        var prefix = me.doc.createElement('span');
            prefix.textContent = (me.show_mode)? st.str('tryout.result.sites') : st.str('tryout.result.pages');
            prefix.textContent += ' ';

        var span = me.doc.createElement('span');

        var exp = /id="orders_nof_results">([^<]+)</;
            exp = exp.exec(text);
        if (exp)
        {
            span.textContent = exp[1];
            span.className = 'bold_green';

            place.appendChild(prefix);
            place.appendChild(span);
        }
        else
        {
            span.textContent = st.str('tryout.result.notfound');
            span.className = 'bold_red';

            place.appendChild(span);
        }
        row.cells[2].appendChild(place);
    },

    run: function(row)
    {
        var st = sape.toolbar, me = sape.tryout, filterId = 0;

        var input = row.querySelector('input[name="filter"]');
        if (input) filterId = input.value;

        var img = me.doc.createElement('img');
            img.src = 'chrome://wmsape/skin/ajax-loader.gif';

        var loader = row.querySelector('div.tryout_place') || me.doc.createElement('div');
            loader.className = "tryout_place";
            loader.textContent = "";
            loader.appendChild(img);

        var reqData = me.reqData + '&filter=' + filterId;

        var blob = new Blob([reqData], {type: 'application/x-www-form-urlencoded'});

        var req = new XMLHttpRequest();
            req.mozBackgroundRequest = true;
            req.open('POST', me.reqUrl, true);
            req.timeout = 60000;
            req.setRequestHeader('Referer', me.reqUrl);
            req.setRequestHeader('X-Requested-With', 'XMLHttpRequest');

        req.onreadystatechange = function(aEvt)
        {
            if (req.readyState == 4)
            {
                if (loader)
                {
                    loader.textContent = "";
                }
                if (req.status == 200 && req.responseText)
                {
                    me.show(row, req.responseText);
                }
                else
                {
                    loader.textContent = st.str('tryout.result.error');
                }
                sape.tryout.next();
            }
        };
        req.send(blob);
        row.cells[2].appendChild(loader);
    },

    nextone: function()
    {
        var st = sape.toolbar, me = sape.tryout;

        if (!me.doc || !me.doc.defaultView) return;

        var table = me.doc.querySelector('table.data.stat_normal_header tbody');
        if (!table) return;

        var rows = table.getElementsByTagName('tr'), rl = rows.length;
        for (var i = 0; i < rl; i++)
        {
            if (rows[i].hasAttribute('tryout') || rows[i].cells.length < 4) continue;

            rows[i].setAttribute('tryout', 1);
            me.run(rows[i]);
            return;
        }
        if (me.inProgress)
        {
            me.inProgress = 0;
            st.showAlert(st.str('nice'), st.str('ya.finish'), 2);
        }
    },

    next: function()
    {
        var me = sape.tryout, timeout = (arguments.length)? arguments[0] : 100;
        if (me.inProgress) sape.toolbar.setTimer(me.nextone, timeout);
    },

    unload: function()
    {
        var me = sape.tryout;
        if (me.doc && me.doc.defaultView)
        {
            me.doc.defaultView.removeEventListener('unload', me.unload, false);
        }
        me.doc = me.inProgress = 0;
        me.results = {};
    },

    start: function(aEvent)
    {
        var st = sape.toolbar, me = sape.tryout;
        if (me.inProgress)
        {
            me.inProgress = 0;
            st.showAlert(st.str('bad'), st.str('ya.stop'), 2);
            return;
        }
        if (me.doc) me.unload();

        var doc = aEvent.target.ownerDocument;
        if (!st.inside(doc)) return;

        me.inProgress = 1;
        me.reqData = '';
        me.doc = doc;
        me.doc.defaultView.addEventListener('unload', me.unload, false);
        st.addCSS(me.doc);

        var form = doc.getElementById('filterForm'), input;
        if (form)
        {
            input = form.querySelector('input[name="project_id"]');
            if (input) me.reqData += 'project_id=' + input.value;

            input = form.querySelector('input[name="link_id"]');
            if (input) me.reqData += '&link_id=' + input.value;

            input = form.querySelector('input[name="act"]');
            if (input) me.reqData += '&act=' + input.value;

            input = form.querySelector('input[name="filter_mode"]');
            if (input) me.reqData += '&filter_mode=' + input.value;

            input = form.querySelector('input[name="s_only_open_url"]:checked');
            if (input) me.reqData += '&s_only_open_url=' + input.value;

            input = form.querySelector('input[name="s_double"]:checked');
            if (input) me.reqData += '&s_double=' + input.value;

            input = form.querySelector('input[name="s_pages_per_site"]:checked');
            if (input) me.reqData += '&s_pages_per_site=' + input.value;

            input = form.querySelector('select[name="show_mode"]');
            if (input)
            {
                me.reqData += '&show_mode=' + input.value;
                me.show_mode = +input.value;
            }
            me.reqData += '&pn=1&ps=1&new_search=1';
        }

        var rows = doc.querySelectorAll("table.data.stat_normal_header tbody tr");
        for (var i=0; i < rows.length; i++)
        {
            var place = rows[i].querySelector('div.tryout_place');
            if (place)
            {
                place.textContent = '';
            }
            rows[i].removeAttribute('tryout');
        }
        st.showAlert(st.str('nice'), st.str('ya.start'), 1);

        for (var j=0; j < 3; j++) me.next(100 + 3000 * j);
    }
};