var sape = sape || {};

if (!sape.xml) sape.xml =
{
    address: "http://xmlsearch.yandex.ru/xmlsearch",
    img: "chrome://wmsape/skin/xml.png"
};

sape.xml.init = function()
{
    sape.xml.address = sape.toolbar.prefs().getCharPref("xml.address").trim();
    if (!sape.xml.address.length)
    {
        sape.xml.address = 'http://xmlsearch.yandex.ru/xmlsearch';
    }
};

sape.xml.isError = function(req, me)
{
    var st = sape.toolbar, xml = req.responseXML;
    var e  = xml.querySelector("error");
    if (e)
    {
        var code = e.getAttribute("code");
        if (code !== null)
        {
            if (code == 15) return 0; // ничего не найдено
            if (me.inProgress)
            {
                st.showAlert(e.textContent, 'XML', 2, sape.xml.img);
                me.inProgress = 0;
            }
            return +code;
        }
        else
        {
            st.showAlert(e.textContent, 'XML', 2, sape.xml.img);
            return 1;
        }
    }
    return 0;
};

sape.xml.inIndex = function(req)
{
    var xml = req.responseXML;

    var e  = xml.querySelector('error');
    if (e) return 0;

    var response = xml.querySelector('response');
    if (response)
    {
        var found = response.querySelector('found[priority="all"]');
        if (found)
        {
            return parseInt(found.textContent, 10);
        }
    }
    return 0;
};

// -----------------------------------------------
// Индексация ссылки через кэш (YACL)
// -----------------------------------------------

sape.xml.yacl = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yacl;

    var URI   = st.getURI(link);
    var page  = URI.host.replace(/^www\./i, '')  + URI.path.replace(/\/$/, '');
    var q     = 'url:"' + page + '" | url:"www.' + page + '"';
    var url   = sape.xml.address;

    if (url.indexOf('?') == -1)  url += '?query=' + encodeURIComponent(q);
    else                         url += '&query=' + encodeURIComponent(q);

    if (sape.xml.address.indexOf('xmlproxy.ru/') > -1) url += '&soft_id=6';
    if (sape.xml.address.indexOf('seozoo.ru/') > -1)   url += '&developer=297';

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            var correct = 0;
            if ((req.status == 200) && req.responseXML)
            {
                   var err = sape.xml.isError(req, me);
                   if (+err !== 0)
                   {
                       row.removeAttribute(me.rowName);
                       if ((err == 32) && (ya.reinit < 100) && (ya.yandexcheck == 1))
                       {
                            me.requestURL = (ya.reinit == 3)? ya.selectURL(3) : ya.defaultURL;
                            me.inProgress = 1;

                            ya.yandexcheck = ya.reinit;
                            ya.next(me);
                       }
                       if ((err == 32) && (ya.reinit == 102) && (ya.yandexcheck == 1))
                       {
                            var nextxml = function()
                            {
                                if (me.doc && me.doc.defaultView)
                                {
                                    me.inProgress = 1;
                                    ya.next(me);
                                }
                            };
                            st.showAlert(st.str('xml.wait'), st.str('xml.error.32'), 2, sape.xml.img);
                            st.setTimer(nextxml, 600000);
                       }
                       return;
                   }

                   var inIndex = sape.xml.inIndex(req);
                   if (+inIndex > -1)
                   {
                       correct = 1;
                       var copy = req.responseXML.querySelector("saved-copy-url"), copyUrl = 0;
                       if (copy && copy.textContent)
                       {
                           copyUrl = copy.textContent.trim();
                       }
                       if (st.cache.enabled)
                       {
                           st.cache.push(URI.spec, 'yap.1', +inIndex);
                           st.cache.push(URI.spec, 'yac', copyUrl);
                       }
                       if (copyUrl)
                       {
                           me.cachequery(link, place, row, copyUrl);
                           return;
                       }
                       else
                       {
                           me.decorate(link, place, row, 0, 0);
                       }
                   }
            }
            if (!correct)
            {
                me.decorate(link, place, row, -1);
            }
            if (me.inProgress && (ya.yandexcheck == 1)) ya.next(me);
        }
    };
    try {req.send(null);} catch(e) {req.abort();}
};


// -----------------------------------------------
// Получение ссылки на сохраненную копию страницы (YAC)
// -----------------------------------------------

sape.xml.yac = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yac;

    var URI   = st.getURI(link);
    var page  = URI.host.replace(/^www\./i, '')  + URI.path.replace(/\/$/, '');
    var q     = 'url:"' + page + '" | url:"www.' + page + '"';
    var url   = sape.xml.address;

    if (url.indexOf('?') == -1)  url += '?query=' + encodeURIComponent(q);
    else                         url += '&query=' + encodeURIComponent(q);

    if (sape.xml.address.indexOf('xmlproxy.ru/') > -1) url += '&soft_id=6';
    if (sape.xml.address.indexOf('seozoo.ru/') > -1)   url += '&developer=297';

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            var correct = 0;
            if ((req.status == 200) && req.responseXML)
            {
                   var err = sape.xml.isError(req, me);
                   if (+err !== 0)
                   {
                       row.removeAttribute(me.rowName);
                       if ((err == 32) && (ya.reinit < 100) && (ya.yandexcheck == 1))
                       {
                            me.requestURL = (ya.reinit == 3)? ya.selectURL(3) : ya.defaultURL;
                            me.inProgress = 1;

                            ya.yandexcheck = ya.reinit;
                            ya.next(me);
                       }
                       if ((err == 32) && (ya.reinit == 102) && (ya.yandexcheck == 1))
                       {
                            var nextxml = function()
                            {
                                if (me.doc && me.doc.defaultView)
                                {
                                    me.inProgress = 1;
                                    ya.next(me);
                                }
                            };
                            st.showAlert(st.str('xml.wait'), st.str('xml.error.32'), 2, sape.xml.img);
                            st.setTimer(nextxml, 600000);
                       }
                       return;
                   }

                   var inIndex = sape.xml.inIndex(req);
                   if (+inIndex > -1)
                   {
                       correct = 1;
                       var copy = req.responseXML.querySelector("saved-copy-url"), copyUrl = 0;
                       if (copy && copy.textContent)
                       {
                           copyUrl = copy.textContent.trim();
                       }
                       var modtime = req.responseXML.querySelector("doc modtime");
                       if (modtime)
                       {
                           st.cache.push(URI.spec, 'ymt', modtime.textContent);
                       }
                       me.decorate(link, place, row, copyUrl);
                       if (st.cache.enabled)
                       {
                           st.cache.push(URI.spec, 'yap.1', +inIndex);
                           st.cache.push(URI.spec, 'yac', copyUrl);
                       }
                       if (copyUrl)
                       {
                           me.cachequery(link, place, row, copyUrl);
                           return;
                       }
                   }
            }
            if (!correct)
            {
                me.decorate(link, place, row, -1);
            }
            if (me.inProgress && (ya.yandexcheck == 1)) ya.next(me);
        }
    };
    try {req.send(null);} catch(e) {req.abort();}
};

// -----------------------------------------------
// Проверка проиндексированности страницы (YAP)
// -----------------------------------------------

sape.xml.yap = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yap;

    var URI   = st.getURI(link);
    var page  = URI.host.replace(/^www\./i, '')  + URI.path.replace(/\/$/, '');
    var q     = 'url:"' + page + '" | url:"www.' + page + '"';
    var url   = sape.xml.address;

    if (url.indexOf('?') == -1)  url += '?query=' + encodeURIComponent(q);
    else                         url += '&query=' + encodeURIComponent(q);

    if (sape.xml.address.indexOf('xmlproxy.ru/') > -1) url += '&soft_id=6';
    if (sape.xml.address.indexOf('seozoo.ru/') > -1)   url += '&developer=297';

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            var correct = 0;
            if ((req.status == 200) && req.responseXML)
            {
                   var err = sape.xml.isError(req, me);
                   if (+err !== 0)
                   {
                       row.removeAttribute(me.rowName);
                       if ((err == 32) && (ya.reinit < 100) && (ya.yandexcheck == 1))
                       {
                            me.requestURL = ya.selectURL(ya.reinit);
                            me.inProgress = 1;

                            ya.yandexcheck = ya.reinit;
                            ya.next(me);
                       }
                       if ((err == 32) && (ya.reinit == 102) && (ya.yandexcheck == 1))
                       {
                            var nextxml = function()
                            {
                                if (me.doc && me.doc.defaultView)
                                {
                                    me.inProgress = 1;
                                    ya.next(me);
                                }
                            };
                            st.showAlert(st.str('xml.wait'), st.str('xml.error.32'), 2, sape.xml.img);
                            st.setTimer(nextxml, 600000);
                       }
                       return;
                   }

                   var inIndex = sape.xml.inIndex(req);
                   if (+inIndex > -1)
                   {
                       correct = 1;
                       var copy = req.responseXML.querySelector("doc saved-copy-url"), copyUrl = 0;
                       if (copy && copy.textContent)
                       {
                           copyUrl = copy.textContent.trim();
                       }
                       var modtime = req.responseXML.querySelector("doc modtime");
                       if (modtime && modtime.textContent)
                       {
                           st.cache.push(URI.spec, 'ymt', modtime.textContent, function()
                           {
                               me.decorate(link, place, row, +inIndex);
                           });
                       }
                       else
                       {
                           me.decorate(link, place, row, +inIndex);
                       }
                       if (st.cache.enabled)
                       {
                           st.cache.push(URI.spec, 'yap.1', +inIndex);
                           st.cache.push(URI.spec, 'yac', copyUrl);
                       }
                   }
            }
            if (!correct)
            {
                me.decorate(link, place, row, -1);
            }
            if (me.inProgress && (ya.yandexcheck == 1)) ya.next(me);
        }
    };
    try {req.send(null);} catch(e) {req.abort();}
};

// -----------------------------------------------
// Проверка проиндексированности ссылки (YAL)
// -----------------------------------------------

sape.xml.yal = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yal;

    var URI  = st.getURI(link);
    var page = URI.host.replace(/^www\./i, '')  + URI.path.replace(/\/$/, '');
    var q    = me.getQueryText(row.cells[me.lay.text]) + ' (url:"' + page + '" | url:"www.' + page + '")';
    var url  = sape.xml.address;

    if (url.indexOf('?') == -1)  url += '?query=' + encodeURIComponent(q) + '&noreask=1&nomisspell=1';
    else                         url += '&query=' + encodeURIComponent(q) + '&noreask=1&nomisspell=1';

    if (sape.xml.address.indexOf('xmlproxy.ru/') > -1) url += '&soft_id=6';
    if (sape.xml.address.indexOf('seozoo.ru/') > -1)   url += '&developer=297';

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            var correct = 0;
            if ((req.status == 200) && req.responseXML)
            {
                   var err = sape.xml.isError(req, me);
                   if (+err !== 0)
                   {
                       row.removeAttribute(me.rowName);
                       if ((err == 32) && (ya.reinit < 100) && (ya.yandexcheck == 1))
                       {
                            me.requestURL = ya.selectURL(ya.reinit);
                            me.inProgress = 1;

                            ya.yandexcheck = ya.reinit;
                            ya.next(me);
                       }
                       if ((err == 32) && (ya.reinit == 102) && (ya.yandexcheck == 1))
                       {
                            var nextxml = function()
                            {
                                if (me.doc && me.doc.defaultView)
                                {
                                    me.inProgress = 1;
                                    ya.next(me);
                                }
                            };
                            st.showAlert(st.str('xml.wait'), st.str('xml.error.32'), 2, sape.xml.img);
                            st.setTimer(nextxml, 600000);
                       }
                       return;
                   }

                   var inIndex = sape.xml.inIndex(req);
                   if (+inIndex > -1)
                   {
                       correct = 1;
                       if (st.cache.enabled)
                       {
                           var text  = me.getText(row.cells[me.lay.text]);
                           var clink = URI.spec + '++' + text;

                           st.cache.push(clink, 'yal.1', +inIndex);
                           if (+inIndex)
                           {
                               st.cache.push(URI.spec, 'yap.1', +inIndex);
                           }
                       }
                       me.decorate(link, place, row, +inIndex);
                   }
            }
            if (!correct)
            {
                me.decorate(link, place, row, -1);
            }
            if (me.inProgress && (ya.yandexcheck == 1)) ya.next(me);
        }
    };
    try {req.send(null);} catch(e) {req.abort();}
};

// -----------------------------------------------
// Проверка релевантности анкоров
// -----------------------------------------------

sape.xml.relevancy = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.relevancy;

    var URI  = st.getURI(link);
    var page = URI.host.replace(/^www\./i, '')  + URI.path.replace(/\/$/, '');
    var q    = me.getQueryText(row.cells[me.lay.text]) + ' (url:"' + page + '" | url:"www.' + page + '")';
    var url  = sape.xml.address;

    if (url.indexOf('?') == -1)  url += '?query=' + encodeURIComponent(q) + '&noreask=1&nomisspell=1';
    else                         url += '&query=' + encodeURIComponent(q) + '&noreask=1&nomisspell=1';

    if (sape.xml.address.indexOf('xmlproxy.ru/') > -1) url += '&soft_id=6';
    if (sape.xml.address.indexOf('seozoo.ru/') > -1)   url += '&developer=297';

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            var correct = 0;
            if ((req.status == 200) && req.responseXML)
            {
                   var err = sape.xml.isError(req, me);
                   if (+err !== 0)
                   {
                       row.removeAttribute(me.rowName);
                       if ((err == 32) && (ya.reinit < 100) && (ya.yandexcheck == 1))
                       {
                            me.requestURL = ya.selectURL(ya.reinit);
                            me.inProgress = 1;

                            ya.yandexcheck = ya.reinit;
                            ya.next(me);
                       }
                       if ((err == 32) && (ya.reinit == 102) && (ya.yandexcheck == 1))
                       {
                            var nextxml = function()
                            {
                                if (me.doc && me.doc.defaultView)
                                {
                                    me.inProgress = 1;
                                    ya.next(me);
                                }
                            };
                            st.showAlert(st.str('xml.wait'), st.str('xml.error.32'), 2, sape.xml.img);
                            st.setTimer(nextxml, 600000);
                       }
                       return;
                   }

                   var inIndex = sape.xml.inIndex(req);
                   if (+inIndex > -1)
                   {
                       correct = 1;
                       if (st.cache.enabled)
                       {
                           var text  = ya.yal.getText(row.cells[me.lay.text]);
                           var clink = URI.spec + '++' + text;

                           st.cache.push(clink, 'yal.1', +inIndex);
                           if (+inIndex)
                           {
                               st.cache.push(URI.spec, 'yap.1', +inIndex);
                           }
                       }
                       me.decorate(link, place, row, +inIndex);
                   }
            }
            if (!correct)
            {
                me.decorate(link, place, row, -1);
            }
            if (me.inProgress && (ya.yandexcheck == 1)) ya.next(me);
        }
    };
    try {req.send(null);} catch(e) {req.abort();}
};

// -----------------------------------------------
// Проверка проиндексированности сайта (HOST)
// -----------------------------------------------

sape.xml.host = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.host;

    var host = st.getURI(link).host.replace(/^www\./i, '');
    var q    = (me.likeGoogle)? st.safeEncode('site:' + host) : st.safeEncode('host:' + host + ' | host:www.' + host);
    var url  = sape.xml.address;

    if (me.regionCheck)
    {
        if (url.indexOf('?') == -1)
        {
            url += '?rstr=-' + me.regionNumber + '&lr=' + me.regionNumber;
        }
        else
        {
            url += '&rstr=-' + me.regionNumber + '&lr=' + me.regionNumber;
        }
    }
    if (url.indexOf('?') == -1)
    {
        url += '?query=' + q;
    }
    else
    {
        url += '&query=' + q;
    }

    if (sape.xml.address.indexOf('xmlproxy.ru/') > -1) url += '&soft_id=6';
    if (sape.xml.address.indexOf('seozoo.ru/') > -1)   url += '&developer=297';

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.overrideMimeType('text/xml; charset=utf-8');
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            var correct = 0;
            if (req.status == 200 && req.responseText.length)
            {
                   var err = sape.xml.isError(req, me);
                   if (+err !== 0)
                   {
                       row.removeAttribute(me.rowName);
                       if ((err == 32) && (ya.reinit < 100) && (ya.yandexcheck == 1))
                       {
                            me.requestURL = ya.selectURL(ya.reinit);
                            me.inProgress = 1;

                            ya.yandexcheck = ya.reinit;
                            ya.next(me);
                       }
                       if ((err == 32) && (ya.reinit == 102) && (ya.yandexcheck == 1))
                       {
                            var nextxml = function()
                            {
                                if (me.doc && me.doc.defaultView)
                                {
                                    me.inProgress = 1;
                                    ya.next(me);
                                }
                            };
                            st.showAlert(st.str('xml.wait'), st.str('xml.error.32'), 2, sape.xml.img);
                            st.setTimer(nextxml, 600000);
                       }
                       return;
                   }

                   var inIndex = sape.xml.inIndex(req);
                   if (+inIndex > -1)
                   {
                        correct = 1;
                        me.decorate(link, place, row, +inIndex);

                        if (st.cache.enabled)
                        {
                            var clink = st.getURI(link).host.replace(/^www\./i, '');

                            if (me.regionCheck) clink += '++' + me.regionNumber;
                            if (me.likeGoogle)  clink += '++' + 'sub';

                            st.cache.push(clink, 'host.1', inIndex);
                        }
                   }
            }
            if (!correct)
            {
                me.decorate(link, place, row, -1);
            }
            if (me.inProgress && (ya.yandexcheck == 1)) ya.next(me);
        }
    };
    try {req.send(null);} catch(e) {req.abort();}
};
