var sape = sape || {};

if (!sape.xtool) sape.xtool =
{
    inProgress: 0,
    doc: null,
    lc: -1,
    lay: {},
    img: "chrome://wmsape/skin/xtool.png",
    check: {},
    limit: {},
    user: {}
};

sape.xtool.login = function()
{
    var getLogin = function()
    {
        var info = {username: null, password: null};
        if ("@mozilla.org/login-manager;1" in Components.classes)
        {
            try
            {
                var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
                var logins = myLoginManager.findLogins({}, 'chrome://wmsape/xtool', null, 'XTool Registration');
                if (logins.length)
                {
                    info.username = logins[0].username;
                    info.password = logins[0].password;
                }
            }
            catch(ex) {}
         }
         return info;
    };
    sape.xtool.user = getLogin();
};

sape.xtool.show = function(data, row)
{
    var me = sape.xtool, st = sape.toolbar;
    var URI = st.getURI(data.url);

    var loader = row.querySelector('div.xtool-loader');
    if (loader) loader.parentNode.removeChild(loader);

    var xtdURL = 'http://xtool.ru/trust/?site=' + encodeURIComponent(URI.host);
    var xtURL  = 'http://xtool.ru/trust/?site=' + encodeURIComponent(URI.spec);

    var xtdLink = me.doc.createElement('a');
        xtdLink.setAttribute('href', xtdURL);
        xtdLink.setAttribute('target', '_blank');
        xtdLink.textContent = isFinite(data.xtd)? data.xtd : 'n/a';
    if (isFinite(data.xtd))
    {
        xtdLink.className = (parseFloat(data.xtd) < me.limit.xtd)? 'bold_red' : 'bold_green';
    }

    var xtLink = me.doc.createElement('a');
        xtLink.setAttribute('href', xtURL);
        xtLink.setAttribute('target', '_blank');
        xtLink.textContent = isFinite(data.xt)? data.xt : 'n/a';
    if (isFinite(data.xt))
    {
        xtLink.className = (parseFloat(data.xt) < me.limit.xtd)? 'bold_red' : 'bold_green';
    }

    var spamLink = me.doc.createElement('a');
        spamLink.setAttribute('href', xtdURL);
        spamLink.setAttribute('target', '_blank');
        spamLink.textContent = isFinite(data.spam)? data.spam : 'n/a';
    if (isFinite(data.spam))
    {
        spamLink.className = (parseFloat(data.spam) > me.limit.spam)? 'bold_red' : 'bold_green';
    }

    var div = row.querySelector('div.xtoolPlace') || me.doc.createElement('div');
        div.textContent = '';
        div.className = 'xtoolPlace';
        div.appendChild(me.doc.createTextNode(st.str('xtool.trust') + '\xA0'));
        div.appendChild(xtdLink);

    if (isFinite(data.change) && data.change)
    {
        var changeText = me.doc.createElement('sup');
            changeText.textContent = (parseFloat(data.change) > 0)? ' +' + data.change : ' ' + data.change;
            changeText.className   = (parseFloat(data.change) > 0)? 'ya-green' : 'ya-red';

        div.appendChild(changeText);
    }

    if (me.check.xt)
    {
        div.appendChild(me.doc.createElement('br'));
        div.appendChild(me.doc.createTextNode(st.str('xtool.trust.page') + '\xA0'));
        div.appendChild(xtLink);
    }

    div.appendChild(me.doc.createElement('br'));
    div.appendChild(me.doc.createTextNode(st.str('xtool.spam') + '\xA0'));
    div.appendChild(spamLink);

    if (isFinite(data.sanctions) && (data.sanctions > 0)&& (data.sanctions < 5))
    {
        var sanText = me.doc.createElement('span');
            sanText.textContent = st.str('xtool.sanctions.' + data.sanctions);
        if ((data.sanctions == 1) || (data.sanctions == 4))
        {
            sanText.className = 'ya-red';
        }
        div.appendChild(me.doc.createElement('br'));
        div.appendChild(sanText);
    }

    row.cells[me.lc].appendChild(div);

    return me.checkParams(data, row);
};

sape.xtool.getParams = function(url, callback)
{
    var data =
    {
        type: 'trust',
        referrer: 8218,
        login: sape.xtool.user.username,
        pass: sape.xtool.user.hash,
        url: url,
        remove: ['google','linkpad','page','whois','xt_history','alexa','liveinternet','majesticseo']
    };
    var req = new XMLHttpRequest();
        req.open('POST', 'http://api.xtool.ru', true);
        req.timeout = 30000;
        req.onreadystatechange = function(evt)
        {
            if (req.readyState == 4)
            {
                if (req.status == 200 && req.responseText.length)
                {
                    try
                    {
                        var result = JSON.parse(req.responseText);
                        if (result)
                        {
                            callback(result);
                            return;
                        }
                    }
                    catch(ex) {}
                }
                callback(null);
            }
        };
        req.send(JSON.stringify(data));
};

sape.xtool.checkParams = function(data, row)
{
    var st = sape.toolbar, me = sape.xtool;

    var checkbox = st.getCheckbox(row.cells[me.lay.check]);
    if (!checkbox || checkbox.checked) return;

    var a = isFinite(data.xtd)  && me.check.xtd  && (parseFloat(data.xtd) < me.limit.xtd);
    var b = isFinite(data.spam) && me.check.spam && (parseFloat(data.spam) > me.limit.spam);
    var c = isFinite(data.xt)   && me.check.xt   && (parseFloat(data.xt) < me.limit.xtd);

    var isChecked = (me.check.together && me.check.xtd && me.check.spam)? a && b : a || b;

    if (me.check.xt && !isChecked)
    {
        isChecked = (me.check.together && me.check.xt && me.check.spam)? c && b : c || b;
    }
    if (isChecked)
    {
        me.counter++;
        checkbox.checked = true;
        checkbox.setAttribute('reason', 'xtool');
    }
    return isChecked;
};

sape.xtool.checkSingle = function(url, row, data)
{
    var st = sape.toolbar, me = sape.xtool;

    var URI = st.getURI(url);
    if (URI.path === '/') return;

    var XTResult = function(result)
    {
        if (result && result.Error && result.ErrorCode && result.ErrorCode > 200)
        {
            st.showAlert(result.Error, 'XTool.ru', 2, me.img);
            row.removeAttribute('xtool');

            me.unload();
            return;
        }
        if (result && result.trust)
        {
            var rt = result.trust;

            data.xt  = (isFinite(rt.xt) && (rt.xt >= 0))? rt.xt : 'n/a';
            data.url = URI.spec;

            if (st.cache.enabled)
            {
                st.cache.push(URI.spec, 'xt', JSON.stringify(data));
            }
        }
        me.show(data, row);
    };
    me.getParams(URI.spec, XTResult);
};

sape.xtool.run = function(url, row)
{
    var st = sape.toolbar, me = sape.xtool;

    var img = me.doc.createElement('img');
        img.src = 'chrome://wmsape/skin/ajax-loader.gif';

    var loader = me.doc.createElement('div');
        loader.className = 'xtool-loader';
        loader.appendChild(img);

    row.cells[me.lc].appendChild(loader);

    var URI = st.getURI(url);
    var data = {url: URI.prePath + '/', xtd: 'n/a', spam: 'n/a', xt: 'n/a', sanctions:0, change:0};

    var XTDResult = function(result)
    {
        if (loader && loader.parentNode) loader.parentNode.removeChild(loader);

        if (result && result.Error && result.ErrorCode && result.ErrorCode > 200)
        {
            st.showAlert(result.Error, 'XTool.ru', 2, me.img);
            row.removeAttribute('xtool');

            me.unload();
            return;
        }
        if (result && result.trust)
        {
            var rt = result.trust;

            data.xtd  = (isFinite(rt.xt) && (rt.xt >= 0))? rt.xt : 'n/a';
            data.spam = (isFinite(rt.spammed) && (rt.spammed >= 0))? rt.spammed : 'n/a';
            data.sanctions = (isFinite(rt.yandex.sanctions) && (rt.yandex.sanctions >= 0))? parseInt(rt.yandex.sanctions, 10) : 0;
            data.change = (isFinite(rt.xt_change))? parseFloat(rt.xt_change) : 0;
            if (URI.path === '/')
            {
                data.xt = data.xtd;
            }
            if (st.cache.enabled)
            {
                st.cache.push(URI.prePath + '/', 'xt', JSON.stringify(data));
            }
        }
        var isChecked = me.show(data, row);
        if (!isChecked && me.check.xt)
        {
            me.checkSingle(url, row, data);
        }
        me.next();
    };

    var noCache = function()
    {
        me.getParams(URI.prePath + '/', XTDResult);
    };

    if (st.cache.enabled)
    {
        var cacheUrl = (me.check.xt)? URI.spec : URI.prePath + '/';

        st.cache.pop(cacheUrl, 'xt', function(res)
        {
            var obj = 0;
            if (res && (obj = JSON.parse(res)))
            {
                me.show(obj, row);
                me.next();
            }
            else noCache();
        });
    }
    else noCache();
};

sape.xtool.nextone = function()
{
    var st = sape.toolbar, me = sape.xtool;

    if (!me.doc || !me.doc.defaultView) return;

    var row = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i = 0; i < rl; i++)
    {
        if (row[i].hasAttribute('xtool')) continue;

        var col = row[i].cells;
        if ((me.lay.cols > 0) && (col.length < me.lay.cols)) continue;

        var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox || (checkbox.checked && me.skip)) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var url = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(url)) continue;

        row[i].setAttribute('xtool', '1');
        me.run(url, row[i]);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.finish'), 2, me.img);
    }
};

sape.xtool.next = function()
{
    var me = sape.xtool, timeout = (arguments.length)? arguments[0] : 100;
    if (me.inProgress)
        sape.toolbar.setTimer(me.nextone, timeout);
};

sape.xtool.unload = function()
{
    var me = sape.xtool;
    if (me.doc && me.doc.defaultView) me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.inProgress = me.doc = 0;
};

sape.xtool.start = function()
{
    var st = sape.toolbar, me = sape.xtool, doc = st.getDocument();
    if (!st.inside(doc))
    {
        st.openService('XT');
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, me.img);
        return;
    }
    if (me.doc)
    {
        me.unload();
    }

    var lay = st.layout(doc);
    if ((me.lc = (lay.url == -1)? lay.link : lay.url) < 0) return;

    me.login();
    if (!me.user.username || !me.user.password)
    {
        st.showAlert(st.str('xtool.nopassword'), 'XTool.ru', 2, me.img);
        return;
    }
    me.user.hash = st.sha512(me.user.password);
    me.user.password = null;

    me.counter = 0;
    me.inProgress = 1;
    me.lay = lay;
    me.doc = st.getDocument();
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    var prefs = st.prefs();

    me.limit.xtd = prefs.getIntPref("xtool.limit.xtd");
    me.limit.spam = prefs.getIntPref("xtool.limit.spam");

    me.check.xt  = prefs.getBoolPref("xtool.check.xt");
    me.check.xtd = prefs.getBoolPref("xtool.check.xtd");
    me.check.spam = prefs.getBoolPref("xtool.check.spam");
    me.check.together = prefs.getBoolPref("xtool.check.together");

    me.skip = prefs.getBoolPref("re.check");

    st.showAlert(st.str('nice'), st.str('ya.start'), 1, me.img);
    for (var i = 0; i < 3; i++)
    {
        me.next(100 + i*500);
    }
};