var sape = sape || {};

if (!sape.yandex) sape.yandex =
{
    defaultURL: "https://yandex.ru/yandsearch?lr=1&text=",
    img:        "chrome://wmsape/skin/yandex.png"
};

sape.yandex.isCaptcha = function(req)
{
   var URI = req.channel.URI;
   if (req.status == 503 || req.status == 403) return 1;
   if (URI.host.match(/yandex/) && URI.path.match(/^[\/]showcaptcha/))  return 1; // yandex
   if (req.responseText.match(/yandex\.(ru|com|by|ua)\/captchaimg/)) return 1; // rambler
   return 0;
};

sape.yandex.anticaptcha = function(me, req, callback)
{
    var st = sape.toolbar;
    if (me.inProgress)
    {
        me.inProgress = 0;

        if (sape.yandex.antigate)
        {
            me.cTimer = 1;
            st.showAlert(st.str('ag.wait'), st.str('captcha'), 3, sape.yandex.img);
            sape.antigate.addTask(me, req, callback);
        }
        else st.showAlert(st.str('ya.stop'), st.str('captcha'), 2, sape.yandex.img);
    }
};

sape.yandex.selectURL = function(yandexcheck)
{
    var requestURL = sape.yandex.defaultURL;

    if (yandexcheck == 8) requestURL = 'https://yandex.ru/touchsearch?lr=1&l10n=ru&text=';
    if (yandexcheck == 7) requestURL = 'http://nova.rambler.ru/search?query=';
    if (yandexcheck == 6) requestURL = 'https://yandex.com/yandsearch?lr=87&text=';
    if (yandexcheck == 5) requestURL = 'https://yandex.by/yandsearch?lr=157&l10n=ru&text=';
    if (yandexcheck == 4) requestURL = 'https://yandex.ua/yandsearch?lr=143&l10n=ru&text=';
    if (yandexcheck == 3) requestURL = 'https://beta.yandex.ru/yandsearch?lr=1&l10n=ru&text=';
    if (yandexcheck == 2) requestURL = 'https://yandex.ru/familysearch?lr=1&l10n=ru&text=';
    if (yandexcheck == 1) requestURL = 'https://yandex.ru/yandsearch?lr=1&l10n=ru&text=';

    return requestURL;
};

sape.yandex.init = function()
{
    var st = sape.toolbar, ya = sape.yandex, prefs = st.prefs();

    ya.skip         = prefs.getBoolPref("re.check");
    ya.errcheck     = prefs.getBoolPref("errors.check");
    ya.changeselect = prefs.getBoolPref("changeselect");
    ya.liveDays     = prefs.getIntPref("livedays");
    ya.yandexcheck  = prefs.getIntPref("yandexcheck");
    ya.requestURL   = ya.selectURL(ya.yandexcheck);

    st.loadJS('antigate');
    ya.antigate = sape.antigate.init();

    ya.seobudget = prefs.getBoolPref("seobudget.use");
    if (ya.seobudget)
    {
        st.loadJS('seobudget');
        sape.seobudget.init();

        ya.requestURL = ya.defaultURL;
    }

    if (ya.yandexcheck == 1)
    {
        st.loadJS('xml');
        sape.xml.init();

        try
        {
            ya.reinit = prefs.getIntPref("xml.reinit");

            if (ya.reinit == -1) ya.reinit = 101;
            if (ya.reinit == -2) ya.reinit = 102;
        }
        catch (ex)
        {
            ya.reinit = 101;
        }
        if (sape.xml.address.indexOf('.yandex.com') > -1)
        {
            prefs.setBoolPref('region.check', false);
            ya.requestURL = ya.selectURL(6);
        }
    }
};

sape.yandex.stop = function(me)
{
    if (me.inProgress || me.cTimer)
    {
        me.cTimer = 0;
        me.inProgress = 0;

        return true;
    }
    else
        return false;
};

sape.yandex.next = function(me)
{
    var timeout = (arguments.length > 1)? +arguments[1] : me.timeout + Math.round(me.timeout * Math.random());
    if (me.doc && me.inProgress) sape.toolbar.setTimer(me.nextone, timeout);
};

sape.yandex.nextrow = function(me)
{
    var st = sape.toolbar, ya = sape.yandex;

    if (!me.inProgress || !me.doc || !me.doc.defaultView) return;

    var row = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i=0; i < rl; i++)
    {
        if (row[i].hasAttribute(me.rowName)) continue;

        var col = row[i].cells;
        if (col.length !== me.lay.cols) continue;

        var as = row[i].querySelector('a.' + me.btnName);
		if (!as) continue;

		var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox || (ya.skip && checkbox.checked)) continue;

        if ((me.rowName == 'yal' || me.rowName == 'yacl') && me.lastDate && sape.yandex.liveDays > 0)
        {
            var linkDate = st.parseDate(col[me.lay.dc]);
            if (linkDate > me.lastDate) continue;
        }

        var a    = col[me.lc].getElementsByTagName('a');
        var link = st.getURL(a[me.lay.idx].getAttribute('href'));

        row[i].setAttribute(me.rowName, '1');

        var crow = row[i];
        if (me.cached(link, as, crow)) continue;

        me.query(link, as, crow);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.finish'), 2, ya.img);

        if (me.counter > 0)
        {
            if (ya.changeselect && !me.lay.seo) st.changeSelect(me.doc, 'placementRemove');
        }
    }
};

sape.yandex.placeButtons = function(me)
{
    var st = sape.toolbar;

    var row  = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i = 0; i < rl; i++)
    {
        if (row[i].hasAttribute(me.rowName))  continue;

        var col = row[i].cells;
        if (col.length !== me.lay.cols) continue;

		var checkbox = st.getCheckbox(col[me.lay.check]);
        if (!checkbox) continue;

        var a = col[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var href = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var link = st.getURL(href);
        var btn  = me.button(link, row[i]);

        var as = row[i].querySelector('a.' + me.btnName);
        if (as)
        {
            as.parentNode.replaceChild(btn, as);
        }
        else
        {
            var yap = col[me.lay.ico].querySelector('.icon_in_yaca, .icon_in_dmoz, .icon_in_wl, .icon_wl, .icon_yal, .icon_bl, .icon_gbl, .icon_ya');
            if (yap)
            {
                yap.parentNode.insertBefore(btn, yap.nextSibling);
            }
            else
            {
                var div = col[me.lay.ico].querySelector('.page_icons') || me.doc.createElement('div');
                    div.className = 'page_icons';
                    div.appendChild(btn);

                col[me.lay.ico].appendChild(div);
            }
        }
        if ((me.rowName == 'yal' || me.rowName == 'yacl') && me.lastDate && sape.yandex.liveDays > 0)
        {
            var linkDate = st.parseDate(col[me.lay.dc]);
            if (linkDate > me.lastDate) continue;
        }
        if (me.cached(link, btn, row[i]))
        {
            row[i].setAttribute(me.rowName, '1');
        }
        col[me.lc].classList.remove('a_visited');
        col[me.lay.ico].classList.remove('a_visited');
    }
    st.initDOM();
};

sape.yandex.countIndex = function(text)
{
    var exp = /(найден|наш|has\sfound)[^\d\&]+(\d+[^\n\&<]*)[^\&\u0430-\u044F\u0451\n]*(ответ|документ|страниц|результат|answer)/i;
    if ((exp = exp.exec(text)) !== null)
    {
        var count = parseInt(exp[2].replace(/[^\d]+/g, ''), 10);
        if (exp[2].match(/(тыс)|(thousand)/)) count *= 1000;
        if (exp[2].match(/(млн)|(million)/))  count *= 1000000;

        return count;
    }
    if ((text.indexOf('Искомая комбинация слов нигде не встречается') != -1)  ||
        (text.indexOf('Yandex: no results found')                     != -1)  ||
        (text.indexOf('По вашему запросу ничего не нашлось')          != -1)  ||
        (text.indexOf('Яндекс: ничего не найдено')                    != -1)) return 0;

    return -1;
};

// ─────────────────────────────────────────────────────────────────────────────
// Проверка на вылет из индекса (HOST)
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.yandex.host) sape.yandex.host =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    rowName: 'host',
    btnName: 'icon_host',
    lay: {}
};

sape.yandex.host.button = function(link, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.host;

    var host = st.getURI(link).host.replace(/^www\./i, '');
    var q    = (me.likeGoogle)? 'site:' + host : 'host:' + host + ' | host:www.' + host;
    var url  = me.requestURL + encodeURIComponent(q);

    if (me.regionCheck)
    {
        url = url.replace(/lr=(\d+)[&]?/, '') + '&rstr=-' + me.regionNumber + '&lr=' + me.regionNumber;
    }
    var as = me.doc.createElement('a');
        as.href = url;
        as.target = '_blank';
        as.className = 'icon_host icon_ya';
        as.textContent = 'HOST';

    return as;
};

sape.yandex.host.placeCounter = function(cell, count)
{
    var doc = cell.ownerDocument, s = doc.createTextNode("\x20[" + count + "]\x20");

    var e = cell.querySelector('b.blocked-in-yandex, b.not-blocked-in-yandex');
    if (e && e.nextSibling)
    {
        if (e.className == 'blocked-in-yandex')
        {
            e.className = 'not-blocked-in-yandex';
            e.textContent = '\u042F:';
            e.parentNode.insertBefore(s, e.nextSibling);
        }
        if (e.className == 'not-blocked-in-yandex')
        {
            e.parentNode.replaceChild(s, e.nextSibling);
        }
        return;
    }

    var b = doc.createElement('b');
        b.className = 'not-blocked-in-yandex';
        b.title = sape.toolbar.str("bing.pages");
        b.textContent = '\u042F:';

    var root = cell.querySelector('.page_icons') || cell;
        root.appendChild(doc.createTextNode("\x20"));
        root.appendChild(b);
        root.appendChild(s);
};


sape.yandex.host.cached = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.host;
    if (st.cache.enabled)
    {
        var clink = st.getURI(link).host.replace(/^www\./i, '');

        if (me.regionCheck) clink += '++' + me.regionNumber;
        if (me.likeGoogle)  clink += '++' + 'sub';

        var inIndex = (ya.seobudget)? st.cache.pop(clink, 'host.0') : st.cache.pop(clink, 'host.' + ya.yandexcheck);
        if (inIndex !== null)
        {
            me.decorate(link, place, row, +inIndex);
            return true;
        }
    }
    return false;
};

sape.yandex.host.decorate = function(link, place, row, inIndex)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.host;

    var checkbox = st.getCheckbox(row.cells[me.lay.check]);

    if (inIndex < 0)
    {
        place.classList.add("icon_silver");

        if (ya.errcheck && !checkbox.checked)
        {
            checkbox.checked = true;
            me.counter++;
        }
        return;
    }
    if (!inIndex)
    {
        place.classList.add("icon_red");

        if (!checkbox.checked)
        {
            checkbox.setAttribute("reason", "host");
            checkbox.checked = true;
            me.counter++;
        }
    }
    if (+inIndex > 0)
    {
        place.classList.add("icon_green");
    }
    me.placeCounter(row.cells[me.lc], +inIndex);
};

sape.yandex.host.query = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.host;

    if (ya.seobudget)
    {
        sape.seobudget.host(link, place, row);
        return;
    }
    if (ya.yandexcheck == 1)
    {
        sape.xml.host(link, place, row);
        return;
    }

    var checkResult = function(req)
    {
        if (ya.isCaptcha(req))
        {
            if (!me.cTimer) ya.anticaptcha(me, req, checkResult);
            row.removeAttribute(me.rowName);
            return;
        }
        var correct = 0;
        if ((req.status == 200) && req.responseText.length)
        {
            row.setAttribute(me.rowName, '1');

            var inIndex = ya.countIndex(req.responseText);
            if (inIndex > -1)
            {
                correct = 1;
                me.decorate(link, place, row, +inIndex);

                if (st.cache.enabled)
                {
                    var clink = st.getURI(link).host.replace(/^www\./i, '');

                    if (me.regionCheck) clink += '++' + me.regionNumber;
                    if (me.likeGoogle)  clink += '++' + 'sub';

                    st.cache.push(clink, 'host.' + ya.yandexcheck, inIndex);
                }
            }
        }
        if (!correct)
        {
            me.decorate(link, place, row, -1);
        }
        if (me.inProgress) ya.next(me);
    };

    var host = st.getURI(link).host.replace(/^www\./i, '');
    var q    = (me.likeGoogle)? 'site:' + host : 'host:' + host + ' | host:www.' + host;
    var url  = me.requestURL + encodeURIComponent(q);

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

    if (ya.yandexcheck == 8)
    {
        req.setRequestHeader('User-Agent', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53');
    }
    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            checkResult(req);
        }
    };
    req.send(null);
};

sape.yandex.host.nextone = function()
{
    sape.yandex.nextrow(sape.yandex.host);
};

sape.yandex.host.unload = function()
{
    var me = sape.yandex.host;
    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.yandex.host.start = function()
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.host, doc = st.getDocument();

    if (!st.inside(doc))
    {
        st.openService('H');
        return;
    }
    if (ya.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, ya.img);
        return;
    }
    ya.init();

    var lay = st.layout(doc);

    me.lay      = lay;
    me.lc       = (lay.url < 0)? lay.link : lay.url;
    me.counter  = 0;

    if (me.lc == -1) return;

    var prefs = st.prefs();

    me.timeout      = Math.max(50, prefs.getIntPref("timeout.yandex"));
    me.requestURL   = ya.requestURL;
    me.regionCheck  = prefs.getBoolPref("region.check");
    me.regionNumber = prefs.getIntPref("region.number");
    me.likeGoogle   = prefs.getBoolPref("host.subdomains");

    if (prefs.getBoolPref("yandex.updates"))
    {
        st.loadJS('updates');
        sape.updates.yandex.check();
    }
    if (ya.seobudget)
    {
        me.regionCheck = false;
        me.likeGoogle  = false;
    }
    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, ya.img);

    ya.placeButtons(me);

    var streams = (ya.yandexcheck == 1)? Math.max(1, prefs.getIntPref("streams")) : 1;
    for (var j=0; j < streams; j++)
    {
        ya.next(me, 100 + j*500);
    }
};

// ─────────────────────────────────────────────────────────────────────────────
// Проверка проиндексированности страницы (YAP)
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.yandex.yap) sape.yandex.yap =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    rowName: 'yap',
    btnName: 'icon_yap',
    lay: {},
    history: {use: false, age: 3},
    ymt: {check: false, age: 90}
};

sape.yandex.yap.button = function(link, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yap;

    var URI  = st.getURI(link);
    var page = URI.host.replace(/^www\./i, '')  + URI.path.replace(/\/$/, '');
    var q    = 'url:"' + page + '" | url:"www.' + page + '"';
    var url  = me.requestURL + encodeURIComponent(q);

    var as = me.doc.createElement('a');
        as.href = url;
        as.target = '_blank';
        as.className = 'icon_yap';
        as.textContent = 'YAP';

    return as;
};

sape.yandex.yap.ageCounter = function(pagedate, days, row)
{
    var st = sape.toolbar, me = sape.yandex.yap, doc = row.ownerDocument, cell = row.cells[me.lay.ico];

    if (row.querySelector('.ya-page-date')) return;

    var b = doc.createElement('b');
        b.className = 'ya-page-date';
        b.textContent = 'YD:';
        b.title = st.str('ymt.date');

    var s = doc.createElement('span');
        s.textContent = '\xA0[' + pagedate + ']\xA0';
        s.title = st.str('ymt.days') + ' ' + days;

    if (days > me.ymt.age) b.classList.add('ya-red');

    var sp = doc.createTextNode("\x20");

    var root = cell.querySelector('.page_icons') || cell;
        root.appendChild(sp);
        root.appendChild(b);
        root.appendChild(s);
};

sape.yandex.yap.ageCheck = function(link, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yap;

    var S = st.cache.pop(st.getURI(link).spec, 'ymt');
    if (S !== null)
    {
        var exp = /(\d{4})(\d{2})(\d{2})T(\d{2})(\d{2})(\d{2})/;
        if ((exp = exp.exec(S)))
        {
            var dateString = exp[3] + '.' + exp[2] + '.' + exp[1];

            var DD = parseInt(exp[3], 10), MM = parseInt(exp[2], 10), YY = parseInt(exp[1], 10);

            var pageDate = new Date(YY, MM-1, DD);
            var nowDate  = new Date();

            var days = Math.floor((nowDate - pageDate) / 1000 / 60 / 60 / 24);
            if (me.ymt.check && days > me.ymt.age)
            {
                var checkbox = st.getCheckbox(row.cells[me.lay.check]);
                if (!checkbox.checked)
                {
                    checkbox.setAttribute("reason", "yap.age");
                    checkbox.checked = true;
                    me.counter++;
                }
            }
            me.ageCounter(dateString, days, row);
        }
    }
};

sape.yandex.yap.decorate = function(link, place, row, inIndex)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yap;

    var clink    = st.getURI(link).spec;
    var checkbox = st.getCheckbox(row.cells[me.lay.check]);

    if (inIndex < 0)
    {
        place.classList.add("icon_silver");

        if (ya.errcheck && !checkbox.checked && !me.history.use)
        {
            checkbox.checked = true;
            me.counter++;
        }
        return;
    }
    if (!inIndex)
    {
        st.cache.age(clink, 'history', function(age)
        {
            if (!age && me.lay.history)
            {
                st.cache.push(clink, 'history', 404);
            }
            if (me.history.use && age <= me.history.age)
            {
                place.classList.add("icon_corall");
                place.setAttribute("title", st.str('yap.noindex') + ' (' + (+age/3600).toFixed() + 'h)');
            }
            else
            {
                place.classList.add("icon_red");
                if (!checkbox.checked)
                {
                    checkbox.setAttribute("reason", "yap");
                    checkbox.checked = true;
                    me.counter++;
                }
            }
        });
    }
    if (inIndex > 0)
    {
        if (me.ymt.check)
        {
            me.ageCheck(link, row);
        }
        st.cache.del(clink, 'history');
        place.classList.add("icon_green");
    }
};

sape.yandex.yap.cached = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yap;
    if (st.cache.enabled)
    {
        var clink = st.getURI(link).spec;

        var inIndex = (ya.seobudget)? st.cache.pop(clink, 'yap.0') : st.cache.pop(clink, 'yap.' + ya.yandexcheck);
        if (inIndex !== null)
        {
           me.decorate(link, place, row, +inIndex);
           return true;
        }
    }
    return false;
};

sape.yandex.yap.query = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yap;

    if (ya.seobudget)
    {
        sape.seobudget.yap(link, place, row);
        return;
    }
    if (ya.yandexcheck == 1)
    {
        sape.xml.yap(link, place, row);
        return;
    }
    var URI = st.getURI(link);

    var checkResult = function(req)
    {
        if (ya.isCaptcha(req))
        {
            if (!me.cTimer) ya.anticaptcha(me, req, checkResult);
            row.removeAttribute(me.rowName);
            return;
        }

        var correct = 0;
        if ((req.status == 200) && req.responseText.length)
        {
            row.setAttribute(me.rowName, '1');

            var inIndex = ya.countIndex(req.responseText), copyUrl = 0;
            if (+inIndex > -1)
            {
                correct = 1;
                if (+inIndex)
                {
                    copyUrl = ya.yac.getCopyUrl(req.responseText);
                }
                if (st.cache.enabled)
                {
                    st.cache.push(URI.spec, 'yap.' + ya.yandexcheck, inIndex);
                    st.cache.push(URI.spec, 'yac', copyUrl);
                }
                me.decorate(link, place, row, +inIndex);
            }
        }
        if (!correct)
        {
            me.decorate(link, place, row, -1);
        }
        if (me.inProgress) ya.next(me);
    };

    var url = place.getAttribute('href');
    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

    if (ya.yandexcheck == 8)
    {
        req.setRequestHeader('User-Agent', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53');
    }
    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            checkResult(req);
        }
    };
    req.send(null);
};

sape.yandex.yap.nextone = function()
{
    sape.yandex.nextrow(sape.yandex.yap);
};

sape.yandex.yap.unload = function()
{
    var me = sape.yandex.yap;
    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.yandex.yap.start = function()
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yap, doc = st.getDocument();

    if (!st.inside(doc))
    {
        st.openService('YP');
        return;
    }
    if (ya.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, ya.img);
        return;
    }
    ya.init();

    var lay = st.layout(doc);

    me.lay      = lay;
    me.lc       = (lay.url < 0)? lay.link : lay.url;
    me.counter  = 0;

    if (me.lc == -1) return;

    var prefs = st.prefs();

    me.timeout      = Math.max(50, prefs.getIntPref("timeout.yandex"));
    me.requestURL   = ya.requestURL;
    me.history.use  = prefs.getBoolPref("history.use") && me.lay.history;
    me.history.age  = prefs.getIntPref("history.age") * 24 * 60 * 60;

    me.ymt.check    = prefs.getBoolPref("ymt.check.age") && (ya.yandexcheck == 1);
    me.ymt.age      = prefs.getIntPref("ymt.age");

    if (prefs.getBoolPref("yandex.updates"))
    {
        st.loadJS('updates');
        sape.updates.yandex.check();
    }
    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    ya.placeButtons(me);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, ya.img);

    var streams = (ya.yandexcheck == 1)? Math.max(1, prefs.getIntPref("streams")) : 1;
    for (var j=0; j < streams; j++)
    {
        ya.next(me, 100 + j*500);
    }
};


// ─────────────────────────────────────────────────────────────────────────────
// Проверка проиндексированности ссылок (YAL)
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.yandex.yal) sape.yandex.yal =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    rowName: 'yal',
    btnName: 'icon_yal',
    lay: {},
    history: {use: false, age: 3}
};

sape.yandex.yal.getText = function(cell)
{
    var st = sape.toolbar;

    var text = st.getTextCell(cell).textContent;
        text = st.html_entity_decode(text).replace(/\s\s+/g, " ").trim();

    return text;
};

sape.yandex.yal.getQueryText = function(cell)
{
    var st = sape.toolbar, me = sape.yandex.yal;

    var text = me.getText(cell);
    var good = [], parts = text.split(/([\.\;\!\?]+\s+)/);

    while (parts.length)
    {
        text = parts.shift();
        text = text.replace(/[\-\%\"\+\:\/]+/g, " ").replace(/(\s{2,})/g, " ").trim();

        if (text.length > 2) good.push(text);
    }
    var result = good.join('" && "');
        result = (result.indexOf('&&') > -1)? '("' + result + '")' : '"' + result + '"';

    return result;
};

sape.yandex.yal.button = function(link, row)
{
    var st = sape.toolbar, me = sape.yandex.yal;

    var URI  = st.getURI(link);
    var page = URI.host.replace(/^www\./i, '')  + URI.path.replace(/\/$/, '');
    var q    = me.getQueryText(row.cells[me.lay.text]) + ' (url:"' + page + '" | url:"www.' + page + '")';
    var url  = me.requestURL + encodeURIComponent(q) + '&noreask=1&nomisspell=1';

    var as = me.doc.createElement('a');
        as.href = url;
        as.target = '_blank';
        as.className = 'icon_yal';
        as.textContent = 'YAL';

    return as;
};

sape.yandex.yal.decorate = function(link, place, row, inIndex)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yal;

    var URI      = st.getURI(link);
    var text     = me.getText(row.cells[me.lay.text]);
    var clink    = URI.spec + '++' + text;
    var checkbox = st.getCheckbox(row.cells[me.lay.check]);

    if (inIndex < 0)
    {
        place.classList.add("icon_silver");
        if (ya.errcheck && !checkbox.checked && !me.history.use)
        {
            checkbox.checked = true;
            me.counter++;
        }
        return;
    }
    if (!inIndex)
    {
        st.cache.age(clink, 'history', function(age)
        {
            if (!age && me.lay.history)
            {
                st.cache.push(clink, 'history', 404);
            }
            if (me.history.use && age <= me.history.age)
            {
                place.classList.add("icon_corall");
                place.setAttribute("title", st.str('yal.noindex') + ' (' + (+age/3600).toFixed() + 'h)');
            }
            else
            {
                place.classList.add("icon_red");
                if (!checkbox.checked)
                {
                    checkbox.setAttribute("reason", "yal");
                    checkbox.checked = true;
                    me.counter++;
                }
            }
        });
    }
    if (inIndex > 0)
    {
        place.classList.add("icon_green");
        st.cache.del(URI.spec, 'history');
        st.cache.del(clink,    'history');
    }
};

sape.yandex.yal.cached = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yal;
    if (st.cache.enabled)
    {
        var text  = me.getText(row.cells[me.lay.text]);
        var clink = st.getURI(link).spec + '++' + text;

        var inIndex = (ya.seobudget)? st.cache.pop(clink, 'yal.0') : st.cache.pop(clink, 'yal.' + ya.yandexcheck);
        if (inIndex !== null)
        {
           me.decorate(link, place, row, +inIndex);
           return true;
        }
    }
    return false;
};

sape.yandex.yal.query = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yal;

    if (ya.seobudget)
    {
        sape.seobudget.yal(link, place, row);
        return;
    }
    if (ya.yandexcheck == 1)
    {
        sape.xml.yal(link, place, row);
        return;
    }

    var checkResult = function(req)
    {
        if (ya.isCaptcha(req))
        {
            if (!me.cTimer) ya.anticaptcha(me, req, checkResult);
            row.removeAttribute(me.rowName);
            return;
        }

        var correct = 0;
        if ((req.status == 200) && req.responseText.length)
        {
            row.setAttribute(me.rowName, '1');

            var inIndex = ya.countIndex(req.responseText);
            if (+inIndex > -1)
            {
                correct = 1;
                if (st.cache.enabled)
                {
                    var URI   = st.getURI(link);
                    var text  = me.getText(row.cells[me.lay.text]);
                    var clink = URI.spec + '++' + text;

                    st.cache.push(clink,  'yal.' + ya.yandexcheck, inIndex);
                    if (+inIndex)
                    {
                        st.cache.push(URI.spec,  'yap.' + ya.yandexcheck, inIndex);
                    }
                }
                me.decorate(link, place, row, +inIndex);
            }
        }
        if (!correct)
        {
            me.decorate(link, place, row, -1);
        }
        if (me.inProgress) ya.next(me);
    };

    var url = place.getAttribute('href');
    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

    if (ya.yandexcheck == 8)
    {
        req.setRequestHeader('User-Agent', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53');
    }
    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            checkResult(req);
        }
    };
    req.send(null);
};

sape.yandex.yal.nextone = function()
{
    sape.yandex.nextrow(sape.yandex.yal);
};

sape.yandex.yal.unload = function()
{
    var me = sape.yandex.yal;
    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.yandex.yal.select = function()
{
    if (sape.toolbar.prefs().getIntPref("yal.cache"))
    {
        sape.yandex.yacl.start();
    }
    else
    {
        sape.yandex.yal.start();
    }
};

sape.yandex.yal.start = function()
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yal, doc = st.getDocument();

    if (ya.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, ya.img);
        return;
    }
    ya.init();

    var lay = st.layout(doc);

    me.lay      = lay;
    me.lc       = (lay.link < 0)? lay.url : lay.link;
    me.counter  = 0;

    if (me.lc == -1 || me.lay.text == -1 || me.lay.dc == -1) return;

    var prefs = st.prefs();

    me.timeout      = Math.max(50, prefs.getIntPref("timeout.yandex"));
    me.requestURL   = ya.requestURL;
    me.history.use  = prefs.getBoolPref("history.use") && me.lay.history;
    me.history.age  = prefs.getIntPref("history.age") * 24 * 60 * 60;

    me.lastDate = new Date();
    me.lastDate.setDate(me.lastDate.getDate() - ya.liveDays);

    if (prefs.getBoolPref("yandex.updates"))
    {
        st.loadJS('updates');
        sape.updates.yandex.check();
    }
    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    ya.placeButtons(me);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, ya.img);

    var streams = (ya.yandexcheck == 1)? Math.max(1, prefs.getIntPref("streams")) : 1;
    for (var j=0; j < streams; j++)
    {
        ya.next(me, 100 + j*500);
    }
};

// ─────────────────────────────────────────────────────────────────────────────
// Проверка кэша страниц (YAC)
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.yandex.yac) sape.yandex.yac =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    rowName: 'yac',
    btnName: 'icon_yac',
    lay: {}
};

sape.yandex.yac.button = function(link, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yac;

    var URI  = st.getURI(link);
    var page = URI.host.replace(/^www\./i, '')  + URI.path.replace(/\/$/, '');
    var q    = 'url:"' + page + '" | url:"www.' + page + '"';
    var url  = me.requestURL + encodeURIComponent(q);

    var as = me.doc.createElement('a');
        as.href = url;
        as.target = '_blank';
        as.className = 'icon_yac icon_ya';
        as.textContent = 'YAC';

    return as;
};

sape.yandex.yac.decorate = function(link, place, row, inIndex)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yac;

    if (inIndex.toString().match(/^https?\:/))
    {
        place.classList.add("icon_green");
        place.setAttribute("href", inIndex.toString());
    }
    if (isFinite(inIndex))
    {
        var checkbox = st.getCheckbox(row.cells[me.lay.check]);
        if (+inIndex === 0)
        {
            place.classList.add("icon_red");

            if (!checkbox.checked)
            {
                checkbox.setAttribute("reason", "yac");
                checkbox.checked = true;
                me.counter++;
            }
            return;
        }
        if (+inIndex === -1)
        {
            place.classList.add("icon_silver");

            if (ya.errcheck && !checkbox.checked)
            {
                checkbox.checked = true;
                me.counter++;
            }
            return;
        }
    }
};

sape.yandex.yac.cached = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yac;
    if (st.cache.enabled)
    {
        var clink = st.getURI(link).spec;

        var copyUrl = st.cache.pop(clink, "yac");
        if (copyUrl !== null)
        {
           me.decorate(link, place, row, copyUrl);

           var cachedate = st.cache.pop(clink,  'yacd');
           if (cachedate)
           {
               me.placeCounter(cachedate, row);
               if (!me.ageCheck && !st.getMyLink(me, row))
               {
                   return true;
               }
           }
           return isFinite(copyUrl);
        }
    }
    return false;
};

sape.yandex.yac.placeCounter = function(cachedate, row)
{
    var st = sape.toolbar, me = sape.yandex.yac, doc = row.ownerDocument, cell = row.cells[me.lay.ico];

    if (row.querySelector('.ya-cache-date')) return;

    var b = doc.createElement('b');
        b.className = 'ya-cache-date';
        b.textContent = 'YC:';
        b.title = st.str('yac.date');

    var s  = doc.createTextNode("\xA0[" + cachedate + "]\xA0");
    var sp = doc.createTextNode("\x20");

    var root = cell.querySelector('.page_icons') || cell;
        root.appendChild(sp);
        root.appendChild(b);
        root.appendChild(s);
};

sape.yandex.yac.searchLink = function(link, text, myLink)
{
    var st = sape.toolbar, me = sape.yandex.yac;

    var URI = st.getURI(link);
    var myLinkURI = st.getURI(myLink);

    if (!sape.hasOwnProperty('external'))
    {
        st.loadJS('external');
    }

    var linkPos = sape.external.utSearchLinkPos(text, myLink, URI.host), ok = (linkPos > -1);
    if (!ok && me.lay.seo)
    {
        linkPos = sape.external.utSearchLinkPos(text, myLinkURI.prePath, URI.host);
        ok = (linkPos > -1);
    }
    return (ok)? 1 : 0;
};

sape.yandex.yac.placeOld = function(cachedate, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yac, doc = row.ownerDocument;

    if (row.querySelector('.icon_old')) return;

    var lastDate = new Date();
        lastDate.setDate(lastDate.getDate() - me.ageLimit);

    var dateText = cachedate.match(/([0-9]+)\.([0-9]+)\.([0-9]+)/);
    if (!dateText || dateText.length < 4) return;

    var dd = parseInt(dateText[1], 10);
    var mm = parseInt(dateText[2], 10)-1;
    var yy = parseInt(dateText[3], 10);

    if (yy < 2000) yy += 2000;

    var pageDate = new Date(yy,mm,dd);
    if (pageDate > lastDate) return;

    var a = doc.createElement('a');
        a.className = 'icon_old icon_ya';
        a.textContent = "OLD";
        a.title = st.str("yac.old");

    place.parentNode.insertBefore(a, place.nextSibling);

    var checkbox = st.getCheckbox(row.cells[me.lay.check]);
    if (me.ageCheck && checkbox && !checkbox.checked)
    {
        checkbox.checked = true;
        me.counter++;
    }
};

sape.yandex.yac.cachequery = function(link, place, row, cacheUrl)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yac, myLink = st.getMyLink(me, row);

    if (st.cache.enabled)
    {
        var cachedate = st.cache.pop(link, 'yacd');
        var present = (myLink)? st.cache.pop(link + '++' + myLink,  'yacl') : 0;

        if (!myLink)
        {
            if (cachedate)
            {
                me.placeCounter(cachedate, row);
                if (me.ageCheck)
                {
                    me.placeOld(cachedate, place, row);
                }
                ya.nextrow(me);
                return;
            }
        }
        else
        {
            if (cachedate && (present !== null))
            {
                me.placeCounter(cachedate, row);
                if (me.ageCheck && !present)
                {
                    me.placeOld(cachedate, place, row);
                }
                if (present)
                {
                    place.textContent = "YAC+";
                    place.title = st.str('yac.found');
                }
                ya.nextrow(me);
                return;
            }
        }
    }

    var copyDate = function(text)
    {
        var exp = /(\d+\.\d+\.\d+)\s\[\d+\:\d+\:\d+\]/;
            exp = text.match(exp);

        return (exp)? exp[1].toString() : 0;
    };

    var checkResult = function(req)
    {
        if (ya.isCaptcha(req))
        {
            if (!me.cTimer) ya.anticaptcha(me, req, checkResult);
            return;
        }

        if ((req.status == 200) && req.responseText.length)
        {
            var cachedate = copyDate(req.responseText);
            if (cachedate)
            {
                me.placeCounter(cachedate, row);
                if (st.cache.enabled)
                {
                    st.cache.push(link,  'yacd', cachedate);
                }
            }

            var present = (myLink)? me.searchLink(link, req.responseText, myLink) : 0;
            if (myLink)
            {
                if (present)
                {
                    place.textContent = "YAC+";
                    place.title = st.str('yac.found');
                }
                if (st.cache.enabled)
                {
                    st.cache.push(link + '++' + myLink,  'yacl', present);
                }
            }
            if (cachedate && !present)
            {
                me.placeOld(cachedate, place, row);
            }
        }
        if (me.inProgress) ya.next(me);
    };

    var url = cacheUrl.toString().trim();
    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            checkResult(req);
        }
    };
    req.send(null);
};

sape.yandex.yac.getCopyUrl = function(text)
{
    var st = sape.toolbar;
    var res, exp = /<a\s[^>]*\shref\=\"(http[^\"]+)\"/g;
    exp.lastIndex = 0;

    while ((res = exp.exec(text)) !== null)
    {
        var href = st.html_entity_decode(res[1]);
        if (href.indexOf('hghltd.yandex.net') > -1)
        {
            if (st.urlCheck(href)) return st.getURI(href).spec;
        }
    }
    return 0;
};

sape.yandex.yac.query = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yac;

    var URI = st.getURI(link);
    if (st.cache.enabled)
    {
        var copyUrl = st.cache.pop(URI.spec, "yac");
        if (copyUrl !== null)
        {
            me.decorate(link, place, row, copyUrl);
            if (copyUrl)
            {
                me.cachequery(link, place, row, copyUrl);
            }
            return;
        }
    }

    if (ya.yandexcheck == 1)
    {
        sape.xml.yac(link, place, row);
        return;
    }

    var checkResult = function(req)
    {
        if (ya.isCaptcha(req))
        {
            if (!me.cTimer) ya.anticaptcha(me, req, checkResult);
            row.removeAttribute(me.rowName);
            return;
        }

        var correct = 0;
        if ((req.status == 200) && req.responseText.length)
        {
            row.setAttribute(me.rowName, '1');

            var inIndex = ya.countIndex(req.responseText), copyUrl = 0;
            if (+inIndex > -1)
            {
                correct = 1;
                if (+inIndex)
                {
                    copyUrl = me.getCopyUrl(req.responseText);
                }
                me.decorate(link, place, row, copyUrl);
                if (st.cache.enabled)
                {
                    st.cache.push(URI.spec, 'yac', copyUrl);
                }
                if (copyUrl)
                {
                    me.cachequery(link, place, row, copyUrl);
                    return;
                }
            }
        }
        if (!correct)
        {
            me.decorate(link, place, row, -1);
        }
        if (me.inProgress) ya.next(me);
    };

    var page = URI.host.replace(/^www\./i, '')  + URI.path.replace(/\/$/, '');
    var q    = 'url:"' + page + '" | url:"www.' + page + '"';
    var url  = me.requestURL + encodeURIComponent(q);

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            checkResult(req);
        }
    };
    req.send(null);
};

sape.yandex.yac.nextone = function()
{
    sape.yandex.nextrow(sape.yandex.yac);
};

sape.yandex.yac.unload = function()
{
    var me = sape.yandex.yac;
    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.yandex.yac.start = function()
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yac, doc = st.getDocument();

    if (!st.inside(doc))
    {
        st.openService('YP');
        return;
    }
    if (ya.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, ya.img);
        return;
    }
    ya.init();

    var lay = st.layout(doc);

    me.lay      = lay;
    me.lc       = (lay.url < 0)? lay.link : lay.url;
    me.counter  = 0;

    if (me.lc == -1) return;

    var prefs = st.prefs();

    me.timeout      = Math.max(50, prefs.getIntPref("timeout.yandex"));
    me.requestURL   = (ya.yandexcheck == 3)? ya.requestURL : ya.defaultURL;
    me.ageCheck     = prefs.getBoolPref('yac.check.age');
    me.ageLimit     = prefs.getIntPref('yac.age');

    if (prefs.getBoolPref("yandex.updates"))
    {
        st.loadJS('updates');
        sape.updates.yandex.check();
    }
    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    ya.placeButtons(me);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, ya.img);

    var streams = (ya.yandexcheck == 1)? Math.max(1, prefs.getIntPref("streams")) : 1;
    for (var j=0; j < streams; j++)
    {
        ya.next(me, 100 + j*500);
    }
};

// ─────────────────────────────────────────────────────────────────────────────
// Проверка индексации ссылки через кэш (YACL)
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.yandex.yacl) sape.yandex.yacl =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    rowName: 'yacl',
    btnName: 'icon_yacl',
    lay: {},
    history: {use: false, age: 3}
};

sape.yandex.yacl.button = function(link, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yacl;

    var URI  = st.getURI(link);
    var page = URI.host.replace(/^www\./i, '')  + URI.path.replace(/\/$/, '');
    var q    = 'url:"' + page + '" | url:"www.' + page + '"';
    var url  = me.requestURL + encodeURIComponent(q);

    var as = me.doc.createElement('a');
        as.href = url;
        as.target = '_blank';
        as.className = 'icon_yacl icon_ya';
        as.textContent = 'YAL';

    return as;
};

sape.yandex.yacl.decorate = function(link, place, row, inIndex, copyUrl)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yacl;

    var URI      = st.getURI(link);
    var myLink   = st.getMyLink(me, row);
    var clink    = URI.spec + '++' + myLink;
    var checkbox = st.getCheckbox(row.cells[me.lay.check]);

    if (+inIndex === 0)
    {
        st.cache.age(clink, 'history', function(age)
        {
            if (!age && me.lay.history)
            {
                st.cache.push(clink, 'history', 404);
            }
            if (me.history.use && age <= me.history.age)
            {
                place.classList.add("icon_corall");
                place.setAttribute("title", st.str('yal.noindex') + ' (' + (+age/3600).toFixed() + 'h)');
            }
            else
            {
                place.classList.add("icon_red");
                if (!checkbox.checked)
                {
                    checkbox.setAttribute("reason", "yal");
                    checkbox.checked = true;
                    me.counter++;
                }
            }
        });
    }
    if (+inIndex === 1)
    {
        place.classList.add("icon_green");
        st.cache.del(URI.spec, 'history');
        st.cache.del(clink,    'history');
    }
    if (+inIndex === -1)
    {
        place.classList.add("icon_silver");

        if (ya.errcheck && !checkbox.checked && !me.history.use)
        {
            checkbox.checked = true;
            me.counter++;
        }
   }
   if (copyUrl.toString().match(/^https?\:/))
   {
        place.setAttribute("href", copyUrl.toString());
   }
};

sape.yandex.yacl.cached = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yacl;
    if (st.cache.enabled)
    {
        var clink = st.getURI(link).spec;

        var copyUrl = st.cache.pop(clink, "yac");
        if (copyUrl !== null)
        {
            if (+copyUrl === 0)
            {
               me.decorate(link, place, row, 0, 0);
               return true;
            }
        }
    }
    return false;
};

sape.yandex.yacl.placeCounter = function(cachedate, row)
{
    var st = sape.toolbar, me = sape.yandex.yacl, doc = row.ownerDocument, cell = row.cells[me.lay.ico];

    if (row.querySelector('.ya-cache-date')) return;

    var b = doc.createElement('b');
        b.className = 'ya-cache-date';
        b.textContent = 'YC:';
        b.title = st.str('yac.date');

    var s  = doc.createTextNode("\xA0[" + cachedate + "]\xA0");
    var sp = doc.createTextNode("\x20");

    var root = cell.querySelector('.page_icons') || cell;
        root.appendChild(sp);
        root.appendChild(b);
        root.appendChild(s);
};

sape.yandex.yacl.searchLink = function(link, text, myLink)
{
    var st = sape.toolbar, me = sape.yandex.yacl;

    var URI = st.getURI(link);
    var myLinkURI = st.getURI(myLink);

    if (!sape.hasOwnProperty('external'))
    {
        st.loadJS('external');
    }

    var linkPos = sape.external.utSearchLinkPos(text, myLink, URI.host), ok = (linkPos > -1);
    if (!ok && me.lay.seo)
    {
        linkPos = sape.external.utSearchLinkPos(text, myLinkURI.prePath, URI.host);
        ok = (linkPos > -1);
    }
    return (ok)? 1 : 0;
};


sape.yandex.yacl.cachequery = function(link, place, row, cacheUrl)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yacl, myLink = st.getMyLink(me, row);

    if (st.cache.enabled)
    {
        var cachedate = st.cache.pop(link, 'yacd');
        if (cachedate)
        {
            me.placeCounter(cachedate, row);
        }
        var present = st.cache.pop(link + '++' + myLink,  'yacl');
        if (present !== null)
        {
            me.decorate(link, place, row, present, cacheUrl);
            ya.nextrow(me);
            return;
        }
    }

    var copyDate = function(text)
    {
        var exp = /(\d+\.\d+\.\d+)\s\[\d+\:\d+\:\d+\]/;
            exp = text.match(exp);

        return (exp)? exp[1].toString() : 0;
    };

    var checkResult = function(req)
    {
        if (ya.isCaptcha(req))
        {
            if (!me.cTimer) ya.anticaptcha(me, req, checkResult);
            return;
        }

        if ((req.status == 200) && req.responseText.length)
        {
            var cachedate = copyDate(req.responseText);
            if (cachedate)
            {
                me.placeCounter(cachedate, row);
                if (st.cache.enabled)
                {
                    st.cache.push(link,  'yacd', cachedate);
                }
            }
            var present = me.searchLink(link, req.responseText, myLink);
            if (st.cache.enabled)
            {
                st.cache.push(link + '++' + myLink,  'yacl', present);
            }
            me.decorate(link, place, row, present, cacheUrl);
        }
        else
        {
            me.decorate(link, place, row, -1, 0);
        }
        if (me.inProgress) ya.next(me);
    };

    var url = cacheUrl.toString().trim();
    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            checkResult(req);
        }
    };
    req.send(null);
};

sape.yandex.yacl.query = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yacl;

    var URI = st.getURI(link);
    if (st.cache.enabled)
    {
        var copyUrl = st.cache.pop(URI.spec, "yac");
        if (copyUrl !== null)
        {
            if (copyUrl)
            {
                me.cachequery(link, place, row, copyUrl);
            }
            else
            {
                me.decorate(link, place, row, 0, 0);
            }
            return;
        }
    }

    var myLink = st.getMyLink(me, row);
    if (!myLink)
    {
        ya.next(me);
        return;
    }

    if (ya.yandexcheck == 1)
    {
        sape.xml.yacl(link, place, row);
        return;
    }

    var checkResult = function(req)
    {
        if (ya.isCaptcha(req))
        {
            if (!me.cTimer) ya.anticaptcha(me, req, checkResult);
            row.removeAttribute(me.rowName);
            return;
        }

        var correct = 0;
        if ((req.status == 200) && req.responseText.length)
        {
            row.setAttribute(me.rowName, '1');

            var inIndex = ya.countIndex(req.responseText), copyUrl = 0;
            if (+inIndex > -1)
            {
                correct = 1;
                if (+inIndex)
                {
                    copyUrl = ya.yac.getCopyUrl(req.responseText);
                }
                if (st.cache.enabled)
                {
                    st.cache.push(URI.spec, 'yac', copyUrl);
                }
                if (copyUrl)
                {
                    me.cachequery(link, place, row, copyUrl);
                    return;
                }
                else
                {
                    me.decorate(link, place, row, 0, 0);
                }
            }
        }
        if (!correct)
        {
            me.decorate(link, place, row, -1, 0);
        }
        if (me.inProgress) ya.next(me);
    };

    var page = URI.host.replace(/^www\./i, '')  + URI.path.replace(/\/$/, '');
    var q    = 'url:"' + page + '" | url:"www.' + page + '"';
    var url  = me.requestURL + encodeURIComponent(q);

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            checkResult(req);
        }
    };
    req.send(null);
};

sape.yandex.yacl.nextone = function()
{
    sape.yandex.nextrow(sape.yandex.yacl);
};

sape.yandex.yacl.unload = function()
{
    var me = sape.yandex.yacl;
    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.yandex.yacl.start = function()
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.yacl, doc = st.getDocument();

    if (ya.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, ya.img);
        return;
    }
    ya.init();

    var lay = st.layout(doc);

    me.lay      = lay;
    me.lc       = (lay.url < 0)? lay.link : lay.url;
    me.counter  = 0;

    if (me.lc == -1) return;

    if (me.lay.loc.match(/[\/]site_links\.php/i))
    {
        ya.yal.start();
        return;
    }

    var prefs = st.prefs();

    me.timeout      = Math.max(50, prefs.getIntPref("timeout.yandex"));
    me.requestURL   = (ya.yandexcheck == 3)? ya.requestURL : ya.defaultURL;
    me.history.use  = prefs.getBoolPref("history.use") && me.lay.history;
    me.history.age  = prefs.getIntPref("history.age") * 24 * 60 * 60;

    if (me.lay.dc == -1)
    {
        if (me.lay.loc.indexOf('wmsape/content/check.html') > 0)
        {
            me.lastDate = 0;
        }
        else
        {
            return;
        }
    }
    else
    {
        me.lastDate = new Date();
        me.lastDate.setDate(me.lastDate.getDate() - ya.liveDays);
    }

    if (prefs.getBoolPref("yandex.updates"))
    {
        st.loadJS('updates');
        sape.updates.yandex.check();
    }
    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    ya.placeButtons(me);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, ya.img);

    var streams = (ya.yandexcheck == 1)? Math.max(1, prefs.getIntPref("streams")) : 1;
    for (var j=0; j < streams; j++)
    {
        ya.next(me, 100 + j*500);
    }
};


// ─────────────────────────────────────────────────────────────────────────────
// Проверка релевантности анкоров (REL)
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.yandex.relevancy) sape.yandex.relevancy =
{
    inProgress: 0,
    cTimer: 0,
    doc: null,
    lc: -1,
    counter: 0,
    rowName: 'relevancy',
    btnName: 'icon_relevancy',
    lay: {}
};

sape.yandex.relevancy.getQueryText = function(cell)
{
    var st = sape.toolbar, me = sape.yandex.relevancy;

    var htmlcell = st.getTextCell(cell);
    var u = htmlcell.querySelector('u');

    var text = (u)? u.textContent : htmlcell.textContent;
        text = st.html_entity_decode(text).trim().toLowerCase();

    var result = text.replace(/[^0-9a-z\u0430-\u044F\u0451]+/gi, ' ').replace(/\s\s+/g, ' ');
    if (me.keycheck)
    {
        var words = result.split(' '), nresult = "";
        for (var i = 0; i < words.length; i++)
        {
            if (!(me.stoplist.indexOf(words[i]) > -1) && (words[i].length > 1)) nresult += words[i] + ' ';
        }
        result = nresult.trim();
    }
    else
    {
        if (me.lay.seo)
        {
            result = result.replace(/\s[^\s]{1,2}\s/ig, ' ').replace(/\s[^\s]{1,2}$/ig, '').replace(/^[^\s]{1,2}\s/ig, '');
        }
    }
    if (me.lay.seo)
    {
        result = '(' + result.replace(/\s/g, ' | ') + ')';
    }
    return result;
};

sape.yandex.relevancy.button = function(link, row)
{
    var st = sape.toolbar, me = sape.yandex.relevancy;

    var URI  = st.getURI(link);
    var page = URI.host.replace(/^www\./i, '')  + URI.path.replace(/\/$/, '');
    var q    = me.getQueryText(row.cells[me.lay.text]) + ' (url:"' + page + '" | url:"www.' + page + '")';
    var url  = me.requestURL + encodeURIComponent(q) + '&noreask=1&nomisspell=1';

    var as = me.doc.createElement('a');
        as.href = url;
        as.target = '_blank';
        as.className = 'icon_relevancy icon_ya';
        as.textContent = 'REL';

    return as;
};

sape.yandex.relevancy.decorate = function(link, place, row, inIndex)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.relevancy;

    var checkbox = st.getCheckbox(row.cells[me.lay.check]);
    if (inIndex < 0)
    {
        place.classList.add("icon_silver");
        if (ya.errcheck && !checkbox.checked)
        {
            checkbox.checked = true;
            me.counter++;
        }
        return;
    }
    if (!inIndex)
    {
        place.classList.add("icon_red");
        place.title = st.str("rel.bad");
        if (!checkbox.checked)
        {
            checkbox.checked = true;
            me.counter++;
        }
    }
    if (inIndex > 0)
    {
        place.classList.add("icon_green");
        place.title = st.str("rel.ok");
    }
};

sape.yandex.relevancy.cached = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.relevancy;
    if (st.cache.enabled)
    {
        var URI   = st.getURI(link);
        var text  = ya.yal.getText(row.cells[me.lay.text]);
        var clink = URI.spec + '++' + text;

        var inIndex = st.cache.pop(clink, 'yal.' + ya.yandexcheck);
        if (inIndex !== null)
        {
           me.decorate(link, place, row, +inIndex);
           return true;
        }
    }
    return false;
};

sape.yandex.relevancy.query = function(link, place, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.relevancy;

    var URI = st.getURI(link);

    if (ya.yandexcheck == 1)
    {
        sape.xml.relevancy(URI.spec, place, row);
        return;
    }

    var checkResult = function(req)
    {
        if (ya.isCaptcha(req))
        {
            if (!me.cTimer) ya.anticaptcha(me, req, checkResult);
            row.removeAttribute(me.rowName);
            return;
        }

        var correct = 0;
        if ((req.status == 200) && req.responseText.length)
        {
            row.setAttribute(me.rowName, '1');

            var inIndex = ya.countIndex(req.responseText);
            if (+inIndex > -1)
            {
                correct = 1;
                if (st.cache.enabled)
                {
                    var text  = ya.yal.getText(row.cells[me.lay.text]);
                    var clink = URI.spec + '++' + text;

                    st.cache.push(clink,  'yal.' + ya.yandexcheck, inIndex);
                    if (+inIndex)
                    {
                        st.cache.push(URI.spec,  'yap.' + ya.yandexcheck, inIndex);
                    }
                }
                me.decorate(URI.spec, place, row, +inIndex);
            }
        }
        if (!correct)
        {
            me.decorate(URI.spec, place, row, -1);
        }
        if (me.inProgress) ya.next(me);
    };

    var url = place.getAttribute('href');
    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

    if (ya.yandexcheck == 8)
    {
        req.setRequestHeader('User-Agent', 'Mozilla/5.0 (iPhone; CPU iPhone OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53');
    }
    req.onreadystatechange = function (aEvt)
    {
        if (req.readyState == 4)
        {
            checkResult(req);
        }
    };
    req.send(null);

};

sape.yandex.relevancy.nextone = function()
{
    sape.yandex.nextrow(sape.yandex.relevancy);
};

sape.yandex.relevancy.unload = function()
{
    var me = sape.yandex.relevancy;
    if (me.doc && me.doc.defaultView)
    {
        me.doc.defaultView.removeEventListener('unload', me.unload, false);
    }
    me.inProgress = me.cTimer = me.doc = 0;
};

sape.yandex.relevancy.start = function()
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.relevancy, doc = st.getDocument();

    if (ya.stop(me))
    {
        st.showAlert(st.str('links.checked') + ' ' + me.counter, st.str('ya.stop'), 2, ya.img);
        return;
    }
    var lay = st.layout(doc);

    me.lay      = lay;
    me.lc       = (lay.url < 0)? lay.link : lay.url;
    me.counter  = 0;

    if (me.lc == -1 || me.lay.text == -1) return;

    ya.init();

    var prefs = st.prefs();

    me.timeout    = Math.max(50, prefs.getIntPref("timeout.yandex"));
    me.requestURL = ya.requestURL;
    me.keycheck   = prefs.getBoolPref("rel.keycheck");
    me.stoplist   = [];

    if (me.keycheck)
    {
        if (!sape.hasOwnProperty('external'))
        {
            st.loadJS('external');
        }
        me.stoplist = sape.external.prefToArray("rel.stoplist");
    }
    if (prefs.getBoolPref("yandex.updates"))
    {
        st.loadJS('updates');
        sape.updates.yandex.check();
    }
    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    ya.placeButtons(me);

    me.cTimer     = 0;
    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ya.start'), 1, ya.img);

    var streams = (ya.yandexcheck == 1)? Math.max(1, prefs.getIntPref("streams")) : 1;
    for (var j=0; j < streams; j++)
    {
        ya.next(me, 100 + j*500);
    }
};


// ─────────────────────────────────────────────────────────────────────────────
// Функция показа ТИЦ
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.yandex.tic) sape.yandex.tic =
{
    lc: -1,
    tc: -1,
    bgcolor: "pink",
    drivelink: false,
    xtool: false,
    lay: {}
};

sape.yandex.tic.mark = function(aEvent)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.tic;
    var doc = st.getDocument();
    var lay = st.layout(doc);

    var cnv, image = aEvent.originalTarget;
    var hash  = image.getAttribute('hash');
    if (!hash)
    {
         cnv = doc.createElement("canvas");
         cnv.width = 88;
         cnv.height = 31;
         cnv.getContext('2d').drawImage(image,0,0,88,31);

         hash = st.md5(cnv.toDataURL("image/png", ""));
         image.setAttribute('hash', hash);
    }
    var counter = 0;
    var row  = doc.getElementsByTagName('tr'), rl = row.length;
    for (var i=0; i < rl; i++)
	{
		var img = row[i].querySelector('img.' + image.className);
        if (!img) continue;

        var col = row[i].cells;
        if (col.length < lay.cols) continue;

        var checkbox = st.getCheckbox(col[lay.check]);
        if (!checkbox) continue;

        var md5 = img.getAttribute('hash');
        if (!md5)
        {
                try
                {
                    cnv = doc.createElement("canvas");
                    cnv.width = 88;
                    cnv.height = 31;
                    cnv.getContext('2d').drawImage(img,0,0,88,31);

                    md5 = st.md5(cnv.toDataURL("image/png", ""));
                    img.setAttribute('hash', md5);
                }
                catch(e) {}
        }
        if (md5 == hash)
        {
           sape.filters.decorate(row[i], me.bgcolor);
           checkbox.checked = true;
           checkbox.setAttribute("reason", "tic");
           counter++;
        }
    }
    if (counter > 0)
    {
        st.showAlert(st.str('links.checked') + ' ' + counter, st.str('ya.finished'), 0, sape.yandex.img);

        if (ya.changeselect) st.changeSelect(doc, 'placementRemove');
    }
    return false;
};

sape.yandex.tic.select = function()
{
    var counters = sape.toolbar.prefs().getIntPref("tic.counters");
    if (!counters)
    {
        sape.yandex.info.start();
    }
    else
    {
        sape.yandex.tic.start();
    }
};

sape.yandex.tic.start = function()
{
    var st = sape.toolbar, me = sape.yandex.tic;

    var doc = st.getDocument();
    if (!st.inside(doc))
    {
        st.openService('TIC');
        return;
    }
    sape.yandex.init();

    var lay = st.layout(doc);

    me.lay = lay;
    me.lc  = (lay.link < 0)? lay.url : lay.link;
    me.tc  = lay.tic;

    if (me.tc == -1) me.lc = me.tc = lay.url;
    if (me.tc == -1) return;

    var prefs       = st.prefs();
    me.bgcolor      = prefs.getCharPref("bgcolor").replace(/[^0-9a-z#]+/ig,"");
    me.drivelink    = (prefs.getIntPref("tic.counters") == 2);
    me.xtool        = (prefs.getIntPref("tic.counters") == 3);

    var row = doc.getElementsByTagName('tr'), rl = row.length;
    for (var i=0; i < rl; i++)
	{
		var td = row[i].cells;
        if (td.length < lay.cols) continue;

        var checkbox = st.getCheckbox(td[me.lay.check]);
        if (!checkbox) continue;

        var a = td[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var href = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        var html = row[i].innerHTML;
        if (html.match(/drivelink/) &&  me.drivelink) continue;
        if (html.match(/xtool/)     &&  me.xtool) continue;
        if (html.match(/cycounter/) && !me.drivelink && !me.xtool) continue;

        var URI = st.getURI(href);

        var img = new Image();
            img.style.cursor = 'pointer';
            img.addEventListener("click", me.mark, false);

        var link = doc.createElement("a");

        if (me.drivelink)
        {
            img.src = 'http://drivelink.ru/images/rank/cache/' + encodeURIComponent(URI.asciiHost.replace(/^www./, '')) + '.png';
            img.className = 'dlCounter';
        }
        if (me.xtool)
        {
            var xtoolError = function(event)
            {
                event.target.src = 'chrome://wmsape/skin/trust-no.png';
                event.target.removeEventListener('error', xtoolError, false);
            };
            img.src = 'http://1.xtool.ru/i/?site=' + encodeURIComponent(URI.asciiHost);
            img.className = 'xtCounter';
            img.addEventListener('error', xtoolError, false);

            link.href  = 'http://xtool.ru/trust/?site=' + encodeURIComponent(URI.asciiHost);
        }
        if (!me.drivelink && !me.xtool)
        {
            img.src = 'http://yandex.ru/cycounter?' + encodeURIComponent(URI.asciiHost);
            img.className = 'cyCounter';

            link.href  = 'http://yaca.yandex.ru/yca/cy/ch/' + encodeURIComponent(URI.asciiHost) + '/';
        }

        var prevent = function(event)
        {
            event.preventDefault();
        };
        link.target = '_blank';
        link.addEventListener("click", prevent,  false);
        link.appendChild(img);

        var div = td[me.tc].querySelector('div.ticPlace') || doc.createElement("div");
            div.className  = "ticPlace";
            div.appendChild(link);

        td[me.tc].appendChild(div);
    }
    st.initDOM();
};

// ─────────────────────────────────────────────────────────────────────────────
// Клей ТИЦ, показ тематики и региона
// ─────────────────────────────────────────────────────────────────────────────

if (!sape.yandex.info) sape.yandex.info =
{
    inProgress: 0,
    timeout: 50,
    doc: null,
    lc: -1,
    tc: -1,
    lay: {}
};

sape.yandex.info.checkCat = function(host, place, checkbox)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.info;

    if (st.cache.enabled)
    {
        var cached = st.cache.pop(host, 'ags');
        if (cached !== null)
        {
            if (cached == 1) me.showAgs(place, checkbox);
            return;
        }
    }

    var url = 'http://yaca.yandex.ru/yca/cy/ch/' + host + '/';
    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.responseType = 'document';
        req.timeout = 15000;

     req.onreadystatechange = function (aEvt)
     {
        if (req.readyState == 4)
        {
            if (req.status == 200 && req.responseXML)
            {
                var p = req.responseXML.querySelector('p.b-cy_error-cy');
                if (p && p.textContent)
                {
                    if (p.textContent.indexOf('\u043d\u0435\0x20\u043e\u043f\u0440\u0435\u0434\u0435\u043b\u0435\u043d') > -1)
                    {
                        me.showAgs(place, checkbox);
                        if (st.cache.enabled) st.cache.push(host, 'ags', 1);
                    }
                    else
                    {
                        if (st.cache.enabled) st.cache.push(host, 'ags', 0);
                    }
                }
            }
        }
    };
    req.send(null);
};


sape.yandex.info.showAgs = function(place, checkbox)
{
    var st = sape.toolbar, me = sape.yandex.info;

    var ags = me.doc.createElement('span');
        ags.setAttribute("style", "margin-left:5px; font-size:9px; color:red;");
        ags.textContent = "\x20\u0410\u0413\u0421-40\x20";

    var ticLink = place.querySelector('a.ticLink');
    if (ticLink)
    {
        place.insertBefore(ags, ticLink.nextSibling);
    }
    if (checkbox && !checkbox.checked && me.ticAgs)
    {
        checkbox.setAttribute("reason", "tic:ags");
        checkbox.checked = true;
    }
};

sape.yandex.info.show = function(href, row, results)
{
    var st = sape.toolbar, me = sape.yandex.info;

    var sameHost = function(host1, host2)
    {
        var u1 = st.getURI('http://' + host1.replace(/^.*[\/][\/]/, '').replace(/^www./i, ''));
        var u2 = st.getURI('http://' + host2.replace(/^.*[\/][\/]/, '').replace(/^www./i, ''));

        return (u1.asciiHost == u2.asciiHost);
    };

    var place = row.querySelector('div.iticPlace');
    if (!place)
    {
        place = me.doc.createElement('div');
        place.className = 'iticPlace';

        row.cells[me.lc].appendChild(place);
    }
    else place.textContent = '';

    var checkbox = st.getCheckbox(row.cells[me.lay.check]);
    if (checkbox && me.ticCheck && (results.tic < me.ticLimit))
    {
        checkbox.setAttribute("reason", "tic");
        checkbox.checked = true;
    }

    var aURI = st.getURI(href), glue = null, mark = null;

    var ticLink = me.doc.createElement('a');
        ticLink.setAttribute("target", "_blank");
        ticLink.className = "ticLink";
        ticLink.href  = 'http://yaca.yandex.ru/yca/cy/ch/' + aURI.asciiHost + '/';
        ticLink.textContent = results.tic;

    if (results.domain.length)
    {
        if (sameHost(results.domain, aURI.asciiHost))
        {
            ticLink.setAttribute("style", "color:green; cursor:help; font-weight:bold;");
            ticLink.title = st.str('ctic.for') + ' ' + results.domain;
        }
        else
        {
            ticLink.setAttribute("style", "color:red; cursor:help; font-weight:bold;");
            ticLink.title = st.str('ctic.glue') + ' ' + results.domain;

            glue = me.doc.createElement('span');
            glue.style.cursor = 'help';
            glue.title = st.str('ctic.glue') + ' ' + results.domain;
            glue.textContent = '\x20[' + results.domain + ']\x20';

            mark = me.doc.createElement('div');
            mark.title = st.str('ctic.glue') + ' ' + results.domain;
            mark.setAttribute("style", "color:red; cursor:help; font-weight:bold;");
            mark.textContent = 'M';
       }
    }
    else
    {
        ticLink.setAttribute("style", "color:red; font-weight:bold;");
    }

    place.appendChild(me.doc.createTextNode(st.str('ctic.tic') + ' '));
    place.appendChild(ticLink);

    if (glue)
    {
        place.appendChild(glue);
        if (me.lc !== me.tc)
        {
            row.cells[me.tc].appendChild(mark);
        }
        if (checkbox && !checkbox.checked && me.ticGlue)
        {
            checkbox.setAttribute("reason", "tic:glue");
            checkbox.checked = true;
        }
    }
    if ((results.rang >  results.tic) && !results.tic)
    {
        me.showAgs(place, checkbox);
    }
    if (me.ticAgsCat && !results.rang && !results.tic)
    {
        me.checkCat(aURI.asciiHost, place, checkbox);
    }
    if (results.info.length)
    {
        var intext = results.info.trim().split(/\n/);
        for (var j=0; j<intext.length; j++)
        {
            place.appendChild(me.doc.createElement('br'));
            place.appendChild(me.doc.createTextNode(intext[j].trim()));
        }
    }
};

sape.yandex.info.request = function(href, row)
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.info;

    var aURI = st.getURI(href);
    var url  = 'http://bar-navig.yandex.ru/u?ver=8.2.1&httpstatus=200&clid=1917055&yasoft=barff&brandID=yandex&url=' + encodeURIComponent(aURI.asciiSpec) + '&show=1&post=0&title=' + encodeURIComponent(aURI.asciiHost) + '&urlinfo=1';

    var img = me.doc.createElement("img");
        img.src = 'chrome://wmsape/skin/ajax-loader.gif';

    var loader = me.doc.createElement('div');
        loader.className = 'itic-loader';
        loader.appendChild(img);

    row.cells[me.lc].appendChild(loader);

    var req = new XMLHttpRequest();
        req.open('GET', url, true);
        req.timeout = 15000;

     req.onreadystatechange = function (aEvt)
     {
        if (req.readyState == 4)
        {
                if (loader) loader.parentNode.removeChild(loader);
                if (ya.isCaptcha(req))
                {
                    st.showAlert(st.str('bad'), st.str('captcha'), 2, ya.img);
                    row.removeAttribute('itic');
                    me.unload();
                    return;
                }
                if (req.status == 200 && req.responseXML)
                {
                    row.setAttribute('itic', '1');

                    var xml = req.responseXML;
                    var ti  = xml.getElementsByTagName("textinfo");
                    var ui  = xml.getElementsByTagName("url");
                    var ci  = xml.getElementsByTagName("tcy");

                    var results = {};
                        results.info   = (ti.length)? ti[0].textContent : "";
                        results.domain = (ui.length)? ui[0].getAttribute("domain")  : "";
                        results.tic    = (ci.length)? + ci[0].getAttribute("value") : 0;
                        results.rang   = (ci.length)? + ci[0].getAttribute("rang")  : 0;

                    if (st.cache.enabled) st.cache.push(aURI.asciiSpec, 'tic', JSON.stringify(results));

                    me.show(aURI.asciiSpec, row, results);
                }
                if (me.inProgress) ya.next(me);
        }
    };
    req.send(null);
};

sape.yandex.info.nextone = function()
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.info;

    if (!me.doc || !me.doc.defaultView) return;

    var row = me.doc.getElementsByTagName('tr'), rl = row.length;
    for (var i=0; i < rl; i++)
    {
        if (row[i].hasAttribute('itic')) continue;
        if (row[i].cells.length < me.lay.cols) continue;

        var checkbox = st.getCheckbox(row[i].cells[me.lay.check]);
        if (!checkbox) continue;

        var a = row[i].cells[me.lc].getElementsByTagName('a');
        if (a.length < me.lay.idx + 1) continue;

        var href = a[me.lay.idx].getAttribute('href');
        if (!st.urlCheck(href)) continue;

        row[i].setAttribute('itic', '1');

        var aURI = st.getURI(href);
        if (st.cache.enabled)
        {
            var cached = st.cache.pop(aURI.asciiSpec, 'tic');
            if (cached)
            {
                me.show(aURI.asciiSpec, row[i], JSON.parse(cached));
                continue;
            }
        }

        me.request(aURI.asciiSpec, row[i]);
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('nice'), st.str('ctic.finish'), 2, ya.img);
    }
};

sape.yandex.info.unload = function()
{
    var me = sape.yandex.info;
    if (me.doc && me.doc.defaultView) me.doc.defaultView.removeEventListener('unload', me.unload, false);
    me.doc = me.inProgress = 0;
};

sape.yandex.info.start = function()
{
    var st = sape.toolbar, ya = sape.yandex, me = ya.info;

    var doc = st.getDocument();
    if (!st.inside(doc))
    {
        st.openService('TIC');
        return;
    }
    if (me.inProgress)
    {
        me.inProgress = 0;
        st.showAlert(st.str('bad'), st.str('ctic.stop'), 2, ya.img);
        return;
    }
    if (me.doc) me.unload();

    ya.init();

    me.lay = st.layout(doc);
    me.tc  = me.lay.tic;
    me.lc  = (me.lay.link < 0)? me.lay.url : me.lay.link;

    if (me.tc == -1) me.lc = me.tc = me.lay.url;
    if (me.tc == -1 || me.lc == -1) return;

    me.doc = doc;
    me.doc.defaultView.addEventListener('unload', me.unload, false);

    var prefs = st.prefs();

    me.ticLimit  = prefs.getIntPref("tic.limit");
    me.ticCheck  = prefs.getBoolPref("tic.check");
    me.ticGlue   = prefs.getBoolPref("tic.glue");
    me.ticAgs    = prefs.getBoolPref("tic.ags");
    me.ticAgsCat = prefs.getBoolPref("tic.ags.cat");
    me.timeout   = Math.max(50, prefs.getIntPref("timeout.yandex"));

    me.inProgress = 1;
    st.showAlert(st.str('nice'), st.str('ctic.start'), 1, ya.img);

    var streams = Math.max(1, prefs.getIntPref("streams"));
    for (var j=0; j < streams; j++)
    {
        ya.next(me, 100 + j*500);
    }
};
