var sape = sape || {};

if (!sape.options) sape.options = {};

sape.options.onload = function()
{
    var so = sape.options;
    try
    {
        Components.utils["import"]("resource://gre/modules/AddonManager.jsm");
        AddonManager.getAddonByID("toolbar@sape.ru", function(addon)
        {
            var prefWindow = document.getElementById("wmsapePreferences");
            if (prefWindow) prefWindow.setAttribute("title", prefWindow.getAttribute("title") + " " + addon.version);
        });
    }
    catch(ex){}

    so.logins.load("SEOBudget");
    so.logins.load("XTool");
    so.logins.load("Megaindex");
    so.initButtons();
    so.tic.init();
    so.seobudget.init();
    so.megaindex.init();
    so.useragent.init();
    so.noadvert.init();

    window.sizeToContent();
};

sape.options.change = function(element)
{
    if (document.createEvent && element.dispatchEvent)
    {
        var evt = document.createEvent("HTMLEvents");
            evt.initEvent("change", true, true);

        element.dispatchEvent(evt);
    }
};

sape.options.ondialogaccept = function()
{
    sape.options.logins.save("SEOBudget");
    sape.options.logins.save("XTool");
    sape.options.logins.save("Megaindex");
    return true;
};

sape.options.logins =
{
    save: function(srvName)
    {
        var u = document.getElementById(srvName.toLowerCase() + "-login-field");
        var p = document.getElementById(srvName.toLowerCase() + "-password-field");

        sape.options.logins.set(srvName, u.value, p.value);
    },

    load: function(srvName)
    {
        var info = sape.options.logins.get(srvName);
        if (info)
        {
            document.getElementById(srvName.toLowerCase() + "-login-field").value = info.login;
            document.getElementById(srvName.toLowerCase() + "-password-field").value = info.password;
        }
    },

    get: function(srvName)
    {
        if (!("@mozilla.org/login-manager;1" in Components.classes)) return null;

        var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);

        var host = "chrome://wmsape/" + srvName.toLowerCase();
        var name = srvName + ' Registration';
        try
        {
            var logins = myLoginManager.findLogins({}, host, null, name);
            if (logins && logins.length)
            {
                return {login:logins[0].username, password:logins[0].password};
            }
        }
        catch(ex) {}

        return null;
    },

    set: function(srvName, login, password)
    {
        if (!("@mozilla.org/login-manager;1" in Components.classes)) return;

        var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
        var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");

        var host = "chrome://wmsape/" + srvName.toLowerCase();
        var name = srvName + ' Registration';
        try
        {
            var logins = myLoginManager.findLogins({}, host, null, name);
            for (var i=0; i < logins.length; i++)
            {
                var oldLoginInfo = new nsLoginInfo(host, null, name, logins[i].username, logins[i].password, "", "");
                myLoginManager.removeLogin(oldLoginInfo);
            }
            if (login && password)
            {
                var newLoginInfo = new nsLoginInfo(host, null, name, login, password, "", "");
                myLoginManager.addLogin(newLoginInfo);
            }
        }
        catch(ex) {}
    }
};

sape.options.defaults = function()
{
    if (sape.presets) sape.presets.reset();
    sape.options.initButtons();
    sape.options.tic.listener();
    sape.options.seobudget.listener();
    sape.options.useragent.listener();
};

sape.options.toggle = function(id)
{
    var groupbox = document.getElementById(id);
    if (groupbox)
    {
        groupbox.collapsed = !groupbox.collapsed;
    }
    window.sizeToContent();
};

sape.options.xmlConfig =
{
    toggle: function()
    {
        sape.options.toggle("yandex-xml-config");
    }
};

sape.options.initButtons = function()
{
    var st = sape.toolbar, so = sape.options;

    var hidden = st.prefs().getCharPref("interface.hidden");

    so.hiddenButtons = hidden.split(',');

    var box = document.getElementById("wmsapeButtonSet");
    if (!box) return;

    var img = box.getElementsByTagName("image");
    for (var i=0; i < img.length; i++)
    {
        if (img[i].hasAttribute("rel"))
        {
            var name = img[i].getAttribute("rel");
            if (so.hiddenButtons.indexOf(name) > -1)
            {
                img[i].setAttribute("tooltiptext", st.str("enable"));
                img[i].className = 'tbh';
            }
            else
            {
                img[i].setAttribute("tooltiptext", st.str("disable"));
                img[i].className = 'tbv';
            }
            img[i].addEventListener("click", sape.options.tclick, true);
        }
    }
};

sape.options.tclick = function(evt)
{
    var st = sape.toolbar, so = sape.options, pos;
    var image = evt.target;
    var name = image.getAttribute("rel");

    if ((pos = so.hiddenButtons.indexOf(name)) > -1)
    {
        so.hiddenButtons.splice(pos, 1);
        image.className = 'tbv';
        image.setAttribute("tooltiptext", st.str("disable"));
    }
    else
    {
        so.hiddenButtons.push(name);
        image.className = 'tbh';
        image.setAttribute("tooltiptext", st.str("enable"));
    }
    st.prefs().setCharPref("interface.hidden", so.hiddenButtons.join(","));
};

sape.options.sortStopList = function(id)
{
    var box = document.getElementById(id);
    var all = box.value.split(/[\n\r\,]+/);

    var element, result = [];
    while (all.length)
    {
        if ((element = all.shift().trim()).length) result.push(element);
    }
    result = result.sort().filter(function(el,i,a){return i == a.indexOf(el);});

    box.value = result.join(", ");
    sape.options.change(box);
};

sape.options.selectAGHost = function(host)
{
    var box = document.getElementById("wmsapeAGHost");

    box.value = host;
    sape.options.change(box);
};

sape.options.tic =
{
    init: function()
    {
        var radio = document.getElementById("rgTicRadio");
            radio.addEventListener("RadioStateChange", this.listener, true);

        this.listener();
    },

    listener: function()
    {
        var radio = document.getElementById("rgTicRadio");

        var ch1 = document.getElementById("hboxTic1").childNodes;
        for (var i = 0; i < ch1.length; i++)
        {
            ch1[i].disabled = !!(+radio.value);
        }
        var ch2 = document.getElementById("hboxTic2").childNodes;
        for (var j = 0; j < ch2.length; j++)
        {
            ch2[j].disabled = !!(+radio.value);
        }
        var ch3 = document.getElementById("hboxTic3").childNodes;
        for (var k = 0; k < ch3.length; k++)
        {
            ch3[k].disabled = !!(+radio.value);
        }
    }
};

sape.options.seobudget =
{
    init: function()
    {
        var checkbox = document.getElementById("chkSeobudgetUse");
            checkbox.addEventListener("CheckboxStateChange", this.listener, true);

        this.listener();
    },

    listener: function()
    {
        var checkbox = document.getElementById("chkSeobudgetUse");

        var ch1 = document.getElementById("hboxHostRegion").childNodes;
        for (var i = 0; i < ch1.length; i++)
        {
            ch1[i].disabled = checkbox.checked;
        }
        var ch2 = document.getElementById("chkHostSub");
            ch2.disabled = checkbox.checked;
    }
};

sape.options.megaindex =
{
    init: function()
    {
        var checkbox = document.getElementById("chkMegaindexUse");
            checkbox.addEventListener("CheckboxStateChange", this.listener, true);

        this.listener();
    },

    listener: function()
    {
        var checkbox = document.getElementById("chkMegaindexUse");
        var radiogroup = document.getElementById("rgGPType");

        var radio = radiogroup.querySelector('radio[value="1"]');
        if (radio)
        {
            radio.disabled = checkbox.checked;
        }
        if (radiogroup && checkbox.checked)
        {
            radiogroup.selectedIndex = 0;
            sape.options.change(radiogroup);
        }
    }
};

sape.options.useragent =
{
    init: function()
    {
        var menu = document.getElementById("user-agent-menulist");
            menu.addEventListener("select", this.listener, true);

        this.listener();
    },

    listener: function()
    {
        var menu = document.getElementById("user-agent-menulist");
        var line = document.getElementById("user-agent-line");

        line.setAttribute('hidden', !(menu.selectedIndex == 5));
    }
};

sape.options.noadvert =
{
    init: function()
    {
        var D = new Date(), now = Math.floor(D.getTime() / 1000);
        var showTime = sape.toolbar.prefs().getIntPref("noadvert") || (now - 1);

        var a1 = document.getElementById("advert-1");
        if (a1) a1.collapsed = (now < showTime);

        var a2 = document.getElementById("advert-2");
        if (a2) a2.collapsed = (now < showTime);

        var a3 = document.getElementById("advert-3");
        if (a3) a3.collapsed = (now < showTime);
    },

    close: function()
    {
        var D = new Date(), now = Math.floor(D.getTime() / 1000);
        var showTime = now + 30 * 24 * 60 * 60;

        sape.toolbar.prefs().setIntPref("noadvert", showTime);
        this.init();

        alert('OK :o(');
    }
};

