var sape = sape || {};
sape.toolbar = sape.toolbar || {};

sape.toolbar.lazy =
{
    notify: function()
    {
        var loader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Components.interfaces.mozIJSSubScriptLoader);
            loader.loadSubScript("chrome://wmsape/content/cache.js",     null, "UTF-8");
            loader.loadSubScript("chrome://wmsape/content/filters.js",   null, "UTF-8");
            loader.loadSubScript("chrome://wmsape/content/presets.js",   null, "UTF-8");

            sape.toolbar.firstRun();
            sape.toolbar.initInterface();
            sape.toolbar.cache.init();
            sape.presets.init();

            window.addEventListener("DOMContentLoaded", sape.toolbar.elements.init, false);
    },

    init: function()
    {
        var loadTimer = Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);
            loadTimer.initWithCallback(sape.toolbar.lazy, 500, Components.interfaces.nsITimer.TYPE_ONE_SHOT);

        window.removeEventListener("load", sape.toolbar.lazy.init, false);
    }
};

//------------------------------------------------------------------------------
// Элементы интерфейса браузера
//------------------------------------------------------------------------------

sape.toolbar.firstRun = function()
{
    var installButton = function(toolbarId, id)
    {
        if (!document.getElementById(id))
        {
            var toolbar = document.getElementById(toolbarId);
            if (toolbar)
            {
                toolbar.insertItem(id);
                toolbar.setAttribute("currentset", toolbar.currentSet);
                document.persist(toolbar.id, "currentset");
            }
        }
    };
    var prefs = sape.toolbar.prefs(), isFirst = prefs.getBoolPref("firstrun");
    if (isFirst)
    {
        prefs.setBoolPref("firstrun", false);
        installButton("nav-bar", "wmsape-toolbar-item");

        if (!document.querySelector("#navigator-toolbox #addon-bar"))
        {
            installButton("addon-bar", "wmsape-statusbar-panel-icon");
        }
    }
};

//------------------------------------------------------------------------------
// Элементы интерфейса страниц
//------------------------------------------------------------------------------

sape.toolbar.elements =
{
    history: function(doc)
    {
        var root = doc.querySelector('div.nav.nav_sape ul.my-n-nav__list');
        if (!root) return;

        var a = doc.createElement("a");
            a.className = "my-n-nav__link";
            a.setAttribute("style", "cursor:pointer; color:#66FFFF;");
            a.setAttribute("title", "\u0418\u0441\u0442\u043e\u0440\u0438\u044f \u043f\u0440\u043e\u0432\u0435\u0440\u043e\u043a \u043f\u0430\u0440\u0430\u043c\u0435\u0442\u0440\u043e\u0432 \u043f\u043b\u0430\u0433\u0438\u043d\u043e\u043c Webmaster SAPE");
            a.textContent="\u0418\u0441\u0442\u043e\u0440\u0438\u044f";
            a.addEventListener("click", function(e){openUILinkIn('chrome://wmsape/content/history.html', 'tab');}, true);

        var li = doc.createElement("li");
            li.className = "my-n-nav__item my-n-nav__item_sape";
            li.appendChild(a);

        root.appendChild(li);
    },

    init: function(aEvent)
    {
        var st = sape.toolbar, doc = aEvent.originalTarget;
        if (doc instanceof HTMLDocument)
        {
            try
            {
                st.initInterface();
            }
            catch(ex) {}

            if (!st.inside(doc)) return;

            if (st.prefs().getBoolPref("cache"))
            {
                st.elements.history(doc);
            }
            if (doc.location.host == 'wmsape')
            {
                if (doc.location.pathname.match(/^\/content\/history/i))
                {
                    st.loadJS('history');
                    sape.history.init(doc);
                }
                if (doc.location.pathname.match(/^\/content\/check/i))
                {
                    st.loadJS('checker');
                    sape.checker.init(doc);
                }
            }
            else
            {
                if (doc.location.pathname.match(/^[\/](links|site_links)\.php/i))
                {
                    st.loadJS('sleeps');
                    sape.sleeps.init(doc);
                }
                if (doc.location.pathname.match(/^[\/]orders\.php/i) && doc.location.search.indexOf('filter_mode=1') > -1)
                {
                    st.loadJS('tryout');
                    sape.tryout.init(doc);
                }
            }
        }
    }
};

window.addEventListener("load", sape.toolbar.lazy.init, false);