var sape = sape || {};

if (!sape.presets) sape.presets =
{
    data: [],
    now: -1
};

sape.presets.observer =
{
    observe: function(aSubject, aTopic, aData)
    {
        if (sape && aTopic == "nsPref:changed")
        {
            if (aData.indexOf("interface") > -1) sape.toolbar.initInterface();
        }
    }
};

//------------------------------------------------------------------------------
// Создает меню пресетов
//------------------------------------------------------------------------------
sape.presets.init = function()
{
    if (sape)
    {
        sape.presets.load();
        sape.presets.prefs = sape.toolbar.prefs();
        sape.presets.prefs.addObserver("", sape.presets.observer, false);
    }
};

//------------------------------------------------------------------------------
// Выбирает пресет
//------------------------------------------------------------------------------
sape.presets.select = function(event)
{
    var st = sape.toolbar, me = sape.presets;
    var el = event.target;

    var pname = el.getAttributeNS('http://www.sape.ru/toolbar.xul', 'name');
    var n = parseInt(pname, 10);

    if (n > me.data.length) return;

    var preset = me.data[n];
    for (var i=0; i < preset[1].length; i++)
    {
        var item = preset[1][i];
        var name  = item[0];
        var value = item[1];

        if (typeof(value) == 'boolean')
        {
           me.prefs.setBoolPref(name, value);
        }
        if (typeof(value) == 'number')
        {
           me.prefs.setIntPref(name, value);
        }
        if (typeof(value) == 'string')
        {
           me.prefs.setCharPref(name, st.unicode.decode(value));
        }
    }
    me.now = n;
    me.refresh();
};

//------------------------------------------------------------------------------
// Удаляет пресет
//------------------------------------------------------------------------------
sape.presets.kill = function(event)
{
    var st = sape.toolbar, me = sape.presets;
    var el = event.target;

    var en = el.getAttributeNS('http://www.sape.ru/toolbar.xul', 'name');
    var n = parseInt(en, 10);

    var name = me.data[n][0];

    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    if (promptService.confirm(null, st.str('menu.presets.title'), st.str('menu.presets.ask') + ' ' + name + '?'))
    {
        if (me.now == n) me.now = -1;
        if (me.now > n)  me.now--;

        me.data.splice(n,1);
        me.save();
    }
};

//------------------------------------------------------------------------------
// Создаёт меню
//------------------------------------------------------------------------------
sape.presets.menu = function()
{
    var st = sape.toolbar, me = sape.presets;
    var popup = document.getElementById('wmsape-button-tools-popup');

    if (!popup) return;

    var boxes = popup.getElementsByTagName('hbox');
    for (var i = boxes.length - 1; i >= 0; i--)
    {
        popup.removeChild(boxes[i]);
    }

    var separator = popup.getElementsByTagName('menuseparator');
    for (var j = separator.length - 1; j >= 0; j--)
    {
        popup.removeChild(separator[j]);
    }

    if (me.data.length) popup.appendChild(document.createElement('menuseparator'));

    for (var idx=0; idx < me.data.length; idx++)
    {
        var setName = me.data[idx][0];

        var hbox = document.createElement('hbox');
            hbox.setAttribute('align', 'center');

        var menuitem = document.createElement('menuitem');
            menuitem.setAttribute('flex', '1');
            menuitem.setAttribute('label', setName);
            menuitem.setAttribute('type', 'checkbox');
            menuitem.setAttribute('checked', (idx == me.now)? 'true' : 'false');
            menuitem.setAttributeNS('http://www.sape.ru/toolbar.xul', 'name', idx);
            menuitem.addEventListener('command', sape.presets.select, false);

        var image = document.createElement('image');
            image.setAttribute('src', 'chrome://wmsape/skin/close.png');
            image.setAttribute('tooltiptext', st.str('menu.presets.kill'));
            image.setAttribute('style', 'cursor:pointer');
            image.setAttributeNS('http://www.sape.ru/toolbar.xul', 'name', idx);
            image.addEventListener('click', sape.presets.kill, false);

        hbox.appendChild(menuitem);
        hbox.appendChild(image);
        popup.appendChild(hbox);
    }
};

//------------------------------------------------------------------------------
// Обновляет меню
//------------------------------------------------------------------------------
sape.presets.refresh = function()
{
    var st = sape.toolbar, me = sape.presets;
    var popup = document.getElementById('wmsape-button-tools-popup');

    if (!popup) return;

    var boxes = popup.getElementsByTagName('hbox');
    for (var i=0; i < boxes.length; i++)
    {
        var menuitem = boxes[i].getElementsByTagName('menuitem');
        if (menuitem.length)
        {
            menuitem[0].setAttribute('checked', (i == me.now)? 'true' : 'false');
        }
    }
};
//------------------------------------------------------------------------------
// Создаёт новый пресет
//------------------------------------------------------------------------------
sape.presets.create = function()
{
    var st = sape.toolbar, me = sape.presets;

    var names = me.prefs.getChildList("", []);
    var values = [];

    for (var i=0; i < names.length; i++)
    {
        var check, value;
        var type = me.prefs.getPrefType(names[i]);

        if (type == me.prefs.PREF_INT)
        {
            check = me.prefs.getIntPref(names[i]);
            value = check;
        }
        if (type == me.prefs.PREF_BOOL)
        {
            check = me.prefs.getBoolPref(names[i]);
            value = check;
        }
        if (type == me.prefs.PREF_STRING)
        {
            check = me.prefs.getCharPref(names[i]);
            value = st.unicode.encode(check);
        }
        values.push([names[i].toString(), value]);
    }
    var setName = '';

    if (me.data.length == 1)                    setName = me.data[0][0];
    if (me.data.length > me.now && me.now > -1) setName = me.data[me.now][0];

    var  promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);

    var chk = {value: false};
    var input = {value: setName};

    if (promptService.prompt(null, st.str('menu.presets.title'), st.str('menu.presets.name'), input, null, chk))
    {
        setName = input.value;
    }
    else return;

    var newPreset = [];
        newPreset[0] = setName.toString();
        newPreset[1] = values;

    var replaced = 0;
    for (var j = 0; j < me.data.length; j++)
    {
        if (me.data[j][0].toString().toLowerCase() == setName.toLowerCase())
        {
            me.data[j] = newPreset;
            me.now = j;
            replaced = 1;
        }
    }
    if (!replaced)
    {
        me.data.push(newPreset);
        me.now = me.data.length - 1;
    }
    me.save();
};

//------------------------------------------------------------------------------
// Сохраняет пресеты в файл
//------------------------------------------------------------------------------
sape.presets.save = function()
{
    var st = sape.toolbar;

    var data = JSON.stringify(sape.presets.data);

    var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
        file.append("wmsape.preset");
    try
    {
        Components.utils['import']("resource://gre/modules/NetUtil.jsm");
        Components.utils['import']("resource://gre/modules/FileUtils.jsm");

    	var ostream = FileUtils.openSafeFileOutputStream(file);
    	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
        	converter.charset = "UTF-8";

    	var istream = converter.convertToInputStream(data);

    	NetUtil.asyncCopy(istream, ostream, function(status)
        {
            if (!Components.isSuccessCode(status)) return;
            sape.presets.menu();
        });
    }
    catch(e) {}
};

//------------------------------------------------------------------------------
// Загружает пресеты из файла
//------------------------------------------------------------------------------
sape.presets.load = function()
{
    var st = sape.toolbar;

    var file = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties).get("ProfD", Components.interfaces.nsIFile);
        file.append("wmsape.preset");

    if (!file.exists()) return;

    var fileStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
        fileStream.init(file, 1, 0, false);
    var inputStream = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
        inputStream.init(fileStream);

    var data = inputStream.read(-1);

    fileStream.close();
    inputStream.close();

    sape.presets.data = JSON.parse(st.unicode.encode(data));
    sape.presets.menu();
};

//------------------------------------------------------------------------------
// Сбрасывает настройки
//------------------------------------------------------------------------------
sape.presets.reset = function()
{
    var st = sape.toolbar, me = sape.presets;

    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    if (!promptService.confirm(null, st.str('options.reset.title'), st.str('options.reset.confirm'))) return;

    var prefs = sape.toolbar.prefs();
    var names = prefs.getChildList("", []);

    for (var i=0; i < names.length; i++)
    {
        try
        {
            prefs.clearUserPref(names[i]);
        }
        catch(ex){}
    }

    var wmsapePreferences = document.getElementById("wmsapePreferences");
    if (wmsapePreferences)
    {
        var preference = wmsapePreferences.getElementsByTagName("preference");
        for (var j=0; j < preference.length; j++)
        {
            preference[j].value = preference[j].defaultValue;
        }
    }
};
